// This code conforms with the UFC specification version 2018.1.0
// and was automatically generated by FFC version 2019.2.0.dev0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
//
// This code was generated with the following parameters:
//

//  add_tabulate_tensor_timing:     False
//  convert_exceptions_to_warnings: False
//  cpp_optimize:                   True
//  cpp_optimize_flags:             '-O2'
//  epsilon:                        1e-14
//  error_control:                  False
//  external_include_dirs:          ''
//  external_includes:              ''
//  external_libraries:             ''
//  external_library_dirs:          ''
//  form_postfix:                   True
//  format:                         'dolfin'
//  generate_dummy_tabulate_tensor: False
//  max_signature_length:           0
//  optimize:                       True
//  precision:                      None
//  quadrature_degree:              None
//  quadrature_rule:                None
//  representation:                 'auto'
//  split:                          False

#ifndef __FORMS_H
#define __FORMS_H
#include <algorithm>
#include <cmath>
#include <iostream>
#include <stdexcept>
#include <ufc.h>

class forms_finite_element_0: public ufc::finite_element
{
public:

  forms_finite_element_0() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Lagrange', triangle, 1)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 3;
  }

  std::size_t value_rank() const final override
  {
    return 0;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t value_size() const final override
  {
    return 1;
  }

  std::size_t reference_value_rank() const final override
  {
    return 0;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t reference_value_size() const final override
  {
    return 1;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910315, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 3; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 2] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 3 * num_derivatives, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.898979485566349, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.4494897427831814, 0.0, 0.0 },
            { 4.242640687119284, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910315, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[3] = {};
    const std::size_t num_components[3] = { 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 3; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[3 * num_derivatives * ip + num_derivatives * i + r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 3 * num_derivatives, 0.0);
    const std::size_t reference_offsets[3] = {};
    const std::size_t physical_offsets[3] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 3; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[3 * num_derivatives * ip + num_derivatives * d + s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[3 * num_derivatives * ip + num_derivatives * d + r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[3];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[3];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 1; ++k)
        values[k] = physical_values[i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold value of a single dof.
    double dof_values = 0.0;
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
        values[r] = dof_values;
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910315, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0 },
                  { 4.242640687119284, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0 },
                  { 4.242640687119284, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0 },
                  { 4.242640687119284, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, num_derivatives * 3, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < num_derivatives; ++s)
            values[num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[6] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 6, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_0();
  }

};


class forms_finite_element_1: public ufc::finite_element
{
public:

  forms_finite_element_1() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 6;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910315, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 6 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 2] += coefficients2[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 3 + 1] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 4 + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 5 + 1] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 6 * num_derivatives * 2, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.898979485566349, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.4494897427831814, 0.0, 0.0 },
            { 4.242640687119284, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910315, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t num_components[6] = { 1, 1, 1, 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 6; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 6 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t physical_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 6; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[12];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[12];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910315, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0 },
                  { 4.242640687119284, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0 },
                  { 4.242640687119284, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0 },
                  { 4.242640687119284, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 3:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910315, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0 },
                  { 4.242640687119284, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 4:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0 },
                  { 4.242640687119284, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 5:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.898979485566349, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.4494897427831814, 0.0, 0.0 },
                  { 4.242640687119284, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 6, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[4] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 3:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 4:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 5:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[3] = vals[1];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[4] = vals[1];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[1];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[3];
    vertex_values[3] = dof_values[4];
    vertex_values[5] = dof_values[5];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
    dof_coordinates[2 * 3] = coordinate_dofs[0];
    dof_coordinates[2 * 3 + 1] = coordinate_dofs[1];
    dof_coordinates[2 * 4] = coordinate_dofs[2];
    dof_coordinates[2 * 4 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 5] = coordinate_dofs[4];
    dof_coordinates[2 * 5 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[12] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 12, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 2;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_0();
    case 1:
        return new forms_finite_element_0();
    default:
        return nullptr;
    }
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_1();
  }

};


class forms_finite_element_2: public ufc::finite_element
{
public:

  forms_finite_element_2() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 15;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 3;
  }

  const char * family() const final override
  {
    return "Nedelec 1st kind H(curl)";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.1695331725611231, 0.08417937871268424, -0.11664236870396073, 0.0, -0.14682003422210355, 0.07290148043997549, -0.10101525445522082 },
          { 0.0, 0.0, 0.0, 0.3216783274236693, -0.13468700594029498, 0.09720197391996735, 0.26057971086461384, -0.1298792610426302, 0.09768798378956726, -0.06313453403451313 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.0782460796435952, -0.16835875742536843, 0.3499271061118822, 0.0, 0.06776309271789391, -0.14580296087995115, 0.3030457633656627 },
          { 0.0, 0.0, 0.0, -0.1651861681364795, 0.2357022603955162, -0.27216552697590873, -0.1202675588605913, 0.14682003422210396, -0.22453655975512488, 0.17677669529663717 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.039123039821797746, -0.08417937871268391, -0.3499271061118825, 0.0, -0.03388154635894701, -0.07290148043997531, -0.30304576336566297 },
          { 0.0, 0.0, 0.0, 0.060858061945018964, 0.0, 0.21384434262392849, 0.06013377943029554, 0.03952847075210454, 0.11226827987756262, -0.13889597487592945 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.16953317256112302, 0.08417937871268405, 0.1166423687039608, 0.0, 0.14682003422210343, 0.07290148043997546, 0.1010152544552209 },
          { 0.0, 0.0, 0.0, 0.4912114999847919, 0.218866384652979, 0.21384434262392807, -0.26057971086461335, 0.016940773179473415, -0.024786503349591735, 0.03788072042070795 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359546, -0.1683587574253681, -0.3499271061118825, 0.0, -0.06776309271789391, -0.1458029608799507, -0.3030457633656628 },
          { 0.0, 0.0, 0.0, -0.24343224778007366, -0.4040610178208842, -0.6220926330877908, 0.12026755886059082, 0.07905694150420939, 0.07873359887517382, -0.12626906806902674 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.0391230398217977, -0.0841793787126841, 0.3499271061118823, 0.0, 0.03388154635894686, -0.0729014804399756, 0.30304576336566275 },
          { 0.0, 0.0, 0.0, 0.09998110176681545, -0.0841793787126838, 0.5637714487358108, -0.06013377943029568, 0.07341001711105209, -0.1851697603175381, 0.16414978848973458 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868717, 0.30304576336566347, 0.3110463165438958, 0.0, -0.09035079029052534, -0.14580296087995076, -0.20203050891044222 },
          { 0.0, 0.0, 0.0, 0.1695331725611227, 0.08417937871268406, 0.11664236870396116, 0.16035674514745452, 0.06776309271789378, 0.03207665139358956, -0.0757614408414162 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.1555231582719478, 0.0, 0.18070158058105049, 0.0, 0.10101525445522119 },
          { 0.0, 0.0, 0.0, -0.3825363893686875, 0.06734350297014775, -0.07776157913597391, -0.3207134902949091, 0.09035079029052541, -0.06415330278717875, 0.050507627227610694 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868745, -0.30304576336566336, 0.3110463165438961, 0.0, -0.09035079029052527, 0.14580296087995118, -0.202030508910442 },
          { 0.0, 0.0, 0.0, 0.21300321680756526, -0.21886638465297936, 0.19440394783993478, 0.1603567451474548, -0.1581138830084195, 0.17787961227354057, -0.1262690680690266 } };
    static const double coefficients9[2][10] =
        { { 3.9999999999999996, 0.0, 0.0, -0.3688555567816591, -0.4761904761904764, -1.6495721976846462, 0.0, -0.3194382824999702, -0.4123930494211611, 0.5714285714285701 },
          { 0.0, 0.0, 0.0, 0.6147592613027629, 0.4761904761904762, -0.5498573992282136, 0.5669467095138394, 0.15971914124998607, -0.45363235436327753, 0.35714285714285776 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.9999999999999982, 0.0, -0.6776309271789392, 1.8079567149113942, 0.0, 0.0, -0.5868455973269646, -1.2626906806902622, 0.0 },
          { 0.0, 0.0, 0.0, 1.0540925533894554, 1.1664236870396087, -0.336717514850735, 1.0415476122441178, 0.6846531968814594, -0.5808377131175204, 0.21870444131992606 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.9999999999999996, 0.1304101327393251, -0.8417937871268396, 0.933138949631687, 0.0, 0.1129384878631563, -0.729014804399754, -2.020305089104421 },
          { 0.0, 0.0, 0.0, -0.3477603539715316, 0.3367175148507375, 1.360827634879545, -0.2004459314343183, 0.6211616832473605, 0.5977921396078008, -0.8838834764831882 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809498, 0.0, 0.0, 0.0, 0.824786098842322, 0.0 },
          { 4.000000000000001, 0.0, 0.0, -1.5983740793871868, 0.47619047619047467, -0.5498573992282165, 0.0, -0.638876564999942, 0.41239304942116145, -0.14285714285714235 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578776, 0.0, 0.0, 0.0, 1.1736911946539275, 0.0, 0.0 },
          { 0.0, 3.9999999999999956, 0.0, 0.6776309271789396, -0.5248906591678226, 0.0, -2.0830952244882375, 0.5868455973269633, -0.1010152544552205, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536814, 0.0, 0.0, 0.0, 1.4580296087995093, 0.0 },
          { 0.0, 0.0, 3.999999999999999, 0.8259308406823958, 0.8417937871268397, -1.7885163201274012, 0.0, -1.129384878631567, 0.7290148043997553, -0.25253813613805165 } };
    for (std::size_t k = 0; k < num_points * 15 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + c] += coefficients0[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 + c] += coefficients1[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 2 + c] += coefficients2[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 3 + c] += coefficients3[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 4 + c] += coefficients4[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 5 + c] += coefficients5[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 6 + c] += coefficients6[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 7 + c] += coefficients7[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 8 + c] += coefficients8[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 9 + c] += coefficients9[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 10 + c] += coefficients10[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 11 + c] += coefficients11[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 12 + c] += coefficients12[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 13 + c] += coefficients13[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 14 + c] += coefficients14[c][r] * basisvalues3[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 15 * num_derivatives * 2, 0.0);
    if (order > 3)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][10][10] =
        { { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.9999999999999947, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 5.291502622129196, 0.0, -2.993325909419161, 13.662601021279459, 0.0, 0.611010092660782, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 4.381780460041332, 0.0, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.4641016151377593, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.5819888974716214, 4.743416490252572, -0.9128709291752781, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 1.9999999999999152, 6.123724356957938, 3.535533905932736, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { -2.3094010767584914, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.645751311064573, 5.184592558726257, -1.4966629547095658, 6.831300510639725, -1.0583005244258317, 0.3055050463303888, 0.0, 0.0, 0.0, 0.0 },
            { 2.236067977499826, 2.190890230020676, 2.5298221281346827, 8.082903768654774, 6.2609903369994075, -1.807392228230124, 0.0, 0.0, 0.0, 0.0 },
            { 1.7320508075688812, -5.091168824543141, 3.919183588453098, 0.0, 9.699484522385688, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
            { 5.000000000000027, 0.0, -2.8284271247462343, 0.0, 0.0, 12.124355652982159, 0.0, 0.0, 0.0, 0.0 } } };
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.1695331725611231, 0.08417937871268424, -0.11664236870396073, 0.0, -0.14682003422210355, 0.07290148043997549, -0.10101525445522082 },
          { 0.0, 0.0, 0.0, 0.3216783274236693, -0.13468700594029498, 0.09720197391996735, 0.26057971086461384, -0.1298792610426302, 0.09768798378956726, -0.06313453403451313 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.0782460796435952, -0.16835875742536843, 0.3499271061118822, 0.0, 0.06776309271789391, -0.14580296087995115, 0.3030457633656627 },
          { 0.0, 0.0, 0.0, -0.1651861681364795, 0.2357022603955162, -0.27216552697590873, -0.1202675588605913, 0.14682003422210396, -0.22453655975512488, 0.17677669529663717 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.039123039821797746, -0.08417937871268391, -0.3499271061118825, 0.0, -0.03388154635894701, -0.07290148043997531, -0.30304576336566297 },
          { 0.0, 0.0, 0.0, 0.060858061945018964, 0.0, 0.21384434262392849, 0.06013377943029554, 0.03952847075210454, 0.11226827987756262, -0.13889597487592945 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.16953317256112302, 0.08417937871268405, 0.1166423687039608, 0.0, 0.14682003422210343, 0.07290148043997546, 0.1010152544552209 },
          { 0.0, 0.0, 0.0, 0.4912114999847919, 0.218866384652979, 0.21384434262392807, -0.26057971086461335, 0.016940773179473415, -0.024786503349591735, 0.03788072042070795 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359546, -0.1683587574253681, -0.3499271061118825, 0.0, -0.06776309271789391, -0.1458029608799507, -0.3030457633656628 },
          { 0.0, 0.0, 0.0, -0.24343224778007366, -0.4040610178208842, -0.6220926330877908, 0.12026755886059082, 0.07905694150420939, 0.07873359887517382, -0.12626906806902674 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.0391230398217977, -0.0841793787126841, 0.3499271061118823, 0.0, 0.03388154635894686, -0.0729014804399756, 0.30304576336566275 },
          { 0.0, 0.0, 0.0, 0.09998110176681545, -0.0841793787126838, 0.5637714487358108, -0.06013377943029568, 0.07341001711105209, -0.1851697603175381, 0.16414978848973458 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868717, 0.30304576336566347, 0.3110463165438958, 0.0, -0.09035079029052534, -0.14580296087995076, -0.20203050891044222 },
          { 0.0, 0.0, 0.0, 0.1695331725611227, 0.08417937871268406, 0.11664236870396116, 0.16035674514745452, 0.06776309271789378, 0.03207665139358956, -0.0757614408414162 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.1555231582719478, 0.0, 0.18070158058105049, 0.0, 0.10101525445522119 },
          { 0.0, 0.0, 0.0, -0.3825363893686875, 0.06734350297014775, -0.07776157913597391, -0.3207134902949091, 0.09035079029052541, -0.06415330278717875, 0.050507627227610694 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868745, -0.30304576336566336, 0.3110463165438961, 0.0, -0.09035079029052527, 0.14580296087995118, -0.202030508910442 },
          { 0.0, 0.0, 0.0, 0.21300321680756526, -0.21886638465297936, 0.19440394783993478, 0.1603567451474548, -0.1581138830084195, 0.17787961227354057, -0.1262690680690266 } };
    static const double coefficients9[2][10] =
        { { 3.9999999999999996, 0.0, 0.0, -0.3688555567816591, -0.4761904761904764, -1.6495721976846462, 0.0, -0.3194382824999702, -0.4123930494211611, 0.5714285714285701 },
          { 0.0, 0.0, 0.0, 0.6147592613027629, 0.4761904761904762, -0.5498573992282136, 0.5669467095138394, 0.15971914124998607, -0.45363235436327753, 0.35714285714285776 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.9999999999999982, 0.0, -0.6776309271789392, 1.8079567149113942, 0.0, 0.0, -0.5868455973269646, -1.2626906806902622, 0.0 },
          { 0.0, 0.0, 0.0, 1.0540925533894554, 1.1664236870396087, -0.336717514850735, 1.0415476122441178, 0.6846531968814594, -0.5808377131175204, 0.21870444131992606 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.9999999999999996, 0.1304101327393251, -0.8417937871268396, 0.933138949631687, 0.0, 0.1129384878631563, -0.729014804399754, -2.020305089104421 },
          { 0.0, 0.0, 0.0, -0.3477603539715316, 0.3367175148507375, 1.360827634879545, -0.2004459314343183, 0.6211616832473605, 0.5977921396078008, -0.8838834764831882 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809498, 0.0, 0.0, 0.0, 0.824786098842322, 0.0 },
          { 4.000000000000001, 0.0, 0.0, -1.5983740793871868, 0.47619047619047467, -0.5498573992282165, 0.0, -0.638876564999942, 0.41239304942116145, -0.14285714285714235 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578776, 0.0, 0.0, 0.0, 1.1736911946539275, 0.0, 0.0 },
          { 0.0, 3.9999999999999956, 0.0, 0.6776309271789396, -0.5248906591678226, 0.0, -2.0830952244882375, 0.5868455973269633, -0.1010152544552205, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536814, 0.0, 0.0, 0.0, 1.4580296087995093, 0.0 },
          { 0.0, 0.0, 3.999999999999999, 0.8259308406823958, 0.8417937871268397, -1.7885163201274012, 0.0, -1.129384878631567, 0.7290148043997553, -0.25253813613805165 } };
    const std::size_t reference_offset[15] = {};
    const std::size_t num_components[15] = { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2 };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 15; ++i)
        {
            double derivatives[16] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients0[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients0[1][s] * aux[s];
                    }
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients1[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients1[1][s] * aux[s];
                    }
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients2[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients2[1][s] * aux[s];
                    }
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients3[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients3[1][s] * aux[s];
                    }
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients4[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients4[1][s] * aux[s];
                    }
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients5[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients5[1][s] * aux[s];
                    }
                }
                break;
            case 6:
                // Compute reference derivatives for dof 6.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients6[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients6[1][s] * aux[s];
                    }
                }
                break;
            case 7:
                // Compute reference derivatives for dof 7.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients7[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients7[1][s] * aux[s];
                    }
                }
                break;
            case 8:
                // Compute reference derivatives for dof 8.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients8[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients8[1][s] * aux[s];
                    }
                }
                break;
            case 9:
                // Compute reference derivatives for dof 9.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients9[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients9[1][s] * aux[s];
                    }
                }
                break;
            case 10:
                // Compute reference derivatives for dof 10.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients10[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients10[1][s] * aux[s];
                    }
                }
                break;
            case 11:
                // Compute reference derivatives for dof 11.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients11[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients11[1][s] * aux[s];
                    }
                }
                break;
            case 12:
                // Compute reference derivatives for dof 12.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients12[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients12[1][s] * aux[s];
                    }
                }
                break;
            case 13:
                // Compute reference derivatives for dof 13.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients13[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients13[1][s] * aux[s];
                    }
                }
                break;
            case 14:
                // Compute reference derivatives for dof 14.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients14[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients14[1][s] * aux[s];
                    }
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    std::fill_n(values, num_points * 15 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[15] = {};
    const std::size_t physical_offsets[15] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[8][8];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 15; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 2; ++i)
                {
                    // Using covariant Piola transform to map values back to the physical element.
                    const double mapped_value = K[2 * 2 * ip + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]] + K[2 * 2 * ip + 2 + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + (reference_offsets[d] + 1)];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[30];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[30];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    // Declare transformation matrix
    double transform[8][8] =
        { { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.1695331725611231, 0.08417937871268424, -0.11664236870396073, 0.0, -0.14682003422210355, 0.07290148043997549, -0.10101525445522082 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.3216783274236693, -0.13468700594029498, 0.09720197391996735, 0.26057971086461384, -0.1298792610426302, 0.09768798378956726, -0.06313453403451313 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999947, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, -3.907985046680551e-14, -2.993325909419161, 13.662601021279459, 0.0, 0.611010092660782, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041332, 1.0658141036401503e-14, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377593, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716214, 4.743416490252572, -0.9128709291752781, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999152, 6.123724356957938, 3.535533905932736, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726257, -1.4966629547095658, 6.831300510639725, -1.0583005244258317, 0.3055050463303888, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499826, 2.190890230020676, 2.5298221281346827, 8.082903768654774, 6.2609903369994075, -1.807392228230124, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688812, -5.091168824543141, 3.919183588453098, 0.0, 9.699484522385688, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000027, 0.0, -2.8284271247462343, 0.0, 0.0, 12.124355652982159, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 1:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0782460796435952, -0.16835875742536843, 0.3499271061118822, 0.0, 0.06776309271789391, -0.14580296087995115, 0.3030457633656627 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.1651861681364795, 0.2357022603955162, -0.27216552697590873, -0.1202675588605913, 0.14682003422210396, -0.22453655975512488, 0.17677669529663717 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999947, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, -3.907985046680551e-14, -2.993325909419161, 13.662601021279459, 0.0, 0.611010092660782, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041332, 1.0658141036401503e-14, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377593, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716214, 4.743416490252572, -0.9128709291752781, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999152, 6.123724356957938, 3.535533905932736, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726257, -1.4966629547095658, 6.831300510639725, -1.0583005244258317, 0.3055050463303888, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499826, 2.190890230020676, 2.5298221281346827, 8.082903768654774, 6.2609903369994075, -1.807392228230124, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688812, -5.091168824543141, 3.919183588453098, 0.0, 9.699484522385688, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000027, 0.0, -2.8284271247462343, 0.0, 0.0, 12.124355652982159, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 2:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.039123039821797746, -0.08417937871268391, -0.3499271061118825, 0.0, -0.03388154635894701, -0.07290148043997531, -0.30304576336566297 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.060858061945018964, 0.0, 0.21384434262392849, 0.06013377943029554, 0.03952847075210454, 0.11226827987756262, -0.13889597487592945 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999947, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, -3.907985046680551e-14, -2.993325909419161, 13.662601021279459, 0.0, 0.611010092660782, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041332, 1.0658141036401503e-14, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377593, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716214, 4.743416490252572, -0.9128709291752781, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999152, 6.123724356957938, 3.535533905932736, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726257, -1.4966629547095658, 6.831300510639725, -1.0583005244258317, 0.3055050463303888, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499826, 2.190890230020676, 2.5298221281346827, 8.082903768654774, 6.2609903369994075, -1.807392228230124, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688812, -5.091168824543141, 3.919183588453098, 0.0, 9.699484522385688, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000027, 0.0, -2.8284271247462343, 0.0, 0.0, 12.124355652982159, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 3:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.16953317256112302, 0.08417937871268405, 0.1166423687039608, 0.0, 0.14682003422210343, 0.07290148043997546, 0.1010152544552209 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.4912114999847919, 0.218866384652979, 0.21384434262392807, -0.26057971086461335, 0.016940773179473415, -0.024786503349591735, 0.03788072042070795 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999947, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, -3.907985046680551e-14, -2.993325909419161, 13.662601021279459, 0.0, 0.611010092660782, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041332, 1.0658141036401503e-14, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377593, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716214, 4.743416490252572, -0.9128709291752781, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999152, 6.123724356957938, 3.535533905932736, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726257, -1.4966629547095658, 6.831300510639725, -1.0583005244258317, 0.3055050463303888, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499826, 2.190890230020676, 2.5298221281346827, 8.082903768654774, 6.2609903369994075, -1.807392228230124, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688812, -5.091168824543141, 3.919183588453098, 0.0, 9.699484522385688, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000027, 0.0, -2.8284271247462343, 0.0, 0.0, 12.124355652982159, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 4:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.07824607964359546, -0.1683587574253681, -0.3499271061118825, 0.0, -0.06776309271789391, -0.1458029608799507, -0.3030457633656628 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.24343224778007366, -0.4040610178208842, -0.6220926330877908, 0.12026755886059082, 0.07905694150420939, 0.07873359887517382, -0.12626906806902674 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999947, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, -3.907985046680551e-14, -2.993325909419161, 13.662601021279459, 0.0, 0.611010092660782, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041332, 1.0658141036401503e-14, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377593, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716214, 4.743416490252572, -0.9128709291752781, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999152, 6.123724356957938, 3.535533905932736, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726257, -1.4966629547095658, 6.831300510639725, -1.0583005244258317, 0.3055050463303888, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499826, 2.190890230020676, 2.5298221281346827, 8.082903768654774, 6.2609903369994075, -1.807392228230124, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688812, -5.091168824543141, 3.919183588453098, 0.0, 9.699484522385688, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000027, 0.0, -2.8284271247462343, 0.0, 0.0, 12.124355652982159, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 5:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0391230398217977, -0.0841793787126841, 0.3499271061118823, 0.0, 0.03388154635894686, -0.0729014804399756, 0.30304576336566275 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.09998110176681545, -0.0841793787126838, 0.5637714487358108, -0.06013377943029568, 0.07341001711105209, -0.1851697603175381, 0.16414978848973458 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999947, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, -3.907985046680551e-14, -2.993325909419161, 13.662601021279459, 0.0, 0.611010092660782, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041332, 1.0658141036401503e-14, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377593, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716214, 4.743416490252572, -0.9128709291752781, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999152, 6.123724356957938, 3.535533905932736, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726257, -1.4966629547095658, 6.831300510639725, -1.0583005244258317, 0.3055050463303888, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499826, 2.190890230020676, 2.5298221281346827, 8.082903768654774, 6.2609903369994075, -1.807392228230124, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688812, -5.091168824543141, 3.919183588453098, 0.0, 9.699484522385688, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000027, 0.0, -2.8284271247462343, 0.0, 0.0, 12.124355652982159, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 6:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.38253638936868717, 0.30304576336566347, 0.3110463165438958, 0.0, -0.09035079029052534, -0.14580296087995076, -0.20203050891044222 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.1695331725611227, 0.08417937871268406, 0.11664236870396116, 0.16035674514745452, 0.06776309271789378, 0.03207665139358956, -0.0757614408414162 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999947, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, -3.907985046680551e-14, -2.993325909419161, 13.662601021279459, 0.0, 0.611010092660782, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041332, 1.0658141036401503e-14, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377593, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716214, 4.743416490252572, -0.9128709291752781, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999152, 6.123724356957938, 3.535533905932736, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726257, -1.4966629547095658, 6.831300510639725, -1.0583005244258317, 0.3055050463303888, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499826, 2.190890230020676, 2.5298221281346827, 8.082903768654774, 6.2609903369994075, -1.807392228230124, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688812, -5.091168824543141, 3.919183588453098, 0.0, 9.699484522385688, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000027, 0.0, -2.8284271247462343, 0.0, 0.0, 12.124355652982159, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 7:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.1555231582719478, 0.0, 0.18070158058105049, 0.0, 0.10101525445522119 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.3825363893686875, 0.06734350297014775, -0.07776157913597391, -0.3207134902949091, 0.09035079029052541, -0.06415330278717875, 0.050507627227610694 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999947, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, -3.907985046680551e-14, -2.993325909419161, 13.662601021279459, 0.0, 0.611010092660782, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041332, 1.0658141036401503e-14, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377593, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716214, 4.743416490252572, -0.9128709291752781, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999152, 6.123724356957938, 3.535533905932736, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726257, -1.4966629547095658, 6.831300510639725, -1.0583005244258317, 0.3055050463303888, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499826, 2.190890230020676, 2.5298221281346827, 8.082903768654774, 6.2609903369994075, -1.807392228230124, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688812, -5.091168824543141, 3.919183588453098, 0.0, 9.699484522385688, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000027, 0.0, -2.8284271247462343, 0.0, 0.0, 12.124355652982159, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 8:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.38253638936868745, -0.30304576336566336, 0.3110463165438961, 0.0, -0.09035079029052527, 0.14580296087995118, -0.202030508910442 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.21300321680756526, -0.21886638465297936, 0.19440394783993478, 0.1603567451474548, -0.1581138830084195, 0.17787961227354057, -0.1262690680690266 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999947, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, -3.907985046680551e-14, -2.993325909419161, 13.662601021279459, 0.0, 0.611010092660782, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041332, 1.0658141036401503e-14, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377593, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716214, 4.743416490252572, -0.9128709291752781, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999152, 6.123724356957938, 3.535533905932736, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726257, -1.4966629547095658, 6.831300510639725, -1.0583005244258317, 0.3055050463303888, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499826, 2.190890230020676, 2.5298221281346827, 8.082903768654774, 6.2609903369994075, -1.807392228230124, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688812, -5.091168824543141, 3.919183588453098, 0.0, 9.699484522385688, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000027, 0.0, -2.8284271247462343, 0.0, 0.0, 12.124355652982159, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 9:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 3.9999999999999996, 0.0, 0.0, -0.3688555567816591, -0.4761904761904764, -1.6495721976846462, 0.0, -0.3194382824999702, -0.4123930494211611, 0.5714285714285701 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.6147592613027629, 0.4761904761904762, -0.5498573992282136, 0.5669467095138394, 0.15971914124998607, -0.45363235436327753, 0.35714285714285776 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999947, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, -3.907985046680551e-14, -2.993325909419161, 13.662601021279459, 0.0, 0.611010092660782, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041332, 1.0658141036401503e-14, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377593, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716214, 4.743416490252572, -0.9128709291752781, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999152, 6.123724356957938, 3.535533905932736, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726257, -1.4966629547095658, 6.831300510639725, -1.0583005244258317, 0.3055050463303888, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499826, 2.190890230020676, 2.5298221281346827, 8.082903768654774, 6.2609903369994075, -1.807392228230124, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688812, -5.091168824543141, 3.919183588453098, 0.0, 9.699484522385688, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000027, 0.0, -2.8284271247462343, 0.0, 0.0, 12.124355652982159, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 10:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 3.9999999999999982, 0.0, -0.6776309271789392, 1.8079567149113942, 0.0, 0.0, -0.5868455973269646, -1.2626906806902622, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 1.0540925533894554, 1.1664236870396087, -0.336717514850735, 1.0415476122441178, 0.6846531968814594, -0.5808377131175204, 0.21870444131992606 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999947, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, -3.907985046680551e-14, -2.993325909419161, 13.662601021279459, 0.0, 0.611010092660782, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041332, 1.0658141036401503e-14, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377593, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716214, 4.743416490252572, -0.9128709291752781, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999152, 6.123724356957938, 3.535533905932736, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726257, -1.4966629547095658, 6.831300510639725, -1.0583005244258317, 0.3055050463303888, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499826, 2.190890230020676, 2.5298221281346827, 8.082903768654774, 6.2609903369994075, -1.807392228230124, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688812, -5.091168824543141, 3.919183588453098, 0.0, 9.699484522385688, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000027, 0.0, -2.8284271247462343, 0.0, 0.0, 12.124355652982159, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 11:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 3.9999999999999996, 0.1304101327393251, -0.8417937871268396, 0.933138949631687, 0.0, 0.1129384878631563, -0.729014804399754, -2.020305089104421 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.3477603539715316, 0.3367175148507375, 1.360827634879545, -0.2004459314343183, 0.6211616832473605, 0.5977921396078008, -0.8838834764831882 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999947, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, -3.907985046680551e-14, -2.993325909419161, 13.662601021279459, 0.0, 0.611010092660782, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041332, 1.0658141036401503e-14, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377593, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716214, 4.743416490252572, -0.9128709291752781, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999152, 6.123724356957938, 3.535533905932736, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726257, -1.4966629547095658, 6.831300510639725, -1.0583005244258317, 0.3055050463303888, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499826, 2.190890230020676, 2.5298221281346827, 8.082903768654774, 6.2609903369994075, -1.807392228230124, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688812, -5.091168824543141, 3.919183588453098, 0.0, 9.699484522385688, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000027, 0.0, -2.8284271247462343, 0.0, 0.0, 12.124355652982159, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 12:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 0.9523809523809498, 0.0, 0.0, 0.0, 0.824786098842322, 0.0 };
            static const double coefficients1[10] = { 4.000000000000001, 0.0, 0.0, -1.5983740793871868, 0.47619047619047467, -0.5498573992282165, 0.0, -0.638876564999942, 0.41239304942116145, -0.14285714285714235 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999947, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, -3.907985046680551e-14, -2.993325909419161, 13.662601021279459, 0.0, 0.611010092660782, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041332, 1.0658141036401503e-14, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377593, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716214, 4.743416490252572, -0.9128709291752781, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999152, 6.123724356957938, 3.535533905932736, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726257, -1.4966629547095658, 6.831300510639725, -1.0583005244258317, 0.3055050463303888, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499826, 2.190890230020676, 2.5298221281346827, 8.082903768654774, 6.2609903369994075, -1.807392228230124, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688812, -5.091168824543141, 3.919183588453098, 0.0, 9.699484522385688, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000027, 0.0, -2.8284271247462343, 0.0, 0.0, 12.124355652982159, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 13:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 1.3552618543578776, 0.0, 0.0, 0.0, 1.1736911946539275, 0.0, 0.0 };
            static const double coefficients1[10] = { 0.0, 3.9999999999999956, 0.0, 0.6776309271789396, -0.5248906591678226, 0.0, -2.0830952244882375, 0.5868455973269633, -0.1010152544552205, 0.0 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999947, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, -3.907985046680551e-14, -2.993325909419161, 13.662601021279459, 0.0, 0.611010092660782, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041332, 1.0658141036401503e-14, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377593, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716214, 4.743416490252572, -0.9128709291752781, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999152, 6.123724356957938, 3.535533905932736, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726257, -1.4966629547095658, 6.831300510639725, -1.0583005244258317, 0.3055050463303888, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499826, 2.190890230020676, 2.5298221281346827, 8.082903768654774, 6.2609903369994075, -1.807392228230124, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688812, -5.091168824543141, 3.919183588453098, 0.0, 9.699484522385688, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000027, 0.0, -2.8284271247462343, 0.0, 0.0, 12.124355652982159, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 14:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 1.6835875742536814, 0.0, 0.0, 0.0, 1.4580296087995093, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 3.999999999999999, 0.8259308406823958, 0.8417937871268397, -1.7885163201274012, 0.0, -1.129384878631567, 0.7290148043997553, -0.25253813613805165 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.89897948556635, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999947, 0.0, 7.07106781186547, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, -3.907985046680551e-14, -2.993325909419161, 13.662601021279459, 0.0, 0.611010092660782, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041332, 1.0658141036401503e-14, 0.0, 12.521980673998822, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377593, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000004, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831823, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716214, 4.743416490252572, -0.9128709291752781, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999152, 6.123724356957938, 3.535533905932736, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064573, 5.184592558726257, -1.4966629547095658, 6.831300510639725, -1.0583005244258317, 0.3055050463303888, 0.0, 0.0, 0.0, 0.0 },
                  { 2.236067977499826, 2.190890230020676, 2.5298221281346827, 8.082903768654774, 6.2609903369994075, -1.807392228230124, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688812, -5.091168824543141, 3.919183588453098, 0.0, 9.699484522385688, 4.200000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000027, 0.0, -2.8284271247462343, 0.0, 0.0, 12.124355652982159, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 15, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[16] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    switch (i)
    {
    case 0:
        {
            y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 1:
        {
            y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 2:
        {
            y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 3:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 4:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 5:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 6:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 7:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 8:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 9:
        {
            result = 0.0;
            double X_9[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_9[36][1] = {};
            double W_9[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_9[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_9[r][0] - X_9[r][1];
                const double w1 = X_9[r][0];
                const double w2 = X_9[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_9[D_9[r][s]] * W_9[r][s];
            }
            return result;
        }
        break;
    case 10:
        {
            result = 0.0;
            double X_10[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_10[36][1] = {};
            double W_10[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_10[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_10[r][0] - X_10[r][1];
                const double w1 = X_10[r][0];
                const double w2 = X_10[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_10[D_10[r][s]] * W_10[r][s];
            }
            return result;
        }
        break;
    case 11:
        {
            result = 0.0;
            double X_11[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_11[36][1] = {};
            double W_11[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_11[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_11[r][0] - X_11[r][1];
                const double w1 = X_11[r][0];
                const double w2 = X_11[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_11[D_11[r][s]] * W_11[r][s];
            }
            return result;
        }
        break;
    case 12:
        {
            result = 0.0;
            double X_12[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_12[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_12[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_12[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_12[r][0] - X_12[r][1];
                const double w1 = X_12[r][0];
                const double w2 = X_12[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_12[D_12[r][s]] * W_12[r][s];
            }
            return result;
        }
        break;
    case 13:
        {
            result = 0.0;
            double X_13[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_13[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_13[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_13[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_13[r][0] - X_13[r][1];
                const double w1 = X_13[r][0];
                const double w2 = X_13[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_13[D_13[r][s]] * W_13[r][s];
            }
            return result;
        }
        break;
    case 14:
        {
            result = 0.0;
            double X_14[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_14[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_14[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_14[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_14[r][0] - X_14[r][1];
                const double w1 = X_14[r][0];
                const double w2 = X_14[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_14[D_14[r][s]] * W_14[r][s];
            }
            return result;
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[0] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[3] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[4] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[6] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[7] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[8] = vals[0] * J[0] + vals[1] * J[2];
    result = 0.0;
    double X_9[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_9[36][1] = {};
    double W_9[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_9[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_9[r][0] - X_9[r][1];
        const double w1 = X_9[r][0];
        const double w2 = X_9[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_9[D_9[r][s]] * W_9[r][s];
    }
    values[9] = result;
    result = 0.0;
    double X_10[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_10[36][1] = {};
    double W_10[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_10[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_10[r][0] - X_10[r][1];
        const double w1 = X_10[r][0];
        const double w2 = X_10[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_10[D_10[r][s]] * W_10[r][s];
    }
    values[10] = result;
    result = 0.0;
    double X_11[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_11[36][1] = {};
    double W_11[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_11[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_11[r][0] - X_11[r][1];
        const double w1 = X_11[r][0];
        const double w2 = X_11[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_11[D_11[r][s]] * W_11[r][s];
    }
    values[11] = result;
    result = 0.0;
    double X_12[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_12[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_12[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_12[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_12[r][0] - X_12[r][1];
        const double w1 = X_12[r][0];
        const double w2 = X_12[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_12[D_12[r][s]] * W_12[r][s];
    }
    values[12] = result;
    result = 0.0;
    double X_13[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_13[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_13[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_13[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_13[r][0] - X_13[r][1];
        const double w1 = X_13[r][0];
        const double w2 = X_13[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_13[D_13[r][s]] * W_13[r][s];
    }
    values[13] = result;
    result = 0.0;
    double X_14[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_14[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_14[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_14[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_14[r][0] - X_14[r][1];
        const double w1 = X_14[r][0];
        const double w2 = X_14[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_14[D_14[r][s]] * W_14[r][s];
    }
    values[14] = result;
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Evaluate function and change variables
    vertex_values[0] = dof_values[3] * (K[2] * 2.999999999999999) + dof_values[4] * (K[2] * -2.999999999999998) + dof_values[5] * K[2] + dof_values[6] * (K[0] * 3.0) + dof_values[7] * (K[0] * -2.9999999999999996) + dof_values[8] * K[0];
    vertex_values[2] = dof_values[0] * (K[2] * 3.000000000000002) + dof_values[1] * (K[2] * -3.0000000000000067) + dof_values[2] * K[2] + dof_values[6] * (K[0] + K[2]) + dof_values[7] * (K[0] * -3.0 + K[2] * -3.000000000000001) + dof_values[8] * (K[0] * 3.0000000000000004 + K[2] * 3.0000000000000053);
    vertex_values[4] = dof_values[0] * -K[0] + dof_values[1] * (K[0] * 2.9999999999999956) + dof_values[2] * (K[0] * -2.9999999999999982) + dof_values[3] * (K[0] + K[2]) + dof_values[4] * (K[0] * -2.9999999999999973 + K[2] * -3.0) + dof_values[5] * (K[0] * 2.9999999999999964 + K[2] * 3.0000000000000018);
    vertex_values[1] = dof_values[3] * (K[2 + 1] * 2.999999999999999) + dof_values[4] * (K[2 + 1] * -2.999999999999998) + dof_values[5] * K[2 + 1] + dof_values[6] * (K[1] * 3.0) + dof_values[7] * (K[1] * -2.9999999999999996) + dof_values[8] * K[1];
    vertex_values[3] = dof_values[0] * (K[2 + 1] * 3.000000000000002) + dof_values[1] * (K[2 + 1] * -3.0000000000000067) + dof_values[2] * K[2 + 1] + dof_values[6] * (K[1] + K[2 + 1]) + dof_values[7] * (K[1] * -3.0 + K[2 + 1] * -3.000000000000001) + dof_values[8] * (K[1] * 3.0000000000000004 + K[2 + 1] * 3.0000000000000053);
    vertex_values[5] = dof_values[0] * -K[1] + dof_values[1] * (K[1] * 2.9999999999999956) + dof_values[2] * (K[1] * -2.9999999999999982) + dof_values[3] * (K[1] + K[2 + 1]) + dof_values[4] * (K[1] * -2.9999999999999973 + K[2 + 1] * -3.0) + dof_values[5] * (K[1] * 2.9999999999999964 + K[2 + 1] * 3.0000000000000018);
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    throw std::runtime_error("tabulate_dof_coordinates is not defined for this element");
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    throw std::runtime_error("tabulate_reference_dof_coordinates is not defined for this element");
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_2();
  }

};


class forms_dofmap_0: public ufc::dofmap
{
public:

  forms_dofmap_0() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 1)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 3;
  }

  std::size_t num_element_dofs() const final override
  {
    return 3;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 2;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 2, 3 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_0();
  }

};


class forms_dofmap_1: public ufc::dofmap
{
public:

  forms_dofmap_1() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 2 * num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 6;
  }

  std::size_t num_element_dofs() const final override
  {
    return 6;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 4;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 4, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + entity_indices[0][0];
    dofs[4] = offset + entity_indices[0][1];
    dofs[5] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 5;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            dofs[2] = 4;
            dofs[3] = 5;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            dofs[2] = 3;
            dofs[3] = 5;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 3;
            dofs[3] = 4;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 2;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_0();
    case 1:
        return new forms_dofmap_0();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_1();
  }

};


class forms_dofmap_2: public ufc::dofmap
{
public:

  forms_dofmap_2() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { false, true, true };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 3 * num_global_entities[1] + 6 * num_global_entities[2];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 15;
  }

  std::size_t num_element_dofs() const final override
  {
    return 15;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 3;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 15 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + 3 * entity_indices[1][0];
    dofs[1] = offset + 3 * entity_indices[1][0] + 1;
    dofs[2] = offset + 3 * entity_indices[1][0] + 2;
    dofs[3] = offset + 3 * entity_indices[1][1];
    dofs[4] = offset + 3 * entity_indices[1][1] + 1;
    dofs[5] = offset + 3 * entity_indices[1][1] + 2;
    dofs[6] = offset + 3 * entity_indices[1][2];
    dofs[7] = offset + 3 * entity_indices[1][2] + 1;
    dofs[8] = offset + 3 * entity_indices[1][2] + 2;
    offset += 3 * num_global_entities[1];
    dofs[9] = offset + 6 * entity_indices[2][0];
    dofs[10] = offset + 6 * entity_indices[2][0] + 1;
    dofs[11] = offset + 6 * entity_indices[2][0] + 2;
    dofs[12] = offset + 6 * entity_indices[2][0] + 3;
    dofs[13] = offset + 6 * entity_indices[2][0] + 4;
    dofs[14] = offset + 6 * entity_indices[2][0] + 5;
    offset += 6 * num_global_entities[2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
        break;
    case 1:
        dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
        break;
    case 2:
        dofs[0] = 6;
        dofs[1] = 7;
        dofs[2] = 8;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 9;
            dofs[1] = 10;
            dofs[2] = 11;
            dofs[3] = 12;
            dofs[4] = 13;
            dofs[5] = 14;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            break;
        case 1:
            break;
        case 2:
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            dofs[6] = 6;
            dofs[7] = 7;
            dofs[8] = 8;
            dofs[9] = 9;
            dofs[10] = 10;
            dofs[11] = 11;
            dofs[12] = 12;
            dofs[13] = 13;
            dofs[14] = 14;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_2();
  }

};


class forms_coordinate_mapping_1: public ufc::coordinate_mapping
{
public:

  forms_coordinate_mapping_1() : ufc::coordinate_mapping()
  {
    // Do nothing
  }

  ~forms_coordinate_mapping_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC coordinate_mapping from VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::coordinate_mapping * create() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
  }

  void compute_physical_coordinates(
      double * x, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double phi[3];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis values of coordinate element
        xelement.evaluate_reference_basis(phi, 1, &X[2 * ip]);
        // Compute x
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t d = 0; d < 3; ++d)
                x[2 * ip + i] += coordinate_dofs[2 * d + i] * phi[d];
    }
  }

  void compute_reference_coordinates(
      double * X, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double J[4];
    double detJ[1];
    double K[4];
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_reference_geometry(
      double * X, double * J, double * detJ, double * K, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_jacobians(
      double * J, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double dphi[6];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis derivatives of coordinate element
        xelement.evaluate_reference_basis_derivatives(dphi, 1, 1, &X[2 * ip]);
        // Compute J
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t j = 0; j < 2; ++j)
                for (std::size_t d = 0; d < 3; ++d)
                    J[2 * 2 * ip + 2 * i + j] += coordinate_dofs[2 * d + i] * dphi[2 * d + j];
    }
  }

  void compute_jacobian_determinants(
      double * detJ, std::size_t num_points,
      const double * J,
      int cell_orientation) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
        detJ[ip] = J[2 * 2 * ip] * J[2 * 2 * ip + 2 + 1] - J[2 * 2 * ip + 1] * J[2 * 2 * ip + 2];
  }

  void compute_jacobian_inverses(
      double * K, std::size_t num_points,
      const double * J, const double * detJ) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        K[2 * 2 * ip] = J[2 * 2 * ip + 2 + 1] / detJ[ip];
        K[2 * 2 * ip + 1] = -J[2 * 2 * ip + 1] / detJ[ip];
        K[2 * 2 * ip + 2] = -J[2 * 2 * ip + 2] / detJ[ip];
        K[2 * 2 * ip + 2 + 1] = J[2 * 2 * ip] / detJ[ip];
    }
  }

  void compute_geometry(
      double * x, double * J, double * detJ, double * K, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    compute_physical_coordinates(x, num_points, X, coordinate_dofs);
    compute_jacobians(J, num_points, X, coordinate_dofs);
    compute_jacobian_determinants(detJ, num_points, J, cell_orientation);
    compute_jacobian_inverses(K, num_points, J, detJ);
  }

  void compute_midpoint_geometry(
      double * x, double * J,
      const double * coordinate_dofs) const final override
  {
    const double phi_Xm[3] = { 0.33333333333333326, 0.33333333333333337, 0.3333333333333333 };
    const double dphi_Xm[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    // Compute x
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t d = 0; d < 3; ++d)
            x[i] += coordinate_dofs[2 * d + i] * phi_Xm[d];
    // Compute J
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t d = 0; d < 3; ++d)
                J[2 * i + j] += coordinate_dofs[2 * d + i] * dphi_Xm[j][d];
  }

};


class forms_cell_integral_0_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_0_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_0_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation,
                       std::size_t local_facet) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 4
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 4
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           4
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q6[1][1][2] = { { { -1.0, 1.0 } } };
    alignas(32) static const double PI0[1][15][15] =
        { { { 2.633333333333339, -2.016666666666667, -0.03333333333332783, -1.591666666666674, -0.06666666666665777, -1.008333333333333, -1.091666666666671, 2.600000000000012, -1.508333333333338, 1.649915822768629, 10.96965511460291, -6.833333333333308, 5.89255650988787, -16.88749537379661, 10.41666666666661 },
            { -2.016666666666667, 2.533333333333337, 0.8166666666666661, -0.06666666666667101, 1.633333333333335, 1.266666666666668, 0.1833333333333354, -1.200000000000005, 1.016666666666665, 3.771236166328277, -8.948929172439165, 11.16666666666666, -11.7851130197758, 7.794228634059973, -20.83333333333336 },
            { -0.03333333333332783, 0.8166666666666661, 0.6333333333333344, -1.00833333333334, 1.26666666666667, 0.4083333333333331, -0.5083333333333342, 0.6000000000000036, -0.09166666666667142, 4.00693842672379, -0.5773502691895791, 4.833333333333328, -5.8925565098879, -3.897114317029994, -10.41666666666668 },
            { -1.591666666666674, -0.06666666666667101, -1.00833333333334, 2.633333333333348, -2.016666666666679, -0.03333333333333553, 1.508333333333337, -2.600000000000009, 1.091666666666674, -7.542472332656556, -5.91784025919373, -3.58333333333336, 5.892556509887942, 16.8874953737966, 10.41666666666675 },
            { -0.06666666666665777, 1.633333333333335, 1.26666666666667, -2.016666666666679, 2.533333333333341, 0.8166666666666673, -1.016666666666669, 1.200000000000007, -0.1833333333333419, 8.013876853447583, -1.15470053837917, 9.666666666666664, -11.78511301977581, -7.794228634059978, -20.83333333333338 },
            { -1.008333333333333, 1.266666666666668, 0.4083333333333331, -0.03333333333333553, 0.8166666666666673, 0.633333333333334, 0.0916666666666687, -0.6000000000000041, 0.5083333333333332, 1.885618083164139, -4.474464586219582, 5.583333333333331, -5.892556509887901, 3.897114317029985, -10.41666666666667 },
            { -1.091666666666671, 0.1833333333333354, -0.5083333333333342, 1.508333333333337, -1.016666666666669, 0.0916666666666687, 3.683333333333332, -5.86666666666667, 2.183333333333341, -4.006938426723776, 2.742413778650667, -1.083333333333323, 2.357022603955149, 10.39230484541329, 4.166666666666658 },
            { 2.600000000000012, -1.200000000000005, 0.6000000000000036, -2.600000000000009, 1.200000000000007, -0.6000000000000041, -5.86666666666667, 11.73333333333335, -5.866666666666679, 5.656854249492397, 10.39230484541332, -2.000000000000009, 0.0, -20.7846096908266, 0.0 },
            { -1.508333333333338, 1.016666666666665, -0.09166666666667142, 1.091666666666674, -0.1833333333333419, 0.5083333333333332, 2.183333333333341, -5.866666666666679, 3.683333333333339, -1.649915822768631, -13.13471862406398, 3.083333333333311, -2.357022603955133, 10.3923048454133, -4.16666666666662 },
            { 1.649915822768629, 3.771236166328277, 4.00693842672379, -7.542472332656556, 8.013876853447583, 1.885618083164139, -4.006938426723776, 5.656854249492397, -1.649915822768631, 26.66666666666685, 4.082482904638809, 25.92724864350684, -33.33333333333351, -36.74234614174776, -58.92556509887928 },
            { 10.96965511460291, -8.948929172439165, -0.5773502691895791, -5.91784025919373, -1.15470053837917, -4.474464586219582, 2.742413778650667, 10.39230484541332, -13.13471862406398, 4.082482904638809, 189.9999999999994, -31.75426480542911, 28.57738033247007, -67.5000000000003, 50.51814855409164 },
            { -6.833333333333308, 11.16666666666666, 4.833333333333328, -3.58333333333336, 9.666666666666664, 5.583333333333331, -1.083333333333323, -2.000000000000009, 3.083333333333311, 25.92724864350684, -31.75426480542911, 53.33333333333323, -58.92556509887893, 12.99038105676661, -104.1666666666666 },
            { 5.89255650988787, -11.7851130197758, -5.8925565098879, 5.892556509887942, -11.78511301977581, -5.892556509887901, 2.357022603955149, 0.0, -2.357022603955133, -33.33333333333351, 28.57738033247007, -58.92556509887893, 66.66666666666674, 0.0, 117.851130197758 },
            { -16.88749537379661, 7.794228634059973, -3.897114317029994, 16.8874953737966, -7.794228634059978, 3.897114317029985, 10.39230484541329, -20.7846096908266, 10.3923048454133, -36.74234614174776, -67.5000000000003, 12.99038105676661, 0.0, 135.0000000000003, 0.0 },
            { 10.41666666666661, -20.83333333333336, -10.41666666666668, 10.41666666666675, -20.83333333333338, -10.41666666666667, 4.166666666666658, 0.0, -4.16666666666662, -58.92556509887928, 50.51814855409164, -104.1666666666666, 117.851130197758, 0.0, 208.3333333333335 } } };
    alignas(32) static const double PI1[1][15][15] =
        { { { 0.3583333333333403, 1.11666666666666, -0.8916666666666612, -0.6500000000000064, -0.5333333333333263, 1.183333333333328, -1.108333333333343, 1.216666666666669, 0.308333333333345, 0.4714045207910398, 0.7216878364869815, 1.583333333333342, -1.649915822768611, -7.36121593216776, -2.916666666666665 },
            { 0.2833333333333339, -1.733333333333337, 2.783333333333343, -0.9500000000000043, 3.066666666666678, -2.116666666666673, -0.03333333333332397, -0.4333333333333326, -0.3666666666666845, 6.128258770283448, -1.443375672973976, 1.833333333333352, -3.771236166328272, 1.732050807568865, -6.666666666666702 },
            { 0.4416666666666702, -0.7166666666666706, 1.691666666666672, -1.150000000000004, 2.13333333333334, -0.9833333333333376, -0.6916666666666647, 0.3833333333333355, -0.1083333333333402, 5.185449728701369, -0.7216878364869918, 2.416666666666678, -4.006938426723774, -3.031088913245561, -7.083333333333345 },
            { -0.9416666666666771, 0.4666666666666797, -2.191666666666684, 2.275000000000013, -3.133333333333352, 0.8583333333333473, 1.816666666666669, -1.383333333333336, -0.01666666666666194, -8.720983634634134, 0.7216878364869992, -4.916666666666687, 7.54247233265652, 9.526279441628883, 13.33333333333336 },
            { 0.8833333333333407, -1.433333333333342, 3.383333333333347, -2.30000000000001, 4.266666666666682, -1.966666666666677, -1.383333333333331, 0.7666666666666713, -0.2166666666666811, 10.37089945740275, -1.443375672973989, 4.83333333333335, -8.013876853447551, -6.062177826491121, -14.16666666666669 },
            { 0.1416666666666671, -0.8666666666666683, 1.391666666666672, -0.4750000000000027, 1.533333333333339, -1.058333333333336, -0.01666666666665999, -0.2166666666666675, -0.183333333333342, 3.064129385141723, -0.7216878364869806, 0.9166666666666805, -1.885618083164137, 0.86602540378443, -3.333333333333354 },
            { -0.7333333333333448, -0.1166666666666563, 0.2666666666666631, 0.7750000000000081, 0.03333333333332744, -0.3083333333333256, 5.50833333333332, -3.433333333333324, -0.2416666666666638, -6.835365551469964, 17.8978583448783, 12.16666666666666, 0.2357022603954917, 7.36121593216779, 0.4166666666666314 },
            { 1.466666666666683, -0.9333333333333439, 0.1333333333333402, -1.13333333333335, 0.26666666666668, -0.4666666666666747, -7.933333333333314, 5.866666666666649, 2.066666666666677, 1.885618083164132, -30.02221399786044, -2.666666666666626, 1.885618083164136, -10.39230484541338, 3.333333333333334 },
            { -0.7333333333333404, 1.050000000000004, -0.4000000000000092, 0.3583333333333454, -0.3000000000000144, 0.7750000000000046, 2.424999999999997, -2.433333333333327, -1.825000000000013, 4.949747468305816, 12.12435565298214, -9.500000000000041, -2.121320343559618, 3.031088913245598, -3.749999999999949 },
            { 3.064129385141738, -3.771236166328297, 10.13519719700725, -7.778174593052068, 13.19932658214896, -5.421151989096916, -5.185449728701341, 3.299831645537232, -0.4714045207910702, 33.33333333333353, -4.082482904638423, 16.49915822768618, -26.66666666666674, -24.49489742783197, -47.14045207910331 },
            { 0.1443375672973326, -3.175426480542807, 4.474464586219625, -0.8660254037844681, 4.618802153517079, -3.752776749732488, 0.7216878364868444, -1.443375672974013, -0.7216878364868746, 8.164965809277472, 57.49999999999878, 105.3664241271068, -4.082482904639221, 7.500000000000082, -7.216878364871377 },
            { 2.416666666666676, -8.166666666666682, 14.91666666666669, -7.000000000000017, 17.33333333333336, -10.33333333333335, -2.416666666666619, -0.1666666666666609, -1.583333333333414, 37.71236166328266, -7.216878364869869, 14.16666666666675, -25.92724864350678, -4.330127018922297, -45.83333333333342 },
            { -3.299831645537246, 8.956685895029636, -17.44196726926823, 9.192388155425157, -20.74179891480547, 11.54941075938032, 4.006938426723714, -0.9428090415820661, 1.649915822768696, -46.66666666666687, 8.164965809276737, -18.85618083164142, 33.33333333333341, 12.24744871391608, 58.92556509887913 },
            { -5.19615242270668, -2.598076211353288, -5.196152422706625, 11.69134295108994, -10.39230484541326, -1.299038105676643, 11.69134295108996, -10.39230484541328, -1.29903810567668, -36.74234614174772, 0.0, -25.980762113533, 36.74234614174755, 67.50000000000027, 64.95190528383269 },
            { -5.833333333333373, 15.83333333333339, -30.83333333333344, 16.25000000000007, -36.66666666666679, 20.41666666666675, 7.083333333333256, -1.666666666666684, 2.916666666666826, -82.49579113843095, 14.43375672973976, -33.33333333333354, 58.92556509887912, 21.65063509461129, 104.166666666667 } } };
    alignas(32) static const double PI2[1][15][15] =
        { { { -0.6083333333333364, -0.6166666666666661, -0.1916666666666681, -2.283333333333348, -0.09999999999998976, -2.116666666666668, -1.108333333333335, 1.216666666666669, 0.3083333333333321, -5.185449728701359, -10.53664241271068, 0.08333333333332327, 16.73486048808166, -7.361215932167758, 10.08333333333331 },
            { 0.2166666666666668, 0.7333333333333369, -0.6166666666666735, 0.3166666666666689, 1.199999999999993, 2.483333333333338, -0.03333333333333971, -0.4333333333333316, -0.3666666666666684, 3.299831645537231, 3.752776749732548, -5.166666666666714, -12.25651754056682, 1.732050807568868, -12.66666666666665 },
            { -0.1916666666666679, 0.2166666666666684, -0.6083333333333381, -1.116666666666673, 0.8999999999999984, 0.7166666666666662, -0.6916666666666713, 0.3833333333333358, -0.1083333333333345, -0.4714045207910336, -3.319764047840367, -4.083333333333367, 0.2357022603955521, -3.031088913245563, -4.083333333333318 },
            { 0.6916666666666703, 0.03333333333332877, 1.108333333333343, 3.241666666666682, -1.400000000000005, 0.1583333333333295, 1.816666666666675, -1.383333333333338, -0.01666666666666328, 4.006938426723773, 11.98001808568476, 6.583333333333401, -10.84230397819378, 9.526279441628876, 0.3333333333333459 },
            { -0.3833333333333356, 0.4333333333333375, -1.216666666666677, -2.233333333333346, 1.799999999999999, 1.433333333333335, -1.383333333333343, 0.7666666666666714, -0.2166666666666694, -0.9428090415820645, -6.63952809568073, -8.166666666666737, 0.4714045207910922, -6.062177826491125, -8.16666666666665 },
            { 0.1083333333333333, 0.3666666666666683, -0.308333333333337, 0.1583333333333362, 0.5999999999999952, 1.241666666666669, -0.01666666666667026, -0.2166666666666654, -0.1833333333333342, 1.649915822768614, 1.87638837486627, -2.583333333333357, -6.12825877028341, 0.8660254037844388, -6.333333333333321 },
            { 2.133333333333349, -0.683333333333348, 0.4666666666666743, 4.308333333333327, -2.866666666666659, 0.5583333333333284, 1.50833333333334, -2.766666666666682, 1.091666666666681, 5.892556509887903, 10.96965511460289, -1.833333333333319, -11.07800623858926, 7.361215932167663, 8.41666666666668 },
            { -4.933333333333361, 2.533333333333357, -0.9333333333333469, -7.533333333333333, 3.733333333333328, -1.533333333333326, -2.600000000000012, 5.866666666666694, -3.266666666666691, -9.428090415820654, -16.16580753730954, 5.333333333333309, 24.51303508113369, -10.3923048454132, -12.66666666666671 },
            { 2.800000000000014, -1.850000000000012, 0.4666666666666747, 3.225000000000007, -0.8666666666666717, 0.9749999999999928, 1.091666666666675, -3.100000000000016, 2.175000000000013, 3.535533905932751, 5.19615242270665, -3.499999999999981, -13.43502884254442, 3.031088913245531, 4.250000000000055 },
            { -1.649915822768621, 0.9428090415820813, -4.006938426723808, -8.720983634634127, 5.656854249492389, 3.06412938514173, -5.185449728701382, 3.299831645537239, -0.4714045207910436, -6.666666666666664, -28.57738033247053, -25.92724864350702, 13.33333333333346, -24.49489742783195, -18.85618083164131 },
            { 0.7216878364870822, 1.443375672974022, -0.7216878364870414, -11.83568051838747, -5.196152422706518, -8.948929172439193, 0.7216878364870238, -1.443375672974098, -0.7216878364869892, 8.164965809277231, 12.49999999999989, -7.216878364870528, 69.4022093788568, 7.499999999999005, 44.74464586219579 },
            { 0.08333333333333121, 3.16666666666668, -4.083333333333365, -2.666666666666669, 6.999999999999958, 10.66666666666667, -2.416666666666697, -0.1666666666666549, -1.583333333333341, 9.428090415820652, 1.443375672973954, -30.83333333333356, -40.06938426723753, -4.330127018922286, -55.83333333333314 },
            { 0.4714045207910441, -3.299831645537246, 5.185449728701398, 5.421151989096872, -8.48528137423853, -11.07800623858927, 4.006938426723816, -0.9428090415820891, 1.649915822768628, -6.666666666666673, 8.164965809277435, 37.71236166328286, 33.33333333333317, 12.24744871391599, 58.92556509887883 },
            { 5.196152422706645, 2.598076211353319, 5.196152422706646, 22.08364779650327, -5.196152422706667, 9.093266739736636, 11.69134295108993, -10.39230484541327, -1.299038105676655, 36.74234614174774, 90.00000000000009, 25.98076211353328, -110.2270384252434, 67.50000000000026, -38.9711431702998 },
            { 0.8333333333333429, -5.833333333333369, 9.16666666666675, 9.583333333333371, -14.99999999999994, -19.58333333333336, 7.083333333333412, -1.666666666666699, 2.916666666666687, -11.78511301977582, 14.43375672974094, 66.66666666666724, 58.92556509887862, 21.65063509461125, 104.1666666666664 } } };
    alignas(32) static const double PI3[1][15][15] =
        { { { -0.6083333333333278, -0.6166666666666791, -0.191666666666665, -0.6500000000000129, -0.5333333333333266, 1.183333333333326, -1.108333333333336, 1.216666666666664, 0.3083333333333442, -5.185449728701373, -10.53664241271072, 0.08333333333332593, 4.006938426723799, 3.897114317029956, -1.416666666666654 },
            { 0.2166666666666585, 0.7333333333333496, -0.6166666666666736, -0.9499999999999963, 3.06666666666667, -2.116666666666672, -0.03333333333333577, -0.4333333333333271, -0.3666666666666802, 3.299831645537246, 3.752776749732601, -5.166666666666696, -0.9428090415820535, -3.464101615137761, 0.3333333333333545 },
            { -0.1916666666666699, 0.2166666666666712, -0.6083333333333365, -1.150000000000003, 2.133333333333334, -0.9833333333333382, -0.6916666666666689, 0.3833333333333364, -0.1083333333333371, -0.4714045207910302, -3.31976404784035, -4.083333333333349, 1.649915822768635, -0.4330127018922338, -0.5833333333333119 },
            { 0.6916666666666679, 0.03333333333333241, 1.108333333333338, 2.275000000000013, -3.133333333333343, 0.8583333333333496, 1.816666666666671, -1.383333333333335, -0.01666666666666645, 4.006938426723775, 11.98001808568476, 6.583333333333374, -5.185449728701403, -1.732050807568835, 1.83333333333329 },
            { -0.3833333333333396, 0.433333333333343, -1.216666666666674, -2.300000000000006, 4.266666666666672, -1.966666666666679, -1.383333333333338, 0.7666666666666724, -0.2166666666666747, -0.9428090415820575, -6.639528095680697, -8.166666666666705, 3.29983164553727, -0.8660254037844706, -1.166666666666623 },
            { 0.1083333333333293, 0.3666666666666749, -0.3083333333333369, -0.4749999999999971, 1.533333333333333, -1.058333333333335, -0.01666666666666781, -0.2166666666666637, -0.1833333333333401, 1.649915822768623, 1.876388374866301, -2.583333333333349, -0.471404520791027, -1.732050807568881, 0.1666666666666767 },
            { 1.150000000000002, 0.9499999999999973, 0.6500000000000039, 2.591666666666664, -3.933333333333323, 1.341666666666672, 2.275000000000001, -2.299999999999999, -0.474999999999999, 9.192388155425114, 19.91858428704208, 2.000000000000034, -7.778174593052078, -6.495190528383249, 2.749999999999928 },
            { -2.133333333333332, -3.066666666666676, 0.5333333333333337, -3.933333333333339, 5.866666666666655, -1.933333333333337, -3.133333333333332, 4.26666666666666, 1.533333333333344, -20.74179891480541, -36.95041722813607, 9.333333333333318, 13.19932658214896, 17.3205080756887, -4.666666666666622 },
            { 0.9833333333333301, 2.116666666666679, -1.183333333333336, 1.341666666666678, -1.933333333333339, 0.59166666666667, 0.8583333333333336, -1.966666666666663, -1.058333333333345, 11.5494107593803, 17.031832941094, -11.33333333333334, -5.421151989096887, -10.82531754730545, 1.916666666666693 },
            { -1.649915822768626, 0.9428090415820898, -4.006938426723796, -7.778174593052055, 13.19932658214892, -5.42115198909692, -5.185449728701366, 3.299831645537236, -0.4714045207910516, -6.666666666666648, -28.57738033247043, -25.92724864350691, 13.33333333333351, 0.0, -4.714045207910198 },
            { 0.7216878364870825, 1.443375672973942, -0.7216878364870194, -0.8660254037845676, 4.618802153517141, -3.752776749732485, 0.7216878364869848, -1.443375672974078, -0.7216878364869248, 8.164965809276918, 12.4999999999993, -7.216878364870343, -4.082482904638962, 52.50000000000025, 105.3664241271055 },
            { 0.08333333333329671, 3.166666666666732, -4.08333333333336, -6.999999999999981, 17.33333333333332, -10.33333333333335, -2.416666666666675, -0.166666666666639, -1.583333333333389, 9.428090415820717, 1.443375672974199, -30.83333333333343, 2.357022603955258, -12.99038105676664, -0.8333333333331812 },
            { 0.4714045207910726, -3.299831645537292, 5.185449728701384, 9.192388155425112, -20.74179891480539, 11.54941075938032, 4.006938426723787, -0.9428090415820969, 1.64991582276867, -6.666666666666744, 8.164965809277163, 37.7123616632827, -6.666666666666827, 12.247448713916, 2.357022603954979 },
            { 5.196152422706609, 2.598076211353367, 5.19615242270663, 11.69134295108998, -10.39230484541324, -1.299038105676612, 11.69134295108993, -10.39230484541325, -1.299038105676703, 36.74234614174777, 90.00000000000018, 25.98076211353324, -36.74234614174797, -22.49999999999976, 12.99038105676635 },
            { 0.8333333333334049, -5.833333333333464, 9.166666666666735, 16.25, -36.66666666666669, 20.41666666666674, 7.083333333333367, -1.666666666666724, 2.916666666666775, -11.78511301977595, 14.43375672974046, 66.666666666667, -11.78511301977608, 21.65063509461116, 4.166666666666345 } } };
    alignas(32) static const double PI4[1][15][15] =
        { { { 0.858333333333347, -0.8000000000000078, 1.275000000000007, -1.295833333333348, 1.67500000000001, -0.8375000000000054, -0.3624999999999957, 0.3083333333333388, 0.7625000000000091, 1.767766952966352, -1.732050807568893, 3.749999999999992, -2.474873734152925, -6.278684177437282, -4.375000000000016 },
            { -0.8000000000000078, 2.766666666666667, -3.46666666666668, 1.258333333333351, -3.683333333333352, 3.008333333333336, -0.8583333333333475, 0.2166666666666608, -1.275000000000009, 1.178511301977603, 2.020725942163698, -16.6666666666667, 2.592724864350726, -0.4330127018921202, 4.583333333333431 },
            { 1.275000000000007, -3.46666666666668, 6.191666666666695, -3.17083333333335, 7.258333333333362, -4.295833333333352, 1.095833333333345, -0.4416666666666617, 0.6374999999999915, 7.660323462854302, 4.041451884327442, 22.91666666666675, -10.72445284799602, -4.113620667976142, -18.95833333333342 },
            { -1.295833333333348, 1.258333333333351, -3.17083333333335, 2.775000000000013, -4.216666666666683, 1.691666666666682, 0.3208333333333316, -0.225000000000006, -0.3874999999999977, -8.249579113843073, -2.237232293109822, -7.708333333333348, 8.367430244040811, 10.60881119635945, 14.79166666666666 },
            { 1.67500000000001, -3.683333333333352, 7.258333333333362, -4.216666666666683, 8.766666666666698, -4.716666666666689, 0.9416666666666732, -0.3833333333333253, 0.5249999999999864, 11.78511301977584, 5.917840259193732, 24.58333333333341, -14.3778378841265, -8.227241335952231, -25.41666666666674 },
            { -0.8375000000000054, 3.008333333333336, -4.295833333333352, 1.691666666666682, -4.716666666666689, 3.441666666666674, -1.054166666666678, 0.3583333333333271, -1.012500000000002, -1.178511301977582, -0.07216878364871609, -18.95833333333339, 4.83189633810813, -0.2165063509460365, 8.541666666666771 },
            { -0.3624999999999957, -0.8583333333333475, 1.095833333333345, 0.3208333333333316, 0.9416666666666732, -1.054166666666678, 10.04166666666667, -5.083333333333317, 1.625000000000027, -18.97403196183913, 24.75389279150503, 27.9583333333334, -0.2357022603955152, 6.062177826491071, -0.4166666666666536 },
            { 0.3083333333333388, 0.2166666666666608, -0.4416666666666617, -0.225000000000006, -0.3833333333333253, 0.3583333333333271, -5.083333333333317, 3.833333333333319, 0.4166666666666513, 2.592724864350722, -19.19689645055491, -8.416666666666682, 0.4714045207910385, -3.464101615137788, 0.8333333333333357 },
            { 0.7625000000000091, -1.275000000000009, 0.6374999999999915, -0.3874999999999977, 0.5249999999999864, -1.012500000000002, 1.625000000000027, 0.4166666666666513, 2.708333333333339, -13.0814754519512, -6.278684177437048, 13.3750000000001, 2.121320343559703, -2.598076211353353, 3.750000000000107 },
            { 1.767766952966352, 1.178511301977603, 7.660323462854302, -8.249579113843073, 11.78511301977584, -1.178511301977582, -18.97403196183913, 2.592724864350722, -13.0814754519512, 113.3333333333338, 14.28869016623505, -64.81812160876709, -36.66666666666686, -30.61862178478968, -64.8181216087672 },
            { -1.732050807568893, 2.020725942163698, 4.041451884327442, -2.237232293109822, 5.917840259193732, -0.07216878364871609, 24.75389279150503, -19.19689645055491, -6.278684177437048, 14.28869016623505, 132.4999999999985, 57.73502691896245, -22.45365597551274, 3.750000000000069, -39.69283100678722 },
            { 3.749999999999992, -16.6666666666667, 22.91666666666675, -7.708333333333348, 24.58333333333341, -18.95833333333339, 27.9583333333334, -8.416666666666682, 13.3750000000001, -64.81812160876709, 57.73502691896245, 219.1666666666676, -22.39171473757417, 10.82531754730554, -39.58333333333365 },
            { -2.474873734152925, 2.592724864350726, -10.72445284799602, 8.367430244040811, -14.3778378841265, 4.83189633810813, -0.2357022603955152, 0.4714045207910385, 2.121320343559703, -36.66666666666686, -22.45365597551274, -22.39171473757417, 33.33333333333329, 24.49489742783168, 58.92556509887888 },
            { -6.278684177437282, -0.4330127018921202, -4.113620667976142, 10.60881119635945, -8.227241335952231, -0.2165063509460365, 6.062177826491071, -3.464101615137788, -2.598076211353353, -30.61862178478968, 3.750000000000069, 10.82531754730554, 24.49489742783168, 67.50000000000053, 43.30127018922175 },
            { -4.375000000000016, 4.583333333333431, -18.95833333333342, 14.79166666666666, -25.41666666666674, 8.541666666666771, -0.4166666666666536, 0.8333333333333357, 3.750000000000107, -64.8181216087672, -39.69283100678722, -39.58333333333365, 58.92556509887888, 43.30127018922175, 104.1666666666665 } } };
    alignas(32) static const double PI5[1][15][15] =
        { { { -1.875000000000021, 1.0, -0.7916666666666761, -0.1125000000000047, 0.1416666666666693, 0.5125000000000043, -1.479166666666683, 2.375000000000026, -1.187500000000013, -3.889087296526057, -8.660254037844481, -1.250000000000016, 3.181980515339511, 4.979646071760493, -2.875000000000028 },
            { 1.666666666666684, -2.166666666666676, 1.0, -0.1083333333333306, -0.283333333333333, -2.025000000000007, 0.708333333333354, -1.583333333333358, 1.958333333333344, -1.649915822768569, -1.44337567297395, 3.333333333333381, 5.421151989096827, -5.629165124598753, 11.58333333333335 },
            { -0.7916666666666722, 1.666666666666677, -1.875000000000016, -1.154166666666679, 1.058333333333333, 2.88750000000001, -1.520833333333349, 0.9583333333333433, -1.145833333333341, 2.003469213361886, -2.886751345948183, -12.08333333333344, -5.067598598503553, -1.515544456622869, -12.45833333333335 },
            { 1.520833333333348, -0.7083333333333456, 1.479166666666678, 1.008333333333346, -0.6833333333333367, -1.075000000000006, 2.270833333333346, -2.291666666666684, 0.7291666666666785, 4.478342947514817, 13.35122497501015, 7.291666666666716, -4.360491817317095, -0.6495190528382917, 3.291666666666698 },
            { -0.9583333333333397, 1.583333333333345, -2.375000000000018, -1.683333333333353, 1.366666666666669, 3.150000000000011, -2.291666666666683, 1.416666666666677, -1.041666666666676, 0.471404520791038, -7.938566201357402, -15.41666666666678, -3.064129385141647, -3.031088913245644, -12.41666666666669 },
            { 1.145833333333343, -1.958333333333341, 1.187500000000013, 0.2583333333333411, -0.5166666666666674, -2.325000000000008, 0.7291666666666837, -1.041666666666682, 1.604166666666674, -2.592724864350654, -1.804219591217497, 6.041666666666735, 6.246109900481137, -2.814582562299315, 12.04166666666668 },
            { 1.154166666666655, 0.1083333333333362, 0.112500000000002, 7.504166666666665, -5.25833333333332, 0.9625000000000055, 1.008333333333326, -1.683333333333318, 0.2583333333333275, 5.067598598503558, 9.165435523385243, -2.041666666666626, -12.9636243217534, 12.99038105676652, 13.58333333333325 },
            { -1.058333333333328, 0.2833333333333331, -0.1416666666666712, -5.258333333333327, 3.016666666666661, -1.008333333333329, -0.6833333333333317, 1.36666666666666, -0.5166666666666646, -3.06412938514169, -5.34048999000401, 1.583333333333288, 11.78511301977578, -17.32050807568874, -7.166666666666647 },
            { -2.887500000000016, 2.02500000000001, -0.5124999999999988, 0.962500000000007, -1.00833333333335, 0.1708333333333231, -1.075000000000001, 3.150000000000014, -2.325000000000012, -3.181980515339477, -4.546633369868298, 3.375000000000052, 3.535533905932795, 4.33012701892231, -2.249999999999951 },
            { 5.067598598503623, -5.421151989096867, -3.181980515339493, -12.96362432175344, 11.78511301977582, 3.535533905932756, -4.360491817317053, -3.064129385141737, 6.246109900481185, -6.666666666666583, -34.70110468942833, -36.53385036130528, 3.333333333333432, -6.123724356958334, -22.39171473757403 },
            { 11.5470053837925, -7.216878364870332, 0.0, 18.25870226312182, -14.86676943163273, 0.2165063509461539, 2.525907427704573, -12.2686932202795, 9.021097956087905, 14.28869016623508, 12.49999999999966, -28.86751345948133, -22.45365597551258, 48.74999999999917, 72.89047148518971 },
            { -4.916666666666666, 10.66666666666669, -5.750000000000023, 4.458333333333284, -11.41666666666666, 4.87500000000002, -2.208333333333346, 3.583333333333336, -8.458333333333355, 20.03469213361891, 23.0940107675851, -30.83333333333348, 5.892556509887932, 2.16506350946074, 5.416666666666536 },
            { -2.003469213361912, 1.649915822768602, 3.889087296526025, 5.067598598503618, -3.064129385141698, -3.181980515339473, 4.478342947514789, 0.4714045207910693, -2.592724864350677, 3.333333333333202, 26.53613888015092, 34.17682775734999, -6.666666666666702, 24.49489742783174, 2.357022603955144 },
            { 11.90784930203615, -2.165063509461175, 5.412658773652792, 2.814582562299482, -1.299038105676692, 0.6495190528383015, 12.99038105676665, -17.32050807568891, 4.330127018922278, 42.8660704987058, 93.75000000000036, 10.82531754730556, -48.98979485566383, -22.49999999999994, -8.660254037844101 },
            { -3.541666666666714, 2.916666666666648, 6.875000000000027, 8.958333333333398, -5.416666666666663, -5.62500000000002, 7.916666666666646, 0.8333333333333974, -4.583333333333334, 5.892556509887656, 46.90970937165677, 60.41666666666701, -11.78511301977587, 43.3012701892219, 4.166666666666694 } } };
    alignas(32) static const double PI6[1][15][15] =
        { { { -0.6083333333333398, -0.6166666666666799, -0.1916666666666623, -0.4666666666666741, 0.9333333333333295, -0.4666666666666673, -1.108333333333341, 1.216666666666679, 0.308333333333341, -5.185449728701421, -10.53664241271078, 0.08333333333337944, 4.006938426723844, 3.897114317029931, -1.41666666666676 },
            { 0.2166666666666763, 0.7333333333333447, -0.6166666666666746, 0.6833333333333416, -2.53333333333333, 1.849999999999991, -0.03333333333332866, -0.4333333333333474, -0.3666666666666718, 3.299831645537298, 3.752776749732671, -5.166666666666755, -0.9428090415821067, -3.464101615137698, 0.3333333333335524 },
            { -0.1916666666666749, 0.2166666666666706, -0.6083333333333331, -2.133333333333344, 4.933333333333344, -2.800000000000014, -0.6916666666666687, 0.3833333333333416, -0.1083333333333385, -0.4714045207910508, -3.319764047840367, -4.083333333333306, 1.64991582276865, -0.4330127018922648, -0.5833333333333921 },
            { 0.6916666666666722, 0.03333333333333774, 1.108333333333333, 1.508333333333343, -2.600000000000005, 1.091666666666684, 1.816666666666672, -1.383333333333342, -0.0166666666666682, 4.006938426723808, 11.9800180856848, 6.58333333333332, -5.185449728701428, -1.732050807568837, 1.833333333333321 },
            { -0.3833333333333422, 0.4333333333333393, -1.216666666666669, -2.766666666666681, 5.866666666666682, -3.100000000000025, -1.383333333333336, 0.7666666666666756, -0.2166666666666734, -0.9428090415820791, -6.639528095680713, -8.166666666666654, 3.299831645537282, -0.8660254037844869, -1.166666666666671 },
            { 0.1083333333333419, 0.366666666666671, -0.3083333333333378, 1.091666666666676, -3.26666666666667, 2.174999999999999, -0.0166666666666635, -0.2166666666666776, -0.183333333333334, 1.649915822768659, 1.876388374866347, -2.583333333333394, -0.4714045207910624, -1.732050807568826, 0.1666666666668322 },
            { 1.116666666666663, -0.3166666666666975, 2.283333333333361, 4.308333333333324, -7.533333333333323, 3.224999999999997, 3.241666666666672, -2.233333333333321, 0.1583333333333497, 5.421151989096753, 19.34123401785234, 14.33333333333356, -8.720983634634083, -8.22724133595216, -8.916666666666899 },
            { -0.8999999999999974, -1.199999999999984, 0.09999999999998932, -2.866666666666665, 3.733333333333326, -0.8666666666666731, -1.399999999999996, 1.799999999999989, 0.5999999999999915, -8.485281374238497, -15.58845726811979, 2.999999999999905, 5.656854249492397, 3.464101615137672, -7.999999999999899 },
            { -0.7166666666666636, -2.483333333333344, 2.11666666666668, 0.5583333333333433, -1.53333333333336, 0.9749999999999979, 0.1583333333333468, 1.433333333333326, 1.241666666666675, -11.07800623858925, -12.41303078757692, 17.66666666666676, 3.064129385141733, 4.76313972081441, -13.08333333333321 },
            { -0.2357022603955363, 12.25651754056689, -16.73486048808171, -11.07800623858927, 24.51303508113374, -13.43502884254443, -10.8423039781938, 0.4714045207910624, -6.128258770283463, 33.3333333333334, -4.082482904638766, -124.922198009624, 13.33333333333339, 0.0, 80.13876853447553 },
            { 5.051814855409208, 10.10362971081832, -5.051814855409169, 10.96965511460279, -16.16580753730937, 5.196152422706642, 5.051814855409164, -10.10362971081836, -5.051814855409153, 57.15476066494022, 87.49999999999899, -50.51814855409176, -28.57738033247042, -22.49999999999981, 62.06515393788332 },
            { 0.583333333333361, -7.833333333333433, 11.41666666666677, 2.166666666666614, -2.666666666666639, 0.5, 8.083333333333407, -1.166666666666701, 3.916666666666738, -18.85618083164145, 10.10362971081848, 84.16666666666745, -11.78511301977597, 12.99038105676655, -25.83333333333382 },
            { 0.4714045207910282, -3.29983164553727, 5.185449728701372, 5.8925565098879, -9.42809041582067, 3.535533905932823, 4.006938426723761, -0.9428090415820458, 1.649915822768644, -6.666666666666844, 8.164965809276993, 37.71236166328273, -6.666666666666705, 12.24744871391587, 2.357022603954551 },
            { 5.196152422706655, 2.598076211353388, 5.196152422706615, 3.89711431703003, -3.464101615137765, -0.4330127018921484, 11.69134295108996, -10.39230484541331, -1.299038105676702, 36.74234614174802, 90.00000000000057, 25.98076211353301, -36.74234614174821, -22.49999999999975, 12.99038105676661 },
            { 0.8333333333333286, -5.833333333333417, 9.16666666666671, 10.41666666666668, -16.66666666666675, 6.250000000000159, 7.083333333333321, -1.666666666666639, 2.916666666666725, -11.78511301977609, 14.43375672974019, 66.666666666667, -11.78511301977587, 21.65063509461092, 4.166666666665591 } } };
    alignas(32) static const double PI7[1][15][15] =
        { { { 6.191666666666705, -3.466666666666696, 1.27500000000001, -1.09583333333333, 0.4416666666666634, -0.6375000000000106, 3.170833333333349, -7.258333333333372, 4.295833333333364, 10.72445284799601, 18.47520861406807, -5.916666666666694, -7.660323462854278, -21.86714144555712, 7.958333333333441 },
            { -3.466666666666696, 2.766666666666689, -0.80000000000001, 0.8583333333333292, -0.216666666666663, 1.275000000000011, -1.258333333333348, 3.683333333333364, -3.008333333333356, -2.592724864350702, -3.752776749732619, 2.666666666666673, -1.178511301977573, 13.42339375865883, -10.08333333333342 },
            { 1.27500000000001, -0.80000000000001, 0.8583333333333424, 0.362500000000012, -0.3083333333333399, -0.7625000000000078, 1.295833333333343, -1.675000000000012, 0.8375000000000092, 2.474873734152922, 6.928203230275541, 3.25000000000004, -1.767766952966387, -2.381569860407176, 3.375000000000052 },
            { -1.09583333333333, 0.8583333333333292, 0.362500000000012, 10.04166666666667, -5.083333333333326, 1.624999999999999, 0.3208333333333424, 0.9416666666666592, -1.054166666666662, -0.2357022603955023, 2.67024499500206, 5.458333333333417, -18.9740319618391, 36.5895733098925, 7.458333333333281 },
            { 0.4416666666666634, -0.216666666666663, -0.3083333333333399, -5.083333333333326, 3.833333333333317, 0.4166666666666637, -0.2250000000000052, -0.3833333333333284, 0.3583333333333299, 0.4714045207910269, -1.010362971081866, -3.416666666666706, 2.592724864350728, -16.88749537379651, -12.41666666666659 },
            { -0.6375000000000106, 1.275000000000011, -0.7625000000000078, 1.624999999999999, 0.4166666666666637, 2.708333333333341, -0.3875000000000098, 0.525000000000013, -1.01250000000001, 2.12132034355964, 1.948557158514953, -4.125000000000027, -13.08147545195112, 8.443747686898275, -12.12500000000003 },
            { 3.170833333333349, -1.258333333333348, 1.295833333333343, 0.3208333333333424, -0.2250000000000052, -0.3875000000000098, 2.775000000000009, -4.216666666666681, 1.69166666666668, 8.367430244040815, 18.11436469582452, 1.791666666666698, -8.249579113843064, -7.794228634059934, 1.916666666666735 },
            { -7.258333333333372, 3.683333333333364, -1.675000000000012, 0.9416666666666592, -0.3833333333333284, 0.525000000000013, -4.216666666666681, 8.766666666666705, -4.716666666666698, -14.37783788412649, -26.12509968083059, 5.58333333333335, 11.7851130197758, 24.24871130596431, -7.166666666666793 },
            { 4.295833333333364, -3.008333333333356, 0.8375000000000092, -1.054166666666662, 0.3583333333333299, -1.01250000000001, 1.69166666666668, -4.716666666666698, 3.441666666666691, 4.831896338108102, 7.289047148519066, -4.45833333333335, -1.178511301977584, -16.45448267190437, 9.41666666666676 },
            { 10.72445284799601, -2.592724864350702, 2.474873734152922, -0.2357022603955023, 0.4714045207910269, 2.12132034355964, 8.367430244040815, -14.37783788412649, 4.831896338108102, 33.33333333333334, 63.27848502189872, -8.24957911384309, -36.66666666666671, -30.61862178478971, -8.249579113842964 },
            { 18.47520861406807, -3.752776749732619, 6.928203230275541, 2.67024499500206, -1.010362971081866, 1.948557158514953, 18.11436469582452, -26.12509968083059, 7.289047148519066, 63.27848502189872, 132.4999999999999, 5.773502691896393, -71.44345083117605, -41.24999999999986, -13.71206889325337 },
            { -5.916666666666694, 2.666666666666673, 3.25000000000004, 5.458333333333417, -3.416666666666706, -4.125000000000027, 1.791666666666698, 5.58333333333335, -4.45833333333335, -8.24957911384309, 5.773502691896393, 39.16666666666705, 5.892556509887763, 36.80607966083902, 5.416666666666742 },
            { -7.660323462854278, -1.178511301977573, -1.767766952966387, -18.9740319618391, 2.592724864350728, -13.08147545195112, -8.249579113843064, 11.7851130197758, -1.178511301977584, -36.66666666666671, -71.44345083117605, 5.892556509887763, 113.3333333333335, -48.98979485566376, 44.78342947514788 },
            { -21.86714144555712, 13.42339375865883, -2.381569860407176, 36.5895733098925, -16.88749537379651, 8.443747686898275, -7.794228634059934, 24.24871130596431, -16.45448267190437, -30.61862178478971, -41.24999999999986, 36.80607966083902, -48.98979485566376, 247.4999999999994, -8.660254037844737 },
            { 7.958333333333441, -10.08333333333342, 3.375000000000052, 7.458333333333281, -12.41666666666659, -12.12500000000003, 1.916666666666735, -7.166666666666793, 9.41666666666676, -8.249579113842964, -13.71206889325337, 5.416666666666742, 44.78342947514788, -8.660254037844737, 104.1666666666667 } } };
    alignas(32) static const double PI8[1][15][15] =
        { { { 1.691666666666668, 2.783333333333355, -0.8916666666666772, -0.2666666666666588, -0.1333333333333308, 0.4000000000000105, 2.191666666666668, -3.383333333333338, -1.391666666666683, 17.44196726926825, 29.3005261613736, -10.91666666666674, -10.13519719700728, -15.15544456622761, 3.583333333333341 },
            { -0.7166666666666716, -1.733333333333346, 1.116666666666673, 0.1166666666666591, 0.9333333333333427, -1.050000000000008, -0.4666666666666699, 1.433333333333341, 0.8666666666666754, -8.956685895029661, -12.41303078757704, 10.16666666666672, 3.771236166328305, 8.660254037844378, -1.333333333333373 },
            { 0.4416666666666701, 0.2833333333333357, 0.3583333333333344, 0.7333333333333443, -1.466666666666681, 0.7333333333333482, 0.9416666666666711, -0.8833333333333386, -0.1416666666666678, 3.299831645537245, 7.649891066762584, 1.583333333333335, -3.064129385141753, -2.165063509461072, 1.083333333333329 },
            { 0.69166666666667, 0.03333333333332125, 1.108333333333347, 5.508333333333336, -7.93333333333333, 2.425000000000002, 1.816666666666674, -1.383333333333335, -0.01666666666665959, 4.00693842672375, 11.98001808568473, 6.583333333333434, -5.185449728701375, -1.732050807568879, 1.833333333333266 },
            { -0.3833333333333402, 0.4333333333333506, -1.216666666666677, -3.433333333333323, 5.86666666666665, -2.43333333333333, -1.383333333333337, 0.7666666666666704, -0.2166666666666797, -0.9428090415820334, -6.639528095680657, -8.166666666666732, 3.299831645537247, -0.866025403784443, -1.166666666666589 },
            { 0.1083333333333237, 0.3666666666666737, -0.3083333333333349, -0.241666666666666, 2.066666666666674, -1.825000000000008, -0.0166666666666701, -0.2166666666666564, -0.1833333333333411, 1.649915822768599, 1.876388374866268, -2.583333333333317, -0.471404520791003, -1.732050807568875, 0.166666666666663 },
            { 1.15, 0.9500000000000072, 0.6499999999999981, 0.7750000000000101, -1.133333333333339, 0.3583333333333522, 2.275000000000001, -2.3, -0.4750000000000056, 9.192388155425142, 19.91858428704212, 1.999999999999993, -7.778174593052102, -6.495190528383215, 2.749999999999962 },
            { -2.133333333333332, -3.06666666666669, 0.5333333333333441, 0.03333333333332228, 0.2666666666666652, -0.3000000000000176, -3.133333333333332, 4.266666666666667, 1.533333333333351, -20.74179891480546, -36.95041722813613, 9.333333333333403, 13.19932658214901, 17.32050807568867, -4.666666666666641 },
            { 0.9833333333333364, 2.116666666666682, -1.183333333333342, -0.308333333333326, -0.4666666666666722, 0.7750000000000073, 0.8583333333333351, -1.966666666666672, -1.058333333333345, 11.54941075938034, 17.03183294109404, -11.3333333333334, -5.421151989096924, -10.82531754730546, 1.916666666666698 },
            { 4.006938426723757, 3.771236166328285, 1.649915822768596, 0.2357022603955277, 1.885618083164158, -2.121320343559617, 7.542472332656496, -8.013876853447522, -1.885618083164155, 33.33333333333337, 69.40220937885674, 2.357022603955109, -26.66666666666688, -24.49489742783153, 9.428090415820471 },
            { 7.64989106676252, 4.907477288111854, 6.206515393788467, 4.041451884327422, -2.309401076758484, -1.73205080756878, 16.31014510460691, -15.29978213352505, -2.453738644055941, 57.15476066494082, 132.5, 27.42413778650727, -53.07227776030264, -37.4999999999994, 18.76388374866244 },
            { -0.9166666666666461, -4.833333333333378, 4.916666666666707, 6.166666666666728, -10.66666666666677, 4.500000000000077, 1.583333333333366, 1.833333333333306, 2.416666666666703, -18.8561808316413, -15.87713240271466, 39.16666666666691, 2.357022603955061, 21.65063509461101, -0.8333333333333872 },
            { -5.185449728701309, -6.128258770283474, -0.4714045207910318, -6.835365551470037, 1.885618083164153, 4.949747468305793, -8.720983634634093, 10.37089945740266, 3.064129385141767, -46.66666666666674, -89.81462390205004, 9.428090415820492, 33.33333333333353, 36.74234614174742, -11.78511301977572 },
            { -1.732050807568858, -0.8660254037845756, -1.732050807568797, 19.48557158514986, -17.32050807568879, -2.165063509460991, -3.89711431702997, 3.46410161513776, 0.433012701892316, -12.24744871391628, -30.00000000000054, -8.66025403784387, 12.24744871391585, 67.49999999999993, 99.59292143520943 },
            { 1.833333333333393, 2.166666666666622, 0.1666666666666812, 9.416666666666618, -24.66666666666662, 15.25, 3.083333333333351, -3.66666666666672, -1.08333333333329, 16.49915822768617, 31.75426480542948, -3.333333333333375, -11.78511301977598, -12.99038105676663, 4.166666666666577 } } };
    alignas(32) static const double PI9[1][15][15] =
        { { { 0.6333333333333313, 0.816666666666666, -0.0333333333333321, 0.5083333333333402, -0.6000000000000072, 0.0916666666666776, 1.008333333333331, -1.266666666666662, -0.4083333333333342, 5.892556509887882, 10.96965511460287, -1.833333333333315, -4.006938426723796, -3.897114317029904, 2.916666666666659 },
            { 0.816666666666666, 2.533333333333346, -2.016666666666679, -0.1833333333333431, 1.200000000000028, -1.016666666666668, 0.06666666666665785, -1.633333333333331, -1.266666666666676, 11.78511301977582, 14.14508159514583, -17.16666666666676, -3.771236166328295, -5.196152422706626, 13.33333333333325 },
            { -0.0333333333333321, -2.016666666666679, 2.63333333333335, 1.091666666666674, -2.600000000000018, 1.508333333333339, 1.591666666666679, 0.06666666666666365, 1.008333333333341, -5.892556509887917, -0.5773502691896049, 19.83333333333346, -1.649915822768618, 0.4330127018922103, -12.91666666666669 },
            { 0.5083333333333402, -0.1833333333333431, 1.091666666666674, 3.683333333333334, -5.86666666666666, 2.183333333333338, 1.508333333333338, -1.016666666666673, 0.09166666666667461, 2.357022603955155, 8.804591605141795, 6.916666666666707, -4.006938426723814, 0.433012701892225, 2.916666666666606 },
            { -0.6000000000000072, 1.200000000000028, -2.600000000000018, -5.86666666666666, 11.73333333333333, -5.866666666666669, -2.600000000000005, 1.200000000000001, -0.6000000000000195, 0.0, -10.39230484541319, -18.00000000000012, 5.656854249492382, 3.464101615137747, 10.00000000000007 },
            { 0.0916666666666776, -1.016666666666668, 1.508333333333339, 2.183333333333338, -5.866666666666669, 3.683333333333319, 1.091666666666681, -0.1833333333333492, 0.5083333333333364, -2.357022603955106, 1.587713240271576, 11.08333333333335, -1.649915822768633, -3.897114317029965, -12.91666666666648 },
            { 1.008333333333331, 0.06666666666665785, 1.591666666666679, 1.508333333333338, -2.600000000000005, 1.091666666666681, 2.633333333333338, -2.016666666666662, -0.03333333333332997, 5.892556509887863, 17.46484564298616, 9.416666666666778, -7.542472332656556, -6.062177826491021, -3.333333333333458 },
            { -1.266666666666662, -1.633333333333331, 0.06666666666666365, -1.016666666666673, 1.200000000000001, -0.1833333333333492, -2.016666666666662, 2.533333333333323, 0.8166666666666678, -11.78511301977576, -21.93931022920572, 3.666666666666621, 8.013876853447588, 7.794228634059837, -5.833333333333258 },
            { -0.4083333333333342, -1.266666666666676, 1.008333333333341, 0.09166666666667461, -0.6000000000000195, 0.5083333333333364, -0.03333333333332997, 0.8166666666666678, 0.6333333333333396, -5.892556509887926, -7.072540797572938, 8.583333333333396, 1.885618083164155, 2.59807621135334, -6.666666666666602 },
            { 5.892556509887882, 11.78511301977582, -5.892556509887917, 2.357022603955155, 0.0, -2.357022603955106, 5.892556509887863, -11.78511301977576, -5.892556509887926, 66.66666666666663, 102.0620726159656, -58.92556509887905, -33.3333333333336, -36.74234614174736, 54.21151989096813 },
            { 10.96965511460287, 14.14508159514583, -0.5773502691896049, 8.804591605141795, -10.39230484541319, 1.587713240271576, 17.46484564298616, -21.93931022920572, -7.072540797572938, 102.0620726159656, 189.9999999999997, -31.75426480542914, -69.40220937885722, -67.49999999999947, 50.51814855409111 },
            { -1.833333333333315, -17.16666666666676, 19.83333333333346, 6.916666666666707, -18.00000000000012, 11.08333333333335, 9.416666666666778, 3.666666666666621, 8.583333333333396, -58.92556509887905, -31.75426480542914, 153.3333333333343, -2.357022603955171, 12.99038105676631, -104.1666666666669 },
            { -4.006938426723796, -3.771236166328295, -1.649915822768618, -4.006938426723814, 5.656854249492382, -1.649915822768633, -7.542472332656556, 8.013876853447588, 1.885618083164155, -33.3333333333336, -69.40220937885722, -2.357022603955171, 26.66666666666707, 24.49489742783154, -9.428090415820876 },
            { -3.897114317029904, -5.196152422706626, 0.4330127018922103, 0.433012701892225, 3.464101615137747, -3.897114317029965, -6.062177826491021, 7.794228634059837, 2.59807621135334, -36.74234614174736, -67.49999999999947, 12.99038105676631, 24.49489742783154, 59.99999999999987, 43.30127018922236 },
            { 2.916666666666659, 13.33333333333325, -12.91666666666669, 2.916666666666606, 10.00000000000007, -12.91666666666648, -3.333333333333458, -5.833333333333258, -6.666666666666602, 54.21151989096813, 50.51814855409111, -104.1666666666669, -9.428090415820876, 43.30127018922236, 183.3333333333317 } } };
    // Unstructured piecewise computations
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q6[0][0][1];
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q6[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q6[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q6[0][0][1];
    alignas(32) double sp[36];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c3 / sp[2];
    sp[4] = -1 * J_c2 / sp[2];
    sp[5] = J_c0 / sp[2];
    sp[6] = sp[5] * sp[3];
    sp[7] = sp[5] * sp[4];
    sp[8] = -1 * J_c1 / sp[2];
    sp[9] = sp[3] * sp[8];
    sp[10] = sp[8] * sp[4];
    sp[11] = -1 * sp[10] + sp[6];
    sp[12] = -1 * sp[7] + sp[7];
    sp[13] = -1 * sp[9] + sp[9];
    sp[14] = -1 * sp[6] + sp[10];
    sp[15] = sp[11] * sp[11];
    sp[16] = sp[11] * sp[12];
    sp[17] = sp[11] * sp[13];
    sp[18] = sp[11] * sp[14];
    sp[19] = sp[12] * sp[12];
    sp[20] = sp[13] * sp[12];
    sp[21] = sp[12] * sp[14];
    sp[22] = sp[13] * sp[13];
    sp[23] = sp[13] * sp[14];
    sp[24] = sp[14] * sp[14];
    sp[25] = std::abs(sp[2]);
    sp[26] = sp[15] * sp[25];
    sp[27] = sp[16] * sp[25];
    sp[28] = sp[17] * sp[25];
    sp[29] = sp[18] * sp[25];
    sp[30] = sp[19] * sp[25];
    sp[31] = sp[20] * sp[25];
    sp[32] = sp[21] * sp[25];
    sp[33] = sp[22] * sp[25];
    sp[34] = sp[23] * sp[25];
    sp[35] = sp[24] * sp[25];
    A[0] = sp[33] * PI0[0][0][0] + sp[34] * PI1[0][0][0] + sp[28] * PI2[0][0][0] + sp[31] * PI3[0][0][0] + sp[34] * PI1[0][0][0] + sp[35] * PI4[0][0][0] + sp[29] * PI5[0][0][0] + sp[32] * PI6[0][0][0] + sp[28] * PI2[0][0][0] + sp[29] * PI5[0][0][0] + sp[26] * PI7[0][0][0] + sp[27] * PI8[0][0][0] + sp[31] * PI3[0][0][0] + sp[32] * PI6[0][0][0] + sp[27] * PI8[0][0][0] + sp[30] * PI9[0][0][0];
    A[1] = sp[33] * PI0[0][0][1] + sp[34] * PI1[0][0][1] + sp[28] * PI2[0][0][1] + sp[31] * PI3[0][0][1] + sp[34] * PI1[0][1][0] + sp[35] * PI4[0][0][1] + sp[29] * PI5[0][0][1] + sp[32] * PI6[0][0][1] + sp[28] * PI2[0][1][0] + sp[29] * PI5[0][1][0] + sp[26] * PI7[0][0][1] + sp[27] * PI8[0][0][1] + sp[31] * PI3[0][1][0] + sp[32] * PI6[0][1][0] + sp[27] * PI8[0][1][0] + sp[30] * PI9[0][0][1];
    A[2] = sp[33] * PI0[0][0][2] + sp[34] * PI1[0][0][2] + sp[28] * PI2[0][0][2] + sp[31] * PI3[0][0][2] + sp[34] * PI1[0][2][0] + sp[35] * PI4[0][0][2] + sp[29] * PI5[0][0][2] + sp[32] * PI6[0][0][2] + sp[28] * PI2[0][2][0] + sp[29] * PI5[0][2][0] + sp[26] * PI7[0][0][2] + sp[27] * PI8[0][0][2] + sp[31] * PI3[0][2][0] + sp[32] * PI6[0][2][0] + sp[27] * PI8[0][2][0] + sp[30] * PI9[0][0][2];
    A[3] = sp[33] * PI0[0][0][3] + sp[34] * PI1[0][0][3] + sp[28] * PI2[0][0][3] + sp[31] * PI3[0][0][3] + sp[34] * PI1[0][3][0] + sp[35] * PI4[0][0][3] + sp[29] * PI5[0][0][3] + sp[32] * PI6[0][0][3] + sp[28] * PI2[0][3][0] + sp[29] * PI5[0][3][0] + sp[26] * PI7[0][0][3] + sp[27] * PI8[0][0][3] + sp[31] * PI3[0][3][0] + sp[32] * PI6[0][3][0] + sp[27] * PI8[0][3][0] + sp[30] * PI9[0][0][3];
    A[4] = sp[33] * PI0[0][0][4] + sp[34] * PI1[0][0][4] + sp[28] * PI2[0][0][4] + sp[31] * PI3[0][0][4] + sp[34] * PI1[0][4][0] + sp[35] * PI4[0][0][4] + sp[29] * PI5[0][0][4] + sp[32] * PI6[0][0][4] + sp[28] * PI2[0][4][0] + sp[29] * PI5[0][4][0] + sp[26] * PI7[0][0][4] + sp[27] * PI8[0][0][4] + sp[31] * PI3[0][4][0] + sp[32] * PI6[0][4][0] + sp[27] * PI8[0][4][0] + sp[30] * PI9[0][0][4];
    A[5] = sp[33] * PI0[0][0][5] + sp[34] * PI1[0][0][5] + sp[28] * PI2[0][0][5] + sp[31] * PI3[0][0][5] + sp[34] * PI1[0][5][0] + sp[35] * PI4[0][0][5] + sp[29] * PI5[0][0][5] + sp[32] * PI6[0][0][5] + sp[28] * PI2[0][5][0] + sp[29] * PI5[0][5][0] + sp[26] * PI7[0][0][5] + sp[27] * PI8[0][0][5] + sp[31] * PI3[0][5][0] + sp[32] * PI6[0][5][0] + sp[27] * PI8[0][5][0] + sp[30] * PI9[0][0][5];
    A[6] = sp[33] * PI0[0][0][6] + sp[34] * PI1[0][0][6] + sp[28] * PI2[0][0][6] + sp[31] * PI3[0][0][6] + sp[34] * PI1[0][6][0] + sp[35] * PI4[0][0][6] + sp[29] * PI5[0][0][6] + sp[32] * PI6[0][0][6] + sp[28] * PI2[0][6][0] + sp[29] * PI5[0][6][0] + sp[26] * PI7[0][0][6] + sp[27] * PI8[0][0][6] + sp[31] * PI3[0][6][0] + sp[32] * PI6[0][6][0] + sp[27] * PI8[0][6][0] + sp[30] * PI9[0][0][6];
    A[7] = sp[33] * PI0[0][0][7] + sp[34] * PI1[0][0][7] + sp[28] * PI2[0][0][7] + sp[31] * PI3[0][0][7] + sp[34] * PI1[0][7][0] + sp[35] * PI4[0][0][7] + sp[29] * PI5[0][0][7] + sp[32] * PI6[0][0][7] + sp[28] * PI2[0][7][0] + sp[29] * PI5[0][7][0] + sp[26] * PI7[0][0][7] + sp[27] * PI8[0][0][7] + sp[31] * PI3[0][7][0] + sp[32] * PI6[0][7][0] + sp[27] * PI8[0][7][0] + sp[30] * PI9[0][0][7];
    A[8] = sp[33] * PI0[0][0][8] + sp[34] * PI1[0][0][8] + sp[28] * PI2[0][0][8] + sp[31] * PI3[0][0][8] + sp[34] * PI1[0][8][0] + sp[35] * PI4[0][0][8] + sp[29] * PI5[0][0][8] + sp[32] * PI6[0][0][8] + sp[28] * PI2[0][8][0] + sp[29] * PI5[0][8][0] + sp[26] * PI7[0][0][8] + sp[27] * PI8[0][0][8] + sp[31] * PI3[0][8][0] + sp[32] * PI6[0][8][0] + sp[27] * PI8[0][8][0] + sp[30] * PI9[0][0][8];
    A[9] = sp[33] * PI0[0][0][9] + sp[34] * PI1[0][0][9] + sp[28] * PI2[0][0][9] + sp[31] * PI3[0][0][9] + sp[34] * PI1[0][9][0] + sp[35] * PI4[0][0][9] + sp[29] * PI5[0][0][9] + sp[32] * PI6[0][0][9] + sp[28] * PI2[0][9][0] + sp[29] * PI5[0][9][0] + sp[26] * PI7[0][0][9] + sp[27] * PI8[0][0][9] + sp[31] * PI3[0][9][0] + sp[32] * PI6[0][9][0] + sp[27] * PI8[0][9][0] + sp[30] * PI9[0][0][9];
    A[10] = sp[33] * PI0[0][0][10] + sp[34] * PI1[0][0][10] + sp[28] * PI2[0][0][10] + sp[31] * PI3[0][0][10] + sp[34] * PI1[0][10][0] + sp[35] * PI4[0][0][10] + sp[29] * PI5[0][0][10] + sp[32] * PI6[0][0][10] + sp[28] * PI2[0][10][0] + sp[29] * PI5[0][10][0] + sp[26] * PI7[0][0][10] + sp[27] * PI8[0][0][10] + sp[31] * PI3[0][10][0] + sp[32] * PI6[0][10][0] + sp[27] * PI8[0][10][0] + sp[30] * PI9[0][0][10];
    A[11] = sp[33] * PI0[0][0][11] + sp[34] * PI1[0][0][11] + sp[28] * PI2[0][0][11] + sp[31] * PI3[0][0][11] + sp[34] * PI1[0][11][0] + sp[35] * PI4[0][0][11] + sp[29] * PI5[0][0][11] + sp[32] * PI6[0][0][11] + sp[28] * PI2[0][11][0] + sp[29] * PI5[0][11][0] + sp[26] * PI7[0][0][11] + sp[27] * PI8[0][0][11] + sp[31] * PI3[0][11][0] + sp[32] * PI6[0][11][0] + sp[27] * PI8[0][11][0] + sp[30] * PI9[0][0][11];
    A[12] = sp[33] * PI0[0][0][12] + sp[34] * PI1[0][0][12] + sp[28] * PI2[0][0][12] + sp[31] * PI3[0][0][12] + sp[34] * PI1[0][12][0] + sp[35] * PI4[0][0][12] + sp[29] * PI5[0][0][12] + sp[32] * PI6[0][0][12] + sp[28] * PI2[0][12][0] + sp[29] * PI5[0][12][0] + sp[26] * PI7[0][0][12] + sp[27] * PI8[0][0][12] + sp[31] * PI3[0][12][0] + sp[32] * PI6[0][12][0] + sp[27] * PI8[0][12][0] + sp[30] * PI9[0][0][12];
    A[13] = sp[33] * PI0[0][0][13] + sp[34] * PI1[0][0][13] + sp[28] * PI2[0][0][13] + sp[31] * PI3[0][0][13] + sp[34] * PI1[0][13][0] + sp[35] * PI4[0][0][13] + sp[29] * PI5[0][0][13] + sp[32] * PI6[0][0][13] + sp[28] * PI2[0][13][0] + sp[29] * PI5[0][13][0] + sp[26] * PI7[0][0][13] + sp[27] * PI8[0][0][13] + sp[31] * PI3[0][13][0] + sp[32] * PI6[0][13][0] + sp[27] * PI8[0][13][0] + sp[30] * PI9[0][0][13];
    A[14] = sp[33] * PI0[0][0][14] + sp[34] * PI1[0][0][14] + sp[28] * PI2[0][0][14] + sp[31] * PI3[0][0][14] + sp[34] * PI1[0][14][0] + sp[35] * PI4[0][0][14] + sp[29] * PI5[0][0][14] + sp[32] * PI6[0][0][14] + sp[28] * PI2[0][14][0] + sp[29] * PI5[0][14][0] + sp[26] * PI7[0][0][14] + sp[27] * PI8[0][0][14] + sp[31] * PI3[0][14][0] + sp[32] * PI6[0][14][0] + sp[27] * PI8[0][14][0] + sp[30] * PI9[0][0][14];
    A[15] = sp[33] * PI0[0][1][0] + sp[34] * PI1[0][1][0] + sp[28] * PI2[0][1][0] + sp[31] * PI3[0][1][0] + sp[34] * PI1[0][0][1] + sp[35] * PI4[0][1][0] + sp[29] * PI5[0][1][0] + sp[32] * PI6[0][1][0] + sp[28] * PI2[0][0][1] + sp[29] * PI5[0][0][1] + sp[26] * PI7[0][1][0] + sp[27] * PI8[0][1][0] + sp[31] * PI3[0][0][1] + sp[32] * PI6[0][0][1] + sp[27] * PI8[0][0][1] + sp[30] * PI9[0][1][0];
    A[16] = sp[33] * PI0[0][1][1] + sp[34] * PI1[0][1][1] + sp[28] * PI2[0][1][1] + sp[31] * PI3[0][1][1] + sp[34] * PI1[0][1][1] + sp[35] * PI4[0][1][1] + sp[29] * PI5[0][1][1] + sp[32] * PI6[0][1][1] + sp[28] * PI2[0][1][1] + sp[29] * PI5[0][1][1] + sp[26] * PI7[0][1][1] + sp[27] * PI8[0][1][1] + sp[31] * PI3[0][1][1] + sp[32] * PI6[0][1][1] + sp[27] * PI8[0][1][1] + sp[30] * PI9[0][1][1];
    A[17] = sp[33] * PI0[0][1][2] + sp[34] * PI1[0][1][2] + sp[28] * PI2[0][1][2] + sp[31] * PI3[0][1][2] + sp[34] * PI1[0][2][1] + sp[35] * PI4[0][1][2] + sp[29] * PI5[0][1][2] + sp[32] * PI6[0][1][2] + sp[28] * PI2[0][2][1] + sp[29] * PI5[0][2][1] + sp[26] * PI7[0][1][2] + sp[27] * PI8[0][1][2] + sp[31] * PI3[0][2][1] + sp[32] * PI6[0][2][1] + sp[27] * PI8[0][2][1] + sp[30] * PI9[0][1][2];
    A[18] = sp[33] * PI0[0][1][3] + sp[34] * PI1[0][1][3] + sp[28] * PI2[0][1][3] + sp[31] * PI3[0][1][3] + sp[34] * PI1[0][3][1] + sp[35] * PI4[0][1][3] + sp[29] * PI5[0][1][3] + sp[32] * PI6[0][1][3] + sp[28] * PI2[0][3][1] + sp[29] * PI5[0][3][1] + sp[26] * PI7[0][1][3] + sp[27] * PI8[0][1][3] + sp[31] * PI3[0][3][1] + sp[32] * PI6[0][3][1] + sp[27] * PI8[0][3][1] + sp[30] * PI9[0][1][3];
    A[19] = sp[33] * PI0[0][1][4] + sp[34] * PI1[0][1][4] + sp[28] * PI2[0][1][4] + sp[31] * PI3[0][1][4] + sp[34] * PI1[0][4][1] + sp[35] * PI4[0][1][4] + sp[29] * PI5[0][1][4] + sp[32] * PI6[0][1][4] + sp[28] * PI2[0][4][1] + sp[29] * PI5[0][4][1] + sp[26] * PI7[0][1][4] + sp[27] * PI8[0][1][4] + sp[31] * PI3[0][4][1] + sp[32] * PI6[0][4][1] + sp[27] * PI8[0][4][1] + sp[30] * PI9[0][1][4];
    A[20] = sp[33] * PI0[0][1][5] + sp[34] * PI1[0][1][5] + sp[28] * PI2[0][1][5] + sp[31] * PI3[0][1][5] + sp[34] * PI1[0][5][1] + sp[35] * PI4[0][1][5] + sp[29] * PI5[0][1][5] + sp[32] * PI6[0][1][5] + sp[28] * PI2[0][5][1] + sp[29] * PI5[0][5][1] + sp[26] * PI7[0][1][5] + sp[27] * PI8[0][1][5] + sp[31] * PI3[0][5][1] + sp[32] * PI6[0][5][1] + sp[27] * PI8[0][5][1] + sp[30] * PI9[0][1][5];
    A[21] = sp[33] * PI0[0][1][6] + sp[34] * PI1[0][1][6] + sp[28] * PI2[0][1][6] + sp[31] * PI3[0][1][6] + sp[34] * PI1[0][6][1] + sp[35] * PI4[0][1][6] + sp[29] * PI5[0][1][6] + sp[32] * PI6[0][1][6] + sp[28] * PI2[0][6][1] + sp[29] * PI5[0][6][1] + sp[26] * PI7[0][1][6] + sp[27] * PI8[0][1][6] + sp[31] * PI3[0][6][1] + sp[32] * PI6[0][6][1] + sp[27] * PI8[0][6][1] + sp[30] * PI9[0][1][6];
    A[22] = sp[33] * PI0[0][1][7] + sp[34] * PI1[0][1][7] + sp[28] * PI2[0][1][7] + sp[31] * PI3[0][1][7] + sp[34] * PI1[0][7][1] + sp[35] * PI4[0][1][7] + sp[29] * PI5[0][1][7] + sp[32] * PI6[0][1][7] + sp[28] * PI2[0][7][1] + sp[29] * PI5[0][7][1] + sp[26] * PI7[0][1][7] + sp[27] * PI8[0][1][7] + sp[31] * PI3[0][7][1] + sp[32] * PI6[0][7][1] + sp[27] * PI8[0][7][1] + sp[30] * PI9[0][1][7];
    A[23] = sp[33] * PI0[0][1][8] + sp[34] * PI1[0][1][8] + sp[28] * PI2[0][1][8] + sp[31] * PI3[0][1][8] + sp[34] * PI1[0][8][1] + sp[35] * PI4[0][1][8] + sp[29] * PI5[0][1][8] + sp[32] * PI6[0][1][8] + sp[28] * PI2[0][8][1] + sp[29] * PI5[0][8][1] + sp[26] * PI7[0][1][8] + sp[27] * PI8[0][1][8] + sp[31] * PI3[0][8][1] + sp[32] * PI6[0][8][1] + sp[27] * PI8[0][8][1] + sp[30] * PI9[0][1][8];
    A[24] = sp[33] * PI0[0][1][9] + sp[34] * PI1[0][1][9] + sp[28] * PI2[0][1][9] + sp[31] * PI3[0][1][9] + sp[34] * PI1[0][9][1] + sp[35] * PI4[0][1][9] + sp[29] * PI5[0][1][9] + sp[32] * PI6[0][1][9] + sp[28] * PI2[0][9][1] + sp[29] * PI5[0][9][1] + sp[26] * PI7[0][1][9] + sp[27] * PI8[0][1][9] + sp[31] * PI3[0][9][1] + sp[32] * PI6[0][9][1] + sp[27] * PI8[0][9][1] + sp[30] * PI9[0][1][9];
    A[25] = sp[33] * PI0[0][1][10] + sp[34] * PI1[0][1][10] + sp[28] * PI2[0][1][10] + sp[31] * PI3[0][1][10] + sp[34] * PI1[0][10][1] + sp[35] * PI4[0][1][10] + sp[29] * PI5[0][1][10] + sp[32] * PI6[0][1][10] + sp[28] * PI2[0][10][1] + sp[29] * PI5[0][10][1] + sp[26] * PI7[0][1][10] + sp[27] * PI8[0][1][10] + sp[31] * PI3[0][10][1] + sp[32] * PI6[0][10][1] + sp[27] * PI8[0][10][1] + sp[30] * PI9[0][1][10];
    A[26] = sp[33] * PI0[0][1][11] + sp[34] * PI1[0][1][11] + sp[28] * PI2[0][1][11] + sp[31] * PI3[0][1][11] + sp[34] * PI1[0][11][1] + sp[35] * PI4[0][1][11] + sp[29] * PI5[0][1][11] + sp[32] * PI6[0][1][11] + sp[28] * PI2[0][11][1] + sp[29] * PI5[0][11][1] + sp[26] * PI7[0][1][11] + sp[27] * PI8[0][1][11] + sp[31] * PI3[0][11][1] + sp[32] * PI6[0][11][1] + sp[27] * PI8[0][11][1] + sp[30] * PI9[0][1][11];
    A[27] = sp[33] * PI0[0][1][12] + sp[34] * PI1[0][1][12] + sp[28] * PI2[0][1][12] + sp[31] * PI3[0][1][12] + sp[34] * PI1[0][12][1] + sp[35] * PI4[0][1][12] + sp[29] * PI5[0][1][12] + sp[32] * PI6[0][1][12] + sp[28] * PI2[0][12][1] + sp[29] * PI5[0][12][1] + sp[26] * PI7[0][1][12] + sp[27] * PI8[0][1][12] + sp[31] * PI3[0][12][1] + sp[32] * PI6[0][12][1] + sp[27] * PI8[0][12][1] + sp[30] * PI9[0][1][12];
    A[28] = sp[33] * PI0[0][1][13] + sp[34] * PI1[0][1][13] + sp[28] * PI2[0][1][13] + sp[31] * PI3[0][1][13] + sp[34] * PI1[0][13][1] + sp[35] * PI4[0][1][13] + sp[29] * PI5[0][1][13] + sp[32] * PI6[0][1][13] + sp[28] * PI2[0][13][1] + sp[29] * PI5[0][13][1] + sp[26] * PI7[0][1][13] + sp[27] * PI8[0][1][13] + sp[31] * PI3[0][13][1] + sp[32] * PI6[0][13][1] + sp[27] * PI8[0][13][1] + sp[30] * PI9[0][1][13];
    A[29] = sp[33] * PI0[0][1][14] + sp[34] * PI1[0][1][14] + sp[28] * PI2[0][1][14] + sp[31] * PI3[0][1][14] + sp[34] * PI1[0][14][1] + sp[35] * PI4[0][1][14] + sp[29] * PI5[0][1][14] + sp[32] * PI6[0][1][14] + sp[28] * PI2[0][14][1] + sp[29] * PI5[0][14][1] + sp[26] * PI7[0][1][14] + sp[27] * PI8[0][1][14] + sp[31] * PI3[0][14][1] + sp[32] * PI6[0][14][1] + sp[27] * PI8[0][14][1] + sp[30] * PI9[0][1][14];
    A[30] = sp[33] * PI0[0][2][0] + sp[34] * PI1[0][2][0] + sp[28] * PI2[0][2][0] + sp[31] * PI3[0][2][0] + sp[34] * PI1[0][0][2] + sp[35] * PI4[0][2][0] + sp[29] * PI5[0][2][0] + sp[32] * PI6[0][2][0] + sp[28] * PI2[0][0][2] + sp[29] * PI5[0][0][2] + sp[26] * PI7[0][2][0] + sp[27] * PI8[0][2][0] + sp[31] * PI3[0][0][2] + sp[32] * PI6[0][0][2] + sp[27] * PI8[0][0][2] + sp[30] * PI9[0][2][0];
    A[31] = sp[33] * PI0[0][2][1] + sp[34] * PI1[0][2][1] + sp[28] * PI2[0][2][1] + sp[31] * PI3[0][2][1] + sp[34] * PI1[0][1][2] + sp[35] * PI4[0][2][1] + sp[29] * PI5[0][2][1] + sp[32] * PI6[0][2][1] + sp[28] * PI2[0][1][2] + sp[29] * PI5[0][1][2] + sp[26] * PI7[0][2][1] + sp[27] * PI8[0][2][1] + sp[31] * PI3[0][1][2] + sp[32] * PI6[0][1][2] + sp[27] * PI8[0][1][2] + sp[30] * PI9[0][2][1];
    A[32] = sp[33] * PI0[0][2][2] + sp[34] * PI1[0][2][2] + sp[28] * PI2[0][2][2] + sp[31] * PI3[0][2][2] + sp[34] * PI1[0][2][2] + sp[35] * PI4[0][2][2] + sp[29] * PI5[0][2][2] + sp[32] * PI6[0][2][2] + sp[28] * PI2[0][2][2] + sp[29] * PI5[0][2][2] + sp[26] * PI7[0][2][2] + sp[27] * PI8[0][2][2] + sp[31] * PI3[0][2][2] + sp[32] * PI6[0][2][2] + sp[27] * PI8[0][2][2] + sp[30] * PI9[0][2][2];
    A[33] = sp[33] * PI0[0][2][3] + sp[34] * PI1[0][2][3] + sp[28] * PI2[0][2][3] + sp[31] * PI3[0][2][3] + sp[34] * PI1[0][3][2] + sp[35] * PI4[0][2][3] + sp[29] * PI5[0][2][3] + sp[32] * PI6[0][2][3] + sp[28] * PI2[0][3][2] + sp[29] * PI5[0][3][2] + sp[26] * PI7[0][2][3] + sp[27] * PI8[0][2][3] + sp[31] * PI3[0][3][2] + sp[32] * PI6[0][3][2] + sp[27] * PI8[0][3][2] + sp[30] * PI9[0][2][3];
    A[34] = sp[33] * PI0[0][2][4] + sp[34] * PI1[0][2][4] + sp[28] * PI2[0][2][4] + sp[31] * PI3[0][2][4] + sp[34] * PI1[0][4][2] + sp[35] * PI4[0][2][4] + sp[29] * PI5[0][2][4] + sp[32] * PI6[0][2][4] + sp[28] * PI2[0][4][2] + sp[29] * PI5[0][4][2] + sp[26] * PI7[0][2][4] + sp[27] * PI8[0][2][4] + sp[31] * PI3[0][4][2] + sp[32] * PI6[0][4][2] + sp[27] * PI8[0][4][2] + sp[30] * PI9[0][2][4];
    A[35] = sp[33] * PI0[0][2][5] + sp[34] * PI1[0][2][5] + sp[28] * PI2[0][2][5] + sp[31] * PI3[0][2][5] + sp[34] * PI1[0][5][2] + sp[35] * PI4[0][2][5] + sp[29] * PI5[0][2][5] + sp[32] * PI6[0][2][5] + sp[28] * PI2[0][5][2] + sp[29] * PI5[0][5][2] + sp[26] * PI7[0][2][5] + sp[27] * PI8[0][2][5] + sp[31] * PI3[0][5][2] + sp[32] * PI6[0][5][2] + sp[27] * PI8[0][5][2] + sp[30] * PI9[0][2][5];
    A[36] = sp[33] * PI0[0][2][6] + sp[34] * PI1[0][2][6] + sp[28] * PI2[0][2][6] + sp[31] * PI3[0][2][6] + sp[34] * PI1[0][6][2] + sp[35] * PI4[0][2][6] + sp[29] * PI5[0][2][6] + sp[32] * PI6[0][2][6] + sp[28] * PI2[0][6][2] + sp[29] * PI5[0][6][2] + sp[26] * PI7[0][2][6] + sp[27] * PI8[0][2][6] + sp[31] * PI3[0][6][2] + sp[32] * PI6[0][6][2] + sp[27] * PI8[0][6][2] + sp[30] * PI9[0][2][6];
    A[37] = sp[33] * PI0[0][2][7] + sp[34] * PI1[0][2][7] + sp[28] * PI2[0][2][7] + sp[31] * PI3[0][2][7] + sp[34] * PI1[0][7][2] + sp[35] * PI4[0][2][7] + sp[29] * PI5[0][2][7] + sp[32] * PI6[0][2][7] + sp[28] * PI2[0][7][2] + sp[29] * PI5[0][7][2] + sp[26] * PI7[0][2][7] + sp[27] * PI8[0][2][7] + sp[31] * PI3[0][7][2] + sp[32] * PI6[0][7][2] + sp[27] * PI8[0][7][2] + sp[30] * PI9[0][2][7];
    A[38] = sp[33] * PI0[0][2][8] + sp[34] * PI1[0][2][8] + sp[28] * PI2[0][2][8] + sp[31] * PI3[0][2][8] + sp[34] * PI1[0][8][2] + sp[35] * PI4[0][2][8] + sp[29] * PI5[0][2][8] + sp[32] * PI6[0][2][8] + sp[28] * PI2[0][8][2] + sp[29] * PI5[0][8][2] + sp[26] * PI7[0][2][8] + sp[27] * PI8[0][2][8] + sp[31] * PI3[0][8][2] + sp[32] * PI6[0][8][2] + sp[27] * PI8[0][8][2] + sp[30] * PI9[0][2][8];
    A[39] = sp[33] * PI0[0][2][9] + sp[34] * PI1[0][2][9] + sp[28] * PI2[0][2][9] + sp[31] * PI3[0][2][9] + sp[34] * PI1[0][9][2] + sp[35] * PI4[0][2][9] + sp[29] * PI5[0][2][9] + sp[32] * PI6[0][2][9] + sp[28] * PI2[0][9][2] + sp[29] * PI5[0][9][2] + sp[26] * PI7[0][2][9] + sp[27] * PI8[0][2][9] + sp[31] * PI3[0][9][2] + sp[32] * PI6[0][9][2] + sp[27] * PI8[0][9][2] + sp[30] * PI9[0][2][9];
    A[40] = sp[33] * PI0[0][2][10] + sp[34] * PI1[0][2][10] + sp[28] * PI2[0][2][10] + sp[31] * PI3[0][2][10] + sp[34] * PI1[0][10][2] + sp[35] * PI4[0][2][10] + sp[29] * PI5[0][2][10] + sp[32] * PI6[0][2][10] + sp[28] * PI2[0][10][2] + sp[29] * PI5[0][10][2] + sp[26] * PI7[0][2][10] + sp[27] * PI8[0][2][10] + sp[31] * PI3[0][10][2] + sp[32] * PI6[0][10][2] + sp[27] * PI8[0][10][2] + sp[30] * PI9[0][2][10];
    A[41] = sp[33] * PI0[0][2][11] + sp[34] * PI1[0][2][11] + sp[28] * PI2[0][2][11] + sp[31] * PI3[0][2][11] + sp[34] * PI1[0][11][2] + sp[35] * PI4[0][2][11] + sp[29] * PI5[0][2][11] + sp[32] * PI6[0][2][11] + sp[28] * PI2[0][11][2] + sp[29] * PI5[0][11][2] + sp[26] * PI7[0][2][11] + sp[27] * PI8[0][2][11] + sp[31] * PI3[0][11][2] + sp[32] * PI6[0][11][2] + sp[27] * PI8[0][11][2] + sp[30] * PI9[0][2][11];
    A[42] = sp[33] * PI0[0][2][12] + sp[34] * PI1[0][2][12] + sp[28] * PI2[0][2][12] + sp[31] * PI3[0][2][12] + sp[34] * PI1[0][12][2] + sp[35] * PI4[0][2][12] + sp[29] * PI5[0][2][12] + sp[32] * PI6[0][2][12] + sp[28] * PI2[0][12][2] + sp[29] * PI5[0][12][2] + sp[26] * PI7[0][2][12] + sp[27] * PI8[0][2][12] + sp[31] * PI3[0][12][2] + sp[32] * PI6[0][12][2] + sp[27] * PI8[0][12][2] + sp[30] * PI9[0][2][12];
    A[43] = sp[33] * PI0[0][2][13] + sp[34] * PI1[0][2][13] + sp[28] * PI2[0][2][13] + sp[31] * PI3[0][2][13] + sp[34] * PI1[0][13][2] + sp[35] * PI4[0][2][13] + sp[29] * PI5[0][2][13] + sp[32] * PI6[0][2][13] + sp[28] * PI2[0][13][2] + sp[29] * PI5[0][13][2] + sp[26] * PI7[0][2][13] + sp[27] * PI8[0][2][13] + sp[31] * PI3[0][13][2] + sp[32] * PI6[0][13][2] + sp[27] * PI8[0][13][2] + sp[30] * PI9[0][2][13];
    A[44] = sp[33] * PI0[0][2][14] + sp[34] * PI1[0][2][14] + sp[28] * PI2[0][2][14] + sp[31] * PI3[0][2][14] + sp[34] * PI1[0][14][2] + sp[35] * PI4[0][2][14] + sp[29] * PI5[0][2][14] + sp[32] * PI6[0][2][14] + sp[28] * PI2[0][14][2] + sp[29] * PI5[0][14][2] + sp[26] * PI7[0][2][14] + sp[27] * PI8[0][2][14] + sp[31] * PI3[0][14][2] + sp[32] * PI6[0][14][2] + sp[27] * PI8[0][14][2] + sp[30] * PI9[0][2][14];
    A[45] = sp[33] * PI0[0][3][0] + sp[34] * PI1[0][3][0] + sp[28] * PI2[0][3][0] + sp[31] * PI3[0][3][0] + sp[34] * PI1[0][0][3] + sp[35] * PI4[0][3][0] + sp[29] * PI5[0][3][0] + sp[32] * PI6[0][3][0] + sp[28] * PI2[0][0][3] + sp[29] * PI5[0][0][3] + sp[26] * PI7[0][3][0] + sp[27] * PI8[0][3][0] + sp[31] * PI3[0][0][3] + sp[32] * PI6[0][0][3] + sp[27] * PI8[0][0][3] + sp[30] * PI9[0][3][0];
    A[46] = sp[33] * PI0[0][3][1] + sp[34] * PI1[0][3][1] + sp[28] * PI2[0][3][1] + sp[31] * PI3[0][3][1] + sp[34] * PI1[0][1][3] + sp[35] * PI4[0][3][1] + sp[29] * PI5[0][3][1] + sp[32] * PI6[0][3][1] + sp[28] * PI2[0][1][3] + sp[29] * PI5[0][1][3] + sp[26] * PI7[0][3][1] + sp[27] * PI8[0][3][1] + sp[31] * PI3[0][1][3] + sp[32] * PI6[0][1][3] + sp[27] * PI8[0][1][3] + sp[30] * PI9[0][3][1];
    A[47] = sp[33] * PI0[0][3][2] + sp[34] * PI1[0][3][2] + sp[28] * PI2[0][3][2] + sp[31] * PI3[0][3][2] + sp[34] * PI1[0][2][3] + sp[35] * PI4[0][3][2] + sp[29] * PI5[0][3][2] + sp[32] * PI6[0][3][2] + sp[28] * PI2[0][2][3] + sp[29] * PI5[0][2][3] + sp[26] * PI7[0][3][2] + sp[27] * PI8[0][3][2] + sp[31] * PI3[0][2][3] + sp[32] * PI6[0][2][3] + sp[27] * PI8[0][2][3] + sp[30] * PI9[0][3][2];
    A[48] = sp[33] * PI0[0][3][3] + sp[34] * PI1[0][3][3] + sp[28] * PI2[0][3][3] + sp[31] * PI3[0][3][3] + sp[34] * PI1[0][3][3] + sp[35] * PI4[0][3][3] + sp[29] * PI5[0][3][3] + sp[32] * PI6[0][3][3] + sp[28] * PI2[0][3][3] + sp[29] * PI5[0][3][3] + sp[26] * PI7[0][3][3] + sp[27] * PI8[0][3][3] + sp[31] * PI3[0][3][3] + sp[32] * PI6[0][3][3] + sp[27] * PI8[0][3][3] + sp[30] * PI9[0][3][3];
    A[49] = sp[33] * PI0[0][3][4] + sp[34] * PI1[0][3][4] + sp[28] * PI2[0][3][4] + sp[31] * PI3[0][3][4] + sp[34] * PI1[0][4][3] + sp[35] * PI4[0][3][4] + sp[29] * PI5[0][3][4] + sp[32] * PI6[0][3][4] + sp[28] * PI2[0][4][3] + sp[29] * PI5[0][4][3] + sp[26] * PI7[0][3][4] + sp[27] * PI8[0][3][4] + sp[31] * PI3[0][4][3] + sp[32] * PI6[0][4][3] + sp[27] * PI8[0][4][3] + sp[30] * PI9[0][3][4];
    A[50] = sp[33] * PI0[0][3][5] + sp[34] * PI1[0][3][5] + sp[28] * PI2[0][3][5] + sp[31] * PI3[0][3][5] + sp[34] * PI1[0][5][3] + sp[35] * PI4[0][3][5] + sp[29] * PI5[0][3][5] + sp[32] * PI6[0][3][5] + sp[28] * PI2[0][5][3] + sp[29] * PI5[0][5][3] + sp[26] * PI7[0][3][5] + sp[27] * PI8[0][3][5] + sp[31] * PI3[0][5][3] + sp[32] * PI6[0][5][3] + sp[27] * PI8[0][5][3] + sp[30] * PI9[0][3][5];
    A[51] = sp[33] * PI0[0][3][6] + sp[34] * PI1[0][3][6] + sp[28] * PI2[0][3][6] + sp[31] * PI3[0][3][6] + sp[34] * PI1[0][6][3] + sp[35] * PI4[0][3][6] + sp[29] * PI5[0][3][6] + sp[32] * PI6[0][3][6] + sp[28] * PI2[0][6][3] + sp[29] * PI5[0][6][3] + sp[26] * PI7[0][3][6] + sp[27] * PI8[0][3][6] + sp[31] * PI3[0][6][3] + sp[32] * PI6[0][6][3] + sp[27] * PI8[0][6][3] + sp[30] * PI9[0][3][6];
    A[52] = sp[33] * PI0[0][3][7] + sp[34] * PI1[0][3][7] + sp[28] * PI2[0][3][7] + sp[31] * PI3[0][3][7] + sp[34] * PI1[0][7][3] + sp[35] * PI4[0][3][7] + sp[29] * PI5[0][3][7] + sp[32] * PI6[0][3][7] + sp[28] * PI2[0][7][3] + sp[29] * PI5[0][7][3] + sp[26] * PI7[0][3][7] + sp[27] * PI8[0][3][7] + sp[31] * PI3[0][7][3] + sp[32] * PI6[0][7][3] + sp[27] * PI8[0][7][3] + sp[30] * PI9[0][3][7];
    A[53] = sp[33] * PI0[0][3][8] + sp[34] * PI1[0][3][8] + sp[28] * PI2[0][3][8] + sp[31] * PI3[0][3][8] + sp[34] * PI1[0][8][3] + sp[35] * PI4[0][3][8] + sp[29] * PI5[0][3][8] + sp[32] * PI6[0][3][8] + sp[28] * PI2[0][8][3] + sp[29] * PI5[0][8][3] + sp[26] * PI7[0][3][8] + sp[27] * PI8[0][3][8] + sp[31] * PI3[0][8][3] + sp[32] * PI6[0][8][3] + sp[27] * PI8[0][8][3] + sp[30] * PI9[0][3][8];
    A[54] = sp[33] * PI0[0][3][9] + sp[34] * PI1[0][3][9] + sp[28] * PI2[0][3][9] + sp[31] * PI3[0][3][9] + sp[34] * PI1[0][9][3] + sp[35] * PI4[0][3][9] + sp[29] * PI5[0][3][9] + sp[32] * PI6[0][3][9] + sp[28] * PI2[0][9][3] + sp[29] * PI5[0][9][3] + sp[26] * PI7[0][3][9] + sp[27] * PI8[0][3][9] + sp[31] * PI3[0][9][3] + sp[32] * PI6[0][9][3] + sp[27] * PI8[0][9][3] + sp[30] * PI9[0][3][9];
    A[55] = sp[33] * PI0[0][3][10] + sp[34] * PI1[0][3][10] + sp[28] * PI2[0][3][10] + sp[31] * PI3[0][3][10] + sp[34] * PI1[0][10][3] + sp[35] * PI4[0][3][10] + sp[29] * PI5[0][3][10] + sp[32] * PI6[0][3][10] + sp[28] * PI2[0][10][3] + sp[29] * PI5[0][10][3] + sp[26] * PI7[0][3][10] + sp[27] * PI8[0][3][10] + sp[31] * PI3[0][10][3] + sp[32] * PI6[0][10][3] + sp[27] * PI8[0][10][3] + sp[30] * PI9[0][3][10];
    A[56] = sp[33] * PI0[0][3][11] + sp[34] * PI1[0][3][11] + sp[28] * PI2[0][3][11] + sp[31] * PI3[0][3][11] + sp[34] * PI1[0][11][3] + sp[35] * PI4[0][3][11] + sp[29] * PI5[0][3][11] + sp[32] * PI6[0][3][11] + sp[28] * PI2[0][11][3] + sp[29] * PI5[0][11][3] + sp[26] * PI7[0][3][11] + sp[27] * PI8[0][3][11] + sp[31] * PI3[0][11][3] + sp[32] * PI6[0][11][3] + sp[27] * PI8[0][11][3] + sp[30] * PI9[0][3][11];
    A[57] = sp[33] * PI0[0][3][12] + sp[34] * PI1[0][3][12] + sp[28] * PI2[0][3][12] + sp[31] * PI3[0][3][12] + sp[34] * PI1[0][12][3] + sp[35] * PI4[0][3][12] + sp[29] * PI5[0][3][12] + sp[32] * PI6[0][3][12] + sp[28] * PI2[0][12][3] + sp[29] * PI5[0][12][3] + sp[26] * PI7[0][3][12] + sp[27] * PI8[0][3][12] + sp[31] * PI3[0][12][3] + sp[32] * PI6[0][12][3] + sp[27] * PI8[0][12][3] + sp[30] * PI9[0][3][12];
    A[58] = sp[33] * PI0[0][3][13] + sp[34] * PI1[0][3][13] + sp[28] * PI2[0][3][13] + sp[31] * PI3[0][3][13] + sp[34] * PI1[0][13][3] + sp[35] * PI4[0][3][13] + sp[29] * PI5[0][3][13] + sp[32] * PI6[0][3][13] + sp[28] * PI2[0][13][3] + sp[29] * PI5[0][13][3] + sp[26] * PI7[0][3][13] + sp[27] * PI8[0][3][13] + sp[31] * PI3[0][13][3] + sp[32] * PI6[0][13][3] + sp[27] * PI8[0][13][3] + sp[30] * PI9[0][3][13];
    A[59] = sp[33] * PI0[0][3][14] + sp[34] * PI1[0][3][14] + sp[28] * PI2[0][3][14] + sp[31] * PI3[0][3][14] + sp[34] * PI1[0][14][3] + sp[35] * PI4[0][3][14] + sp[29] * PI5[0][3][14] + sp[32] * PI6[0][3][14] + sp[28] * PI2[0][14][3] + sp[29] * PI5[0][14][3] + sp[26] * PI7[0][3][14] + sp[27] * PI8[0][3][14] + sp[31] * PI3[0][14][3] + sp[32] * PI6[0][14][3] + sp[27] * PI8[0][14][3] + sp[30] * PI9[0][3][14];
    A[60] = sp[33] * PI0[0][4][0] + sp[34] * PI1[0][4][0] + sp[28] * PI2[0][4][0] + sp[31] * PI3[0][4][0] + sp[34] * PI1[0][0][4] + sp[35] * PI4[0][4][0] + sp[29] * PI5[0][4][0] + sp[32] * PI6[0][4][0] + sp[28] * PI2[0][0][4] + sp[29] * PI5[0][0][4] + sp[26] * PI7[0][4][0] + sp[27] * PI8[0][4][0] + sp[31] * PI3[0][0][4] + sp[32] * PI6[0][0][4] + sp[27] * PI8[0][0][4] + sp[30] * PI9[0][4][0];
    A[61] = sp[33] * PI0[0][4][1] + sp[34] * PI1[0][4][1] + sp[28] * PI2[0][4][1] + sp[31] * PI3[0][4][1] + sp[34] * PI1[0][1][4] + sp[35] * PI4[0][4][1] + sp[29] * PI5[0][4][1] + sp[32] * PI6[0][4][1] + sp[28] * PI2[0][1][4] + sp[29] * PI5[0][1][4] + sp[26] * PI7[0][4][1] + sp[27] * PI8[0][4][1] + sp[31] * PI3[0][1][4] + sp[32] * PI6[0][1][4] + sp[27] * PI8[0][1][4] + sp[30] * PI9[0][4][1];
    A[62] = sp[33] * PI0[0][4][2] + sp[34] * PI1[0][4][2] + sp[28] * PI2[0][4][2] + sp[31] * PI3[0][4][2] + sp[34] * PI1[0][2][4] + sp[35] * PI4[0][4][2] + sp[29] * PI5[0][4][2] + sp[32] * PI6[0][4][2] + sp[28] * PI2[0][2][4] + sp[29] * PI5[0][2][4] + sp[26] * PI7[0][4][2] + sp[27] * PI8[0][4][2] + sp[31] * PI3[0][2][4] + sp[32] * PI6[0][2][4] + sp[27] * PI8[0][2][4] + sp[30] * PI9[0][4][2];
    A[63] = sp[33] * PI0[0][4][3] + sp[34] * PI1[0][4][3] + sp[28] * PI2[0][4][3] + sp[31] * PI3[0][4][3] + sp[34] * PI1[0][3][4] + sp[35] * PI4[0][4][3] + sp[29] * PI5[0][4][3] + sp[32] * PI6[0][4][3] + sp[28] * PI2[0][3][4] + sp[29] * PI5[0][3][4] + sp[26] * PI7[0][4][3] + sp[27] * PI8[0][4][3] + sp[31] * PI3[0][3][4] + sp[32] * PI6[0][3][4] + sp[27] * PI8[0][3][4] + sp[30] * PI9[0][4][3];
    A[64] = sp[33] * PI0[0][4][4] + sp[34] * PI1[0][4][4] + sp[28] * PI2[0][4][4] + sp[31] * PI3[0][4][4] + sp[34] * PI1[0][4][4] + sp[35] * PI4[0][4][4] + sp[29] * PI5[0][4][4] + sp[32] * PI6[0][4][4] + sp[28] * PI2[0][4][4] + sp[29] * PI5[0][4][4] + sp[26] * PI7[0][4][4] + sp[27] * PI8[0][4][4] + sp[31] * PI3[0][4][4] + sp[32] * PI6[0][4][4] + sp[27] * PI8[0][4][4] + sp[30] * PI9[0][4][4];
    A[65] = sp[33] * PI0[0][4][5] + sp[34] * PI1[0][4][5] + sp[28] * PI2[0][4][5] + sp[31] * PI3[0][4][5] + sp[34] * PI1[0][5][4] + sp[35] * PI4[0][4][5] + sp[29] * PI5[0][4][5] + sp[32] * PI6[0][4][5] + sp[28] * PI2[0][5][4] + sp[29] * PI5[0][5][4] + sp[26] * PI7[0][4][5] + sp[27] * PI8[0][4][5] + sp[31] * PI3[0][5][4] + sp[32] * PI6[0][5][4] + sp[27] * PI8[0][5][4] + sp[30] * PI9[0][4][5];
    A[66] = sp[33] * PI0[0][4][6] + sp[34] * PI1[0][4][6] + sp[28] * PI2[0][4][6] + sp[31] * PI3[0][4][6] + sp[34] * PI1[0][6][4] + sp[35] * PI4[0][4][6] + sp[29] * PI5[0][4][6] + sp[32] * PI6[0][4][6] + sp[28] * PI2[0][6][4] + sp[29] * PI5[0][6][4] + sp[26] * PI7[0][4][6] + sp[27] * PI8[0][4][6] + sp[31] * PI3[0][6][4] + sp[32] * PI6[0][6][4] + sp[27] * PI8[0][6][4] + sp[30] * PI9[0][4][6];
    A[67] = sp[33] * PI0[0][4][7] + sp[34] * PI1[0][4][7] + sp[28] * PI2[0][4][7] + sp[31] * PI3[0][4][7] + sp[34] * PI1[0][7][4] + sp[35] * PI4[0][4][7] + sp[29] * PI5[0][4][7] + sp[32] * PI6[0][4][7] + sp[28] * PI2[0][7][4] + sp[29] * PI5[0][7][4] + sp[26] * PI7[0][4][7] + sp[27] * PI8[0][4][7] + sp[31] * PI3[0][7][4] + sp[32] * PI6[0][7][4] + sp[27] * PI8[0][7][4] + sp[30] * PI9[0][4][7];
    A[68] = sp[33] * PI0[0][4][8] + sp[34] * PI1[0][4][8] + sp[28] * PI2[0][4][8] + sp[31] * PI3[0][4][8] + sp[34] * PI1[0][8][4] + sp[35] * PI4[0][4][8] + sp[29] * PI5[0][4][8] + sp[32] * PI6[0][4][8] + sp[28] * PI2[0][8][4] + sp[29] * PI5[0][8][4] + sp[26] * PI7[0][4][8] + sp[27] * PI8[0][4][8] + sp[31] * PI3[0][8][4] + sp[32] * PI6[0][8][4] + sp[27] * PI8[0][8][4] + sp[30] * PI9[0][4][8];
    A[69] = sp[33] * PI0[0][4][9] + sp[34] * PI1[0][4][9] + sp[28] * PI2[0][4][9] + sp[31] * PI3[0][4][9] + sp[34] * PI1[0][9][4] + sp[35] * PI4[0][4][9] + sp[29] * PI5[0][4][9] + sp[32] * PI6[0][4][9] + sp[28] * PI2[0][9][4] + sp[29] * PI5[0][9][4] + sp[26] * PI7[0][4][9] + sp[27] * PI8[0][4][9] + sp[31] * PI3[0][9][4] + sp[32] * PI6[0][9][4] + sp[27] * PI8[0][9][4] + sp[30] * PI9[0][4][9];
    A[70] = sp[33] * PI0[0][4][10] + sp[34] * PI1[0][4][10] + sp[28] * PI2[0][4][10] + sp[31] * PI3[0][4][10] + sp[34] * PI1[0][10][4] + sp[35] * PI4[0][4][10] + sp[29] * PI5[0][4][10] + sp[32] * PI6[0][4][10] + sp[28] * PI2[0][10][4] + sp[29] * PI5[0][10][4] + sp[26] * PI7[0][4][10] + sp[27] * PI8[0][4][10] + sp[31] * PI3[0][10][4] + sp[32] * PI6[0][10][4] + sp[27] * PI8[0][10][4] + sp[30] * PI9[0][4][10];
    A[71] = sp[33] * PI0[0][4][11] + sp[34] * PI1[0][4][11] + sp[28] * PI2[0][4][11] + sp[31] * PI3[0][4][11] + sp[34] * PI1[0][11][4] + sp[35] * PI4[0][4][11] + sp[29] * PI5[0][4][11] + sp[32] * PI6[0][4][11] + sp[28] * PI2[0][11][4] + sp[29] * PI5[0][11][4] + sp[26] * PI7[0][4][11] + sp[27] * PI8[0][4][11] + sp[31] * PI3[0][11][4] + sp[32] * PI6[0][11][4] + sp[27] * PI8[0][11][4] + sp[30] * PI9[0][4][11];
    A[72] = sp[33] * PI0[0][4][12] + sp[34] * PI1[0][4][12] + sp[28] * PI2[0][4][12] + sp[31] * PI3[0][4][12] + sp[34] * PI1[0][12][4] + sp[35] * PI4[0][4][12] + sp[29] * PI5[0][4][12] + sp[32] * PI6[0][4][12] + sp[28] * PI2[0][12][4] + sp[29] * PI5[0][12][4] + sp[26] * PI7[0][4][12] + sp[27] * PI8[0][4][12] + sp[31] * PI3[0][12][4] + sp[32] * PI6[0][12][4] + sp[27] * PI8[0][12][4] + sp[30] * PI9[0][4][12];
    A[73] = sp[33] * PI0[0][4][13] + sp[34] * PI1[0][4][13] + sp[28] * PI2[0][4][13] + sp[31] * PI3[0][4][13] + sp[34] * PI1[0][13][4] + sp[35] * PI4[0][4][13] + sp[29] * PI5[0][4][13] + sp[32] * PI6[0][4][13] + sp[28] * PI2[0][13][4] + sp[29] * PI5[0][13][4] + sp[26] * PI7[0][4][13] + sp[27] * PI8[0][4][13] + sp[31] * PI3[0][13][4] + sp[32] * PI6[0][13][4] + sp[27] * PI8[0][13][4] + sp[30] * PI9[0][4][13];
    A[74] = sp[33] * PI0[0][4][14] + sp[34] * PI1[0][4][14] + sp[28] * PI2[0][4][14] + sp[31] * PI3[0][4][14] + sp[34] * PI1[0][14][4] + sp[35] * PI4[0][4][14] + sp[29] * PI5[0][4][14] + sp[32] * PI6[0][4][14] + sp[28] * PI2[0][14][4] + sp[29] * PI5[0][14][4] + sp[26] * PI7[0][4][14] + sp[27] * PI8[0][4][14] + sp[31] * PI3[0][14][4] + sp[32] * PI6[0][14][4] + sp[27] * PI8[0][14][4] + sp[30] * PI9[0][4][14];
    A[75] = sp[33] * PI0[0][5][0] + sp[34] * PI1[0][5][0] + sp[28] * PI2[0][5][0] + sp[31] * PI3[0][5][0] + sp[34] * PI1[0][0][5] + sp[35] * PI4[0][5][0] + sp[29] * PI5[0][5][0] + sp[32] * PI6[0][5][0] + sp[28] * PI2[0][0][5] + sp[29] * PI5[0][0][5] + sp[26] * PI7[0][5][0] + sp[27] * PI8[0][5][0] + sp[31] * PI3[0][0][5] + sp[32] * PI6[0][0][5] + sp[27] * PI8[0][0][5] + sp[30] * PI9[0][5][0];
    A[76] = sp[33] * PI0[0][5][1] + sp[34] * PI1[0][5][1] + sp[28] * PI2[0][5][1] + sp[31] * PI3[0][5][1] + sp[34] * PI1[0][1][5] + sp[35] * PI4[0][5][1] + sp[29] * PI5[0][5][1] + sp[32] * PI6[0][5][1] + sp[28] * PI2[0][1][5] + sp[29] * PI5[0][1][5] + sp[26] * PI7[0][5][1] + sp[27] * PI8[0][5][1] + sp[31] * PI3[0][1][5] + sp[32] * PI6[0][1][5] + sp[27] * PI8[0][1][5] + sp[30] * PI9[0][5][1];
    A[77] = sp[33] * PI0[0][5][2] + sp[34] * PI1[0][5][2] + sp[28] * PI2[0][5][2] + sp[31] * PI3[0][5][2] + sp[34] * PI1[0][2][5] + sp[35] * PI4[0][5][2] + sp[29] * PI5[0][5][2] + sp[32] * PI6[0][5][2] + sp[28] * PI2[0][2][5] + sp[29] * PI5[0][2][5] + sp[26] * PI7[0][5][2] + sp[27] * PI8[0][5][2] + sp[31] * PI3[0][2][5] + sp[32] * PI6[0][2][5] + sp[27] * PI8[0][2][5] + sp[30] * PI9[0][5][2];
    A[78] = sp[33] * PI0[0][5][3] + sp[34] * PI1[0][5][3] + sp[28] * PI2[0][5][3] + sp[31] * PI3[0][5][3] + sp[34] * PI1[0][3][5] + sp[35] * PI4[0][5][3] + sp[29] * PI5[0][5][3] + sp[32] * PI6[0][5][3] + sp[28] * PI2[0][3][5] + sp[29] * PI5[0][3][5] + sp[26] * PI7[0][5][3] + sp[27] * PI8[0][5][3] + sp[31] * PI3[0][3][5] + sp[32] * PI6[0][3][5] + sp[27] * PI8[0][3][5] + sp[30] * PI9[0][5][3];
    A[79] = sp[33] * PI0[0][5][4] + sp[34] * PI1[0][5][4] + sp[28] * PI2[0][5][4] + sp[31] * PI3[0][5][4] + sp[34] * PI1[0][4][5] + sp[35] * PI4[0][5][4] + sp[29] * PI5[0][5][4] + sp[32] * PI6[0][5][4] + sp[28] * PI2[0][4][5] + sp[29] * PI5[0][4][5] + sp[26] * PI7[0][5][4] + sp[27] * PI8[0][5][4] + sp[31] * PI3[0][4][5] + sp[32] * PI6[0][4][5] + sp[27] * PI8[0][4][5] + sp[30] * PI9[0][5][4];
    A[80] = sp[33] * PI0[0][5][5] + sp[34] * PI1[0][5][5] + sp[28] * PI2[0][5][5] + sp[31] * PI3[0][5][5] + sp[34] * PI1[0][5][5] + sp[35] * PI4[0][5][5] + sp[29] * PI5[0][5][5] + sp[32] * PI6[0][5][5] + sp[28] * PI2[0][5][5] + sp[29] * PI5[0][5][5] + sp[26] * PI7[0][5][5] + sp[27] * PI8[0][5][5] + sp[31] * PI3[0][5][5] + sp[32] * PI6[0][5][5] + sp[27] * PI8[0][5][5] + sp[30] * PI9[0][5][5];
    A[81] = sp[33] * PI0[0][5][6] + sp[34] * PI1[0][5][6] + sp[28] * PI2[0][5][6] + sp[31] * PI3[0][5][6] + sp[34] * PI1[0][6][5] + sp[35] * PI4[0][5][6] + sp[29] * PI5[0][5][6] + sp[32] * PI6[0][5][6] + sp[28] * PI2[0][6][5] + sp[29] * PI5[0][6][5] + sp[26] * PI7[0][5][6] + sp[27] * PI8[0][5][6] + sp[31] * PI3[0][6][5] + sp[32] * PI6[0][6][5] + sp[27] * PI8[0][6][5] + sp[30] * PI9[0][5][6];
    A[82] = sp[33] * PI0[0][5][7] + sp[34] * PI1[0][5][7] + sp[28] * PI2[0][5][7] + sp[31] * PI3[0][5][7] + sp[34] * PI1[0][7][5] + sp[35] * PI4[0][5][7] + sp[29] * PI5[0][5][7] + sp[32] * PI6[0][5][7] + sp[28] * PI2[0][7][5] + sp[29] * PI5[0][7][5] + sp[26] * PI7[0][5][7] + sp[27] * PI8[0][5][7] + sp[31] * PI3[0][7][5] + sp[32] * PI6[0][7][5] + sp[27] * PI8[0][7][5] + sp[30] * PI9[0][5][7];
    A[83] = sp[33] * PI0[0][5][8] + sp[34] * PI1[0][5][8] + sp[28] * PI2[0][5][8] + sp[31] * PI3[0][5][8] + sp[34] * PI1[0][8][5] + sp[35] * PI4[0][5][8] + sp[29] * PI5[0][5][8] + sp[32] * PI6[0][5][8] + sp[28] * PI2[0][8][5] + sp[29] * PI5[0][8][5] + sp[26] * PI7[0][5][8] + sp[27] * PI8[0][5][8] + sp[31] * PI3[0][8][5] + sp[32] * PI6[0][8][5] + sp[27] * PI8[0][8][5] + sp[30] * PI9[0][5][8];
    A[84] = sp[33] * PI0[0][5][9] + sp[34] * PI1[0][5][9] + sp[28] * PI2[0][5][9] + sp[31] * PI3[0][5][9] + sp[34] * PI1[0][9][5] + sp[35] * PI4[0][5][9] + sp[29] * PI5[0][5][9] + sp[32] * PI6[0][5][9] + sp[28] * PI2[0][9][5] + sp[29] * PI5[0][9][5] + sp[26] * PI7[0][5][9] + sp[27] * PI8[0][5][9] + sp[31] * PI3[0][9][5] + sp[32] * PI6[0][9][5] + sp[27] * PI8[0][9][5] + sp[30] * PI9[0][5][9];
    A[85] = sp[33] * PI0[0][5][10] + sp[34] * PI1[0][5][10] + sp[28] * PI2[0][5][10] + sp[31] * PI3[0][5][10] + sp[34] * PI1[0][10][5] + sp[35] * PI4[0][5][10] + sp[29] * PI5[0][5][10] + sp[32] * PI6[0][5][10] + sp[28] * PI2[0][10][5] + sp[29] * PI5[0][10][5] + sp[26] * PI7[0][5][10] + sp[27] * PI8[0][5][10] + sp[31] * PI3[0][10][5] + sp[32] * PI6[0][10][5] + sp[27] * PI8[0][10][5] + sp[30] * PI9[0][5][10];
    A[86] = sp[33] * PI0[0][5][11] + sp[34] * PI1[0][5][11] + sp[28] * PI2[0][5][11] + sp[31] * PI3[0][5][11] + sp[34] * PI1[0][11][5] + sp[35] * PI4[0][5][11] + sp[29] * PI5[0][5][11] + sp[32] * PI6[0][5][11] + sp[28] * PI2[0][11][5] + sp[29] * PI5[0][11][5] + sp[26] * PI7[0][5][11] + sp[27] * PI8[0][5][11] + sp[31] * PI3[0][11][5] + sp[32] * PI6[0][11][5] + sp[27] * PI8[0][11][5] + sp[30] * PI9[0][5][11];
    A[87] = sp[33] * PI0[0][5][12] + sp[34] * PI1[0][5][12] + sp[28] * PI2[0][5][12] + sp[31] * PI3[0][5][12] + sp[34] * PI1[0][12][5] + sp[35] * PI4[0][5][12] + sp[29] * PI5[0][5][12] + sp[32] * PI6[0][5][12] + sp[28] * PI2[0][12][5] + sp[29] * PI5[0][12][5] + sp[26] * PI7[0][5][12] + sp[27] * PI8[0][5][12] + sp[31] * PI3[0][12][5] + sp[32] * PI6[0][12][5] + sp[27] * PI8[0][12][5] + sp[30] * PI9[0][5][12];
    A[88] = sp[33] * PI0[0][5][13] + sp[34] * PI1[0][5][13] + sp[28] * PI2[0][5][13] + sp[31] * PI3[0][5][13] + sp[34] * PI1[0][13][5] + sp[35] * PI4[0][5][13] + sp[29] * PI5[0][5][13] + sp[32] * PI6[0][5][13] + sp[28] * PI2[0][13][5] + sp[29] * PI5[0][13][5] + sp[26] * PI7[0][5][13] + sp[27] * PI8[0][5][13] + sp[31] * PI3[0][13][5] + sp[32] * PI6[0][13][5] + sp[27] * PI8[0][13][5] + sp[30] * PI9[0][5][13];
    A[89] = sp[33] * PI0[0][5][14] + sp[34] * PI1[0][5][14] + sp[28] * PI2[0][5][14] + sp[31] * PI3[0][5][14] + sp[34] * PI1[0][14][5] + sp[35] * PI4[0][5][14] + sp[29] * PI5[0][5][14] + sp[32] * PI6[0][5][14] + sp[28] * PI2[0][14][5] + sp[29] * PI5[0][14][5] + sp[26] * PI7[0][5][14] + sp[27] * PI8[0][5][14] + sp[31] * PI3[0][14][5] + sp[32] * PI6[0][14][5] + sp[27] * PI8[0][14][5] + sp[30] * PI9[0][5][14];
    A[90] = sp[33] * PI0[0][6][0] + sp[34] * PI1[0][6][0] + sp[28] * PI2[0][6][0] + sp[31] * PI3[0][6][0] + sp[34] * PI1[0][0][6] + sp[35] * PI4[0][6][0] + sp[29] * PI5[0][6][0] + sp[32] * PI6[0][6][0] + sp[28] * PI2[0][0][6] + sp[29] * PI5[0][0][6] + sp[26] * PI7[0][6][0] + sp[27] * PI8[0][6][0] + sp[31] * PI3[0][0][6] + sp[32] * PI6[0][0][6] + sp[27] * PI8[0][0][6] + sp[30] * PI9[0][6][0];
    A[91] = sp[33] * PI0[0][6][1] + sp[34] * PI1[0][6][1] + sp[28] * PI2[0][6][1] + sp[31] * PI3[0][6][1] + sp[34] * PI1[0][1][6] + sp[35] * PI4[0][6][1] + sp[29] * PI5[0][6][1] + sp[32] * PI6[0][6][1] + sp[28] * PI2[0][1][6] + sp[29] * PI5[0][1][6] + sp[26] * PI7[0][6][1] + sp[27] * PI8[0][6][1] + sp[31] * PI3[0][1][6] + sp[32] * PI6[0][1][6] + sp[27] * PI8[0][1][6] + sp[30] * PI9[0][6][1];
    A[92] = sp[33] * PI0[0][6][2] + sp[34] * PI1[0][6][2] + sp[28] * PI2[0][6][2] + sp[31] * PI3[0][6][2] + sp[34] * PI1[0][2][6] + sp[35] * PI4[0][6][2] + sp[29] * PI5[0][6][2] + sp[32] * PI6[0][6][2] + sp[28] * PI2[0][2][6] + sp[29] * PI5[0][2][6] + sp[26] * PI7[0][6][2] + sp[27] * PI8[0][6][2] + sp[31] * PI3[0][2][6] + sp[32] * PI6[0][2][6] + sp[27] * PI8[0][2][6] + sp[30] * PI9[0][6][2];
    A[93] = sp[33] * PI0[0][6][3] + sp[34] * PI1[0][6][3] + sp[28] * PI2[0][6][3] + sp[31] * PI3[0][6][3] + sp[34] * PI1[0][3][6] + sp[35] * PI4[0][6][3] + sp[29] * PI5[0][6][3] + sp[32] * PI6[0][6][3] + sp[28] * PI2[0][3][6] + sp[29] * PI5[0][3][6] + sp[26] * PI7[0][6][3] + sp[27] * PI8[0][6][3] + sp[31] * PI3[0][3][6] + sp[32] * PI6[0][3][6] + sp[27] * PI8[0][3][6] + sp[30] * PI9[0][6][3];
    A[94] = sp[33] * PI0[0][6][4] + sp[34] * PI1[0][6][4] + sp[28] * PI2[0][6][4] + sp[31] * PI3[0][6][4] + sp[34] * PI1[0][4][6] + sp[35] * PI4[0][6][4] + sp[29] * PI5[0][6][4] + sp[32] * PI6[0][6][4] + sp[28] * PI2[0][4][6] + sp[29] * PI5[0][4][6] + sp[26] * PI7[0][6][4] + sp[27] * PI8[0][6][4] + sp[31] * PI3[0][4][6] + sp[32] * PI6[0][4][6] + sp[27] * PI8[0][4][6] + sp[30] * PI9[0][6][4];
    A[95] = sp[33] * PI0[0][6][5] + sp[34] * PI1[0][6][5] + sp[28] * PI2[0][6][5] + sp[31] * PI3[0][6][5] + sp[34] * PI1[0][5][6] + sp[35] * PI4[0][6][5] + sp[29] * PI5[0][6][5] + sp[32] * PI6[0][6][5] + sp[28] * PI2[0][5][6] + sp[29] * PI5[0][5][6] + sp[26] * PI7[0][6][5] + sp[27] * PI8[0][6][5] + sp[31] * PI3[0][5][6] + sp[32] * PI6[0][5][6] + sp[27] * PI8[0][5][6] + sp[30] * PI9[0][6][5];
    A[96] = sp[33] * PI0[0][6][6] + sp[34] * PI1[0][6][6] + sp[28] * PI2[0][6][6] + sp[31] * PI3[0][6][6] + sp[34] * PI1[0][6][6] + sp[35] * PI4[0][6][6] + sp[29] * PI5[0][6][6] + sp[32] * PI6[0][6][6] + sp[28] * PI2[0][6][6] + sp[29] * PI5[0][6][6] + sp[26] * PI7[0][6][6] + sp[27] * PI8[0][6][6] + sp[31] * PI3[0][6][6] + sp[32] * PI6[0][6][6] + sp[27] * PI8[0][6][6] + sp[30] * PI9[0][6][6];
    A[97] = sp[33] * PI0[0][6][7] + sp[34] * PI1[0][6][7] + sp[28] * PI2[0][6][7] + sp[31] * PI3[0][6][7] + sp[34] * PI1[0][7][6] + sp[35] * PI4[0][6][7] + sp[29] * PI5[0][6][7] + sp[32] * PI6[0][6][7] + sp[28] * PI2[0][7][6] + sp[29] * PI5[0][7][6] + sp[26] * PI7[0][6][7] + sp[27] * PI8[0][6][7] + sp[31] * PI3[0][7][6] + sp[32] * PI6[0][7][6] + sp[27] * PI8[0][7][6] + sp[30] * PI9[0][6][7];
    A[98] = sp[33] * PI0[0][6][8] + sp[34] * PI1[0][6][8] + sp[28] * PI2[0][6][8] + sp[31] * PI3[0][6][8] + sp[34] * PI1[0][8][6] + sp[35] * PI4[0][6][8] + sp[29] * PI5[0][6][8] + sp[32] * PI6[0][6][8] + sp[28] * PI2[0][8][6] + sp[29] * PI5[0][8][6] + sp[26] * PI7[0][6][8] + sp[27] * PI8[0][6][8] + sp[31] * PI3[0][8][6] + sp[32] * PI6[0][8][6] + sp[27] * PI8[0][8][6] + sp[30] * PI9[0][6][8];
    A[99] = sp[33] * PI0[0][6][9] + sp[34] * PI1[0][6][9] + sp[28] * PI2[0][6][9] + sp[31] * PI3[0][6][9] + sp[34] * PI1[0][9][6] + sp[35] * PI4[0][6][9] + sp[29] * PI5[0][6][9] + sp[32] * PI6[0][6][9] + sp[28] * PI2[0][9][6] + sp[29] * PI5[0][9][6] + sp[26] * PI7[0][6][9] + sp[27] * PI8[0][6][9] + sp[31] * PI3[0][9][6] + sp[32] * PI6[0][9][6] + sp[27] * PI8[0][9][6] + sp[30] * PI9[0][6][9];
    A[100] = sp[33] * PI0[0][6][10] + sp[34] * PI1[0][6][10] + sp[28] * PI2[0][6][10] + sp[31] * PI3[0][6][10] + sp[34] * PI1[0][10][6] + sp[35] * PI4[0][6][10] + sp[29] * PI5[0][6][10] + sp[32] * PI6[0][6][10] + sp[28] * PI2[0][10][6] + sp[29] * PI5[0][10][6] + sp[26] * PI7[0][6][10] + sp[27] * PI8[0][6][10] + sp[31] * PI3[0][10][6] + sp[32] * PI6[0][10][6] + sp[27] * PI8[0][10][6] + sp[30] * PI9[0][6][10];
    A[101] = sp[33] * PI0[0][6][11] + sp[34] * PI1[0][6][11] + sp[28] * PI2[0][6][11] + sp[31] * PI3[0][6][11] + sp[34] * PI1[0][11][6] + sp[35] * PI4[0][6][11] + sp[29] * PI5[0][6][11] + sp[32] * PI6[0][6][11] + sp[28] * PI2[0][11][6] + sp[29] * PI5[0][11][6] + sp[26] * PI7[0][6][11] + sp[27] * PI8[0][6][11] + sp[31] * PI3[0][11][6] + sp[32] * PI6[0][11][6] + sp[27] * PI8[0][11][6] + sp[30] * PI9[0][6][11];
    A[102] = sp[33] * PI0[0][6][12] + sp[34] * PI1[0][6][12] + sp[28] * PI2[0][6][12] + sp[31] * PI3[0][6][12] + sp[34] * PI1[0][12][6] + sp[35] * PI4[0][6][12] + sp[29] * PI5[0][6][12] + sp[32] * PI6[0][6][12] + sp[28] * PI2[0][12][6] + sp[29] * PI5[0][12][6] + sp[26] * PI7[0][6][12] + sp[27] * PI8[0][6][12] + sp[31] * PI3[0][12][6] + sp[32] * PI6[0][12][6] + sp[27] * PI8[0][12][6] + sp[30] * PI9[0][6][12];
    A[103] = sp[33] * PI0[0][6][13] + sp[34] * PI1[0][6][13] + sp[28] * PI2[0][6][13] + sp[31] * PI3[0][6][13] + sp[34] * PI1[0][13][6] + sp[35] * PI4[0][6][13] + sp[29] * PI5[0][6][13] + sp[32] * PI6[0][6][13] + sp[28] * PI2[0][13][6] + sp[29] * PI5[0][13][6] + sp[26] * PI7[0][6][13] + sp[27] * PI8[0][6][13] + sp[31] * PI3[0][13][6] + sp[32] * PI6[0][13][6] + sp[27] * PI8[0][13][6] + sp[30] * PI9[0][6][13];
    A[104] = sp[33] * PI0[0][6][14] + sp[34] * PI1[0][6][14] + sp[28] * PI2[0][6][14] + sp[31] * PI3[0][6][14] + sp[34] * PI1[0][14][6] + sp[35] * PI4[0][6][14] + sp[29] * PI5[0][6][14] + sp[32] * PI6[0][6][14] + sp[28] * PI2[0][14][6] + sp[29] * PI5[0][14][6] + sp[26] * PI7[0][6][14] + sp[27] * PI8[0][6][14] + sp[31] * PI3[0][14][6] + sp[32] * PI6[0][14][6] + sp[27] * PI8[0][14][6] + sp[30] * PI9[0][6][14];
    A[105] = sp[33] * PI0[0][7][0] + sp[34] * PI1[0][7][0] + sp[28] * PI2[0][7][0] + sp[31] * PI3[0][7][0] + sp[34] * PI1[0][0][7] + sp[35] * PI4[0][7][0] + sp[29] * PI5[0][7][0] + sp[32] * PI6[0][7][0] + sp[28] * PI2[0][0][7] + sp[29] * PI5[0][0][7] + sp[26] * PI7[0][7][0] + sp[27] * PI8[0][7][0] + sp[31] * PI3[0][0][7] + sp[32] * PI6[0][0][7] + sp[27] * PI8[0][0][7] + sp[30] * PI9[0][7][0];
    A[106] = sp[33] * PI0[0][7][1] + sp[34] * PI1[0][7][1] + sp[28] * PI2[0][7][1] + sp[31] * PI3[0][7][1] + sp[34] * PI1[0][1][7] + sp[35] * PI4[0][7][1] + sp[29] * PI5[0][7][1] + sp[32] * PI6[0][7][1] + sp[28] * PI2[0][1][7] + sp[29] * PI5[0][1][7] + sp[26] * PI7[0][7][1] + sp[27] * PI8[0][7][1] + sp[31] * PI3[0][1][7] + sp[32] * PI6[0][1][7] + sp[27] * PI8[0][1][7] + sp[30] * PI9[0][7][1];
    A[107] = sp[33] * PI0[0][7][2] + sp[34] * PI1[0][7][2] + sp[28] * PI2[0][7][2] + sp[31] * PI3[0][7][2] + sp[34] * PI1[0][2][7] + sp[35] * PI4[0][7][2] + sp[29] * PI5[0][7][2] + sp[32] * PI6[0][7][2] + sp[28] * PI2[0][2][7] + sp[29] * PI5[0][2][7] + sp[26] * PI7[0][7][2] + sp[27] * PI8[0][7][2] + sp[31] * PI3[0][2][7] + sp[32] * PI6[0][2][7] + sp[27] * PI8[0][2][7] + sp[30] * PI9[0][7][2];
    A[108] = sp[33] * PI0[0][7][3] + sp[34] * PI1[0][7][3] + sp[28] * PI2[0][7][3] + sp[31] * PI3[0][7][3] + sp[34] * PI1[0][3][7] + sp[35] * PI4[0][7][3] + sp[29] * PI5[0][7][3] + sp[32] * PI6[0][7][3] + sp[28] * PI2[0][3][7] + sp[29] * PI5[0][3][7] + sp[26] * PI7[0][7][3] + sp[27] * PI8[0][7][3] + sp[31] * PI3[0][3][7] + sp[32] * PI6[0][3][7] + sp[27] * PI8[0][3][7] + sp[30] * PI9[0][7][3];
    A[109] = sp[33] * PI0[0][7][4] + sp[34] * PI1[0][7][4] + sp[28] * PI2[0][7][4] + sp[31] * PI3[0][7][4] + sp[34] * PI1[0][4][7] + sp[35] * PI4[0][7][4] + sp[29] * PI5[0][7][4] + sp[32] * PI6[0][7][4] + sp[28] * PI2[0][4][7] + sp[29] * PI5[0][4][7] + sp[26] * PI7[0][7][4] + sp[27] * PI8[0][7][4] + sp[31] * PI3[0][4][7] + sp[32] * PI6[0][4][7] + sp[27] * PI8[0][4][7] + sp[30] * PI9[0][7][4];
    A[110] = sp[33] * PI0[0][7][5] + sp[34] * PI1[0][7][5] + sp[28] * PI2[0][7][5] + sp[31] * PI3[0][7][5] + sp[34] * PI1[0][5][7] + sp[35] * PI4[0][7][5] + sp[29] * PI5[0][7][5] + sp[32] * PI6[0][7][5] + sp[28] * PI2[0][5][7] + sp[29] * PI5[0][5][7] + sp[26] * PI7[0][7][5] + sp[27] * PI8[0][7][5] + sp[31] * PI3[0][5][7] + sp[32] * PI6[0][5][7] + sp[27] * PI8[0][5][7] + sp[30] * PI9[0][7][5];
    A[111] = sp[33] * PI0[0][7][6] + sp[34] * PI1[0][7][6] + sp[28] * PI2[0][7][6] + sp[31] * PI3[0][7][6] + sp[34] * PI1[0][6][7] + sp[35] * PI4[0][7][6] + sp[29] * PI5[0][7][6] + sp[32] * PI6[0][7][6] + sp[28] * PI2[0][6][7] + sp[29] * PI5[0][6][7] + sp[26] * PI7[0][7][6] + sp[27] * PI8[0][7][6] + sp[31] * PI3[0][6][7] + sp[32] * PI6[0][6][7] + sp[27] * PI8[0][6][7] + sp[30] * PI9[0][7][6];
    A[112] = sp[33] * PI0[0][7][7] + sp[34] * PI1[0][7][7] + sp[28] * PI2[0][7][7] + sp[31] * PI3[0][7][7] + sp[34] * PI1[0][7][7] + sp[35] * PI4[0][7][7] + sp[29] * PI5[0][7][7] + sp[32] * PI6[0][7][7] + sp[28] * PI2[0][7][7] + sp[29] * PI5[0][7][7] + sp[26] * PI7[0][7][7] + sp[27] * PI8[0][7][7] + sp[31] * PI3[0][7][7] + sp[32] * PI6[0][7][7] + sp[27] * PI8[0][7][7] + sp[30] * PI9[0][7][7];
    A[113] = sp[33] * PI0[0][7][8] + sp[34] * PI1[0][7][8] + sp[28] * PI2[0][7][8] + sp[31] * PI3[0][7][8] + sp[34] * PI1[0][8][7] + sp[35] * PI4[0][7][8] + sp[29] * PI5[0][7][8] + sp[32] * PI6[0][7][8] + sp[28] * PI2[0][8][7] + sp[29] * PI5[0][8][7] + sp[26] * PI7[0][7][8] + sp[27] * PI8[0][7][8] + sp[31] * PI3[0][8][7] + sp[32] * PI6[0][8][7] + sp[27] * PI8[0][8][7] + sp[30] * PI9[0][7][8];
    A[114] = sp[33] * PI0[0][7][9] + sp[34] * PI1[0][7][9] + sp[28] * PI2[0][7][9] + sp[31] * PI3[0][7][9] + sp[34] * PI1[0][9][7] + sp[35] * PI4[0][7][9] + sp[29] * PI5[0][7][9] + sp[32] * PI6[0][7][9] + sp[28] * PI2[0][9][7] + sp[29] * PI5[0][9][7] + sp[26] * PI7[0][7][9] + sp[27] * PI8[0][7][9] + sp[31] * PI3[0][9][7] + sp[32] * PI6[0][9][7] + sp[27] * PI8[0][9][7] + sp[30] * PI9[0][7][9];
    A[115] = sp[33] * PI0[0][7][10] + sp[34] * PI1[0][7][10] + sp[28] * PI2[0][7][10] + sp[31] * PI3[0][7][10] + sp[34] * PI1[0][10][7] + sp[35] * PI4[0][7][10] + sp[29] * PI5[0][7][10] + sp[32] * PI6[0][7][10] + sp[28] * PI2[0][10][7] + sp[29] * PI5[0][10][7] + sp[26] * PI7[0][7][10] + sp[27] * PI8[0][7][10] + sp[31] * PI3[0][10][7] + sp[32] * PI6[0][10][7] + sp[27] * PI8[0][10][7] + sp[30] * PI9[0][7][10];
    A[116] = sp[33] * PI0[0][7][11] + sp[34] * PI1[0][7][11] + sp[28] * PI2[0][7][11] + sp[31] * PI3[0][7][11] + sp[34] * PI1[0][11][7] + sp[35] * PI4[0][7][11] + sp[29] * PI5[0][7][11] + sp[32] * PI6[0][7][11] + sp[28] * PI2[0][11][7] + sp[29] * PI5[0][11][7] + sp[26] * PI7[0][7][11] + sp[27] * PI8[0][7][11] + sp[31] * PI3[0][11][7] + sp[32] * PI6[0][11][7] + sp[27] * PI8[0][11][7] + sp[30] * PI9[0][7][11];
    A[117] = sp[33] * PI0[0][7][12] + sp[34] * PI1[0][7][12] + sp[28] * PI2[0][7][12] + sp[31] * PI3[0][7][12] + sp[34] * PI1[0][12][7] + sp[35] * PI4[0][7][12] + sp[29] * PI5[0][7][12] + sp[32] * PI6[0][7][12] + sp[28] * PI2[0][12][7] + sp[29] * PI5[0][12][7] + sp[26] * PI7[0][7][12] + sp[27] * PI8[0][7][12] + sp[31] * PI3[0][12][7] + sp[32] * PI6[0][12][7] + sp[27] * PI8[0][12][7] + sp[30] * PI9[0][7][12];
    A[118] = sp[33] * PI0[0][7][13] + sp[34] * PI1[0][7][13] + sp[28] * PI2[0][7][13] + sp[31] * PI3[0][7][13] + sp[34] * PI1[0][13][7] + sp[35] * PI4[0][7][13] + sp[29] * PI5[0][7][13] + sp[32] * PI6[0][7][13] + sp[28] * PI2[0][13][7] + sp[29] * PI5[0][13][7] + sp[26] * PI7[0][7][13] + sp[27] * PI8[0][7][13] + sp[31] * PI3[0][13][7] + sp[32] * PI6[0][13][7] + sp[27] * PI8[0][13][7] + sp[30] * PI9[0][7][13];
    A[119] = sp[33] * PI0[0][7][14] + sp[34] * PI1[0][7][14] + sp[28] * PI2[0][7][14] + sp[31] * PI3[0][7][14] + sp[34] * PI1[0][14][7] + sp[35] * PI4[0][7][14] + sp[29] * PI5[0][7][14] + sp[32] * PI6[0][7][14] + sp[28] * PI2[0][14][7] + sp[29] * PI5[0][14][7] + sp[26] * PI7[0][7][14] + sp[27] * PI8[0][7][14] + sp[31] * PI3[0][14][7] + sp[32] * PI6[0][14][7] + sp[27] * PI8[0][14][7] + sp[30] * PI9[0][7][14];
    A[120] = sp[33] * PI0[0][8][0] + sp[34] * PI1[0][8][0] + sp[28] * PI2[0][8][0] + sp[31] * PI3[0][8][0] + sp[34] * PI1[0][0][8] + sp[35] * PI4[0][8][0] + sp[29] * PI5[0][8][0] + sp[32] * PI6[0][8][0] + sp[28] * PI2[0][0][8] + sp[29] * PI5[0][0][8] + sp[26] * PI7[0][8][0] + sp[27] * PI8[0][8][0] + sp[31] * PI3[0][0][8] + sp[32] * PI6[0][0][8] + sp[27] * PI8[0][0][8] + sp[30] * PI9[0][8][0];
    A[121] = sp[33] * PI0[0][8][1] + sp[34] * PI1[0][8][1] + sp[28] * PI2[0][8][1] + sp[31] * PI3[0][8][1] + sp[34] * PI1[0][1][8] + sp[35] * PI4[0][8][1] + sp[29] * PI5[0][8][1] + sp[32] * PI6[0][8][1] + sp[28] * PI2[0][1][8] + sp[29] * PI5[0][1][8] + sp[26] * PI7[0][8][1] + sp[27] * PI8[0][8][1] + sp[31] * PI3[0][1][8] + sp[32] * PI6[0][1][8] + sp[27] * PI8[0][1][8] + sp[30] * PI9[0][8][1];
    A[122] = sp[33] * PI0[0][8][2] + sp[34] * PI1[0][8][2] + sp[28] * PI2[0][8][2] + sp[31] * PI3[0][8][2] + sp[34] * PI1[0][2][8] + sp[35] * PI4[0][8][2] + sp[29] * PI5[0][8][2] + sp[32] * PI6[0][8][2] + sp[28] * PI2[0][2][8] + sp[29] * PI5[0][2][8] + sp[26] * PI7[0][8][2] + sp[27] * PI8[0][8][2] + sp[31] * PI3[0][2][8] + sp[32] * PI6[0][2][8] + sp[27] * PI8[0][2][8] + sp[30] * PI9[0][8][2];
    A[123] = sp[33] * PI0[0][8][3] + sp[34] * PI1[0][8][3] + sp[28] * PI2[0][8][3] + sp[31] * PI3[0][8][3] + sp[34] * PI1[0][3][8] + sp[35] * PI4[0][8][3] + sp[29] * PI5[0][8][3] + sp[32] * PI6[0][8][3] + sp[28] * PI2[0][3][8] + sp[29] * PI5[0][3][8] + sp[26] * PI7[0][8][3] + sp[27] * PI8[0][8][3] + sp[31] * PI3[0][3][8] + sp[32] * PI6[0][3][8] + sp[27] * PI8[0][3][8] + sp[30] * PI9[0][8][3];
    A[124] = sp[33] * PI0[0][8][4] + sp[34] * PI1[0][8][4] + sp[28] * PI2[0][8][4] + sp[31] * PI3[0][8][4] + sp[34] * PI1[0][4][8] + sp[35] * PI4[0][8][4] + sp[29] * PI5[0][8][4] + sp[32] * PI6[0][8][4] + sp[28] * PI2[0][4][8] + sp[29] * PI5[0][4][8] + sp[26] * PI7[0][8][4] + sp[27] * PI8[0][8][4] + sp[31] * PI3[0][4][8] + sp[32] * PI6[0][4][8] + sp[27] * PI8[0][4][8] + sp[30] * PI9[0][8][4];
    A[125] = sp[33] * PI0[0][8][5] + sp[34] * PI1[0][8][5] + sp[28] * PI2[0][8][5] + sp[31] * PI3[0][8][5] + sp[34] * PI1[0][5][8] + sp[35] * PI4[0][8][5] + sp[29] * PI5[0][8][5] + sp[32] * PI6[0][8][5] + sp[28] * PI2[0][5][8] + sp[29] * PI5[0][5][8] + sp[26] * PI7[0][8][5] + sp[27] * PI8[0][8][5] + sp[31] * PI3[0][5][8] + sp[32] * PI6[0][5][8] + sp[27] * PI8[0][5][8] + sp[30] * PI9[0][8][5];
    A[126] = sp[33] * PI0[0][8][6] + sp[34] * PI1[0][8][6] + sp[28] * PI2[0][8][6] + sp[31] * PI3[0][8][6] + sp[34] * PI1[0][6][8] + sp[35] * PI4[0][8][6] + sp[29] * PI5[0][8][6] + sp[32] * PI6[0][8][6] + sp[28] * PI2[0][6][8] + sp[29] * PI5[0][6][8] + sp[26] * PI7[0][8][6] + sp[27] * PI8[0][8][6] + sp[31] * PI3[0][6][8] + sp[32] * PI6[0][6][8] + sp[27] * PI8[0][6][8] + sp[30] * PI9[0][8][6];
    A[127] = sp[33] * PI0[0][8][7] + sp[34] * PI1[0][8][7] + sp[28] * PI2[0][8][7] + sp[31] * PI3[0][8][7] + sp[34] * PI1[0][7][8] + sp[35] * PI4[0][8][7] + sp[29] * PI5[0][8][7] + sp[32] * PI6[0][8][7] + sp[28] * PI2[0][7][8] + sp[29] * PI5[0][7][8] + sp[26] * PI7[0][8][7] + sp[27] * PI8[0][8][7] + sp[31] * PI3[0][7][8] + sp[32] * PI6[0][7][8] + sp[27] * PI8[0][7][8] + sp[30] * PI9[0][8][7];
    A[128] = sp[33] * PI0[0][8][8] + sp[34] * PI1[0][8][8] + sp[28] * PI2[0][8][8] + sp[31] * PI3[0][8][8] + sp[34] * PI1[0][8][8] + sp[35] * PI4[0][8][8] + sp[29] * PI5[0][8][8] + sp[32] * PI6[0][8][8] + sp[28] * PI2[0][8][8] + sp[29] * PI5[0][8][8] + sp[26] * PI7[0][8][8] + sp[27] * PI8[0][8][8] + sp[31] * PI3[0][8][8] + sp[32] * PI6[0][8][8] + sp[27] * PI8[0][8][8] + sp[30] * PI9[0][8][8];
    A[129] = sp[33] * PI0[0][8][9] + sp[34] * PI1[0][8][9] + sp[28] * PI2[0][8][9] + sp[31] * PI3[0][8][9] + sp[34] * PI1[0][9][8] + sp[35] * PI4[0][8][9] + sp[29] * PI5[0][8][9] + sp[32] * PI6[0][8][9] + sp[28] * PI2[0][9][8] + sp[29] * PI5[0][9][8] + sp[26] * PI7[0][8][9] + sp[27] * PI8[0][8][9] + sp[31] * PI3[0][9][8] + sp[32] * PI6[0][9][8] + sp[27] * PI8[0][9][8] + sp[30] * PI9[0][8][9];
    A[130] = sp[33] * PI0[0][8][10] + sp[34] * PI1[0][8][10] + sp[28] * PI2[0][8][10] + sp[31] * PI3[0][8][10] + sp[34] * PI1[0][10][8] + sp[35] * PI4[0][8][10] + sp[29] * PI5[0][8][10] + sp[32] * PI6[0][8][10] + sp[28] * PI2[0][10][8] + sp[29] * PI5[0][10][8] + sp[26] * PI7[0][8][10] + sp[27] * PI8[0][8][10] + sp[31] * PI3[0][10][8] + sp[32] * PI6[0][10][8] + sp[27] * PI8[0][10][8] + sp[30] * PI9[0][8][10];
    A[131] = sp[33] * PI0[0][8][11] + sp[34] * PI1[0][8][11] + sp[28] * PI2[0][8][11] + sp[31] * PI3[0][8][11] + sp[34] * PI1[0][11][8] + sp[35] * PI4[0][8][11] + sp[29] * PI5[0][8][11] + sp[32] * PI6[0][8][11] + sp[28] * PI2[0][11][8] + sp[29] * PI5[0][11][8] + sp[26] * PI7[0][8][11] + sp[27] * PI8[0][8][11] + sp[31] * PI3[0][11][8] + sp[32] * PI6[0][11][8] + sp[27] * PI8[0][11][8] + sp[30] * PI9[0][8][11];
    A[132] = sp[33] * PI0[0][8][12] + sp[34] * PI1[0][8][12] + sp[28] * PI2[0][8][12] + sp[31] * PI3[0][8][12] + sp[34] * PI1[0][12][8] + sp[35] * PI4[0][8][12] + sp[29] * PI5[0][8][12] + sp[32] * PI6[0][8][12] + sp[28] * PI2[0][12][8] + sp[29] * PI5[0][12][8] + sp[26] * PI7[0][8][12] + sp[27] * PI8[0][8][12] + sp[31] * PI3[0][12][8] + sp[32] * PI6[0][12][8] + sp[27] * PI8[0][12][8] + sp[30] * PI9[0][8][12];
    A[133] = sp[33] * PI0[0][8][13] + sp[34] * PI1[0][8][13] + sp[28] * PI2[0][8][13] + sp[31] * PI3[0][8][13] + sp[34] * PI1[0][13][8] + sp[35] * PI4[0][8][13] + sp[29] * PI5[0][8][13] + sp[32] * PI6[0][8][13] + sp[28] * PI2[0][13][8] + sp[29] * PI5[0][13][8] + sp[26] * PI7[0][8][13] + sp[27] * PI8[0][8][13] + sp[31] * PI3[0][13][8] + sp[32] * PI6[0][13][8] + sp[27] * PI8[0][13][8] + sp[30] * PI9[0][8][13];
    A[134] = sp[33] * PI0[0][8][14] + sp[34] * PI1[0][8][14] + sp[28] * PI2[0][8][14] + sp[31] * PI3[0][8][14] + sp[34] * PI1[0][14][8] + sp[35] * PI4[0][8][14] + sp[29] * PI5[0][8][14] + sp[32] * PI6[0][8][14] + sp[28] * PI2[0][14][8] + sp[29] * PI5[0][14][8] + sp[26] * PI7[0][8][14] + sp[27] * PI8[0][8][14] + sp[31] * PI3[0][14][8] + sp[32] * PI6[0][14][8] + sp[27] * PI8[0][14][8] + sp[30] * PI9[0][8][14];
    A[135] = sp[33] * PI0[0][9][0] + sp[34] * PI1[0][9][0] + sp[28] * PI2[0][9][0] + sp[31] * PI3[0][9][0] + sp[34] * PI1[0][0][9] + sp[35] * PI4[0][9][0] + sp[29] * PI5[0][9][0] + sp[32] * PI6[0][9][0] + sp[28] * PI2[0][0][9] + sp[29] * PI5[0][0][9] + sp[26] * PI7[0][9][0] + sp[27] * PI8[0][9][0] + sp[31] * PI3[0][0][9] + sp[32] * PI6[0][0][9] + sp[27] * PI8[0][0][9] + sp[30] * PI9[0][9][0];
    A[136] = sp[33] * PI0[0][9][1] + sp[34] * PI1[0][9][1] + sp[28] * PI2[0][9][1] + sp[31] * PI3[0][9][1] + sp[34] * PI1[0][1][9] + sp[35] * PI4[0][9][1] + sp[29] * PI5[0][9][1] + sp[32] * PI6[0][9][1] + sp[28] * PI2[0][1][9] + sp[29] * PI5[0][1][9] + sp[26] * PI7[0][9][1] + sp[27] * PI8[0][9][1] + sp[31] * PI3[0][1][9] + sp[32] * PI6[0][1][9] + sp[27] * PI8[0][1][9] + sp[30] * PI9[0][9][1];
    A[137] = sp[33] * PI0[0][9][2] + sp[34] * PI1[0][9][2] + sp[28] * PI2[0][9][2] + sp[31] * PI3[0][9][2] + sp[34] * PI1[0][2][9] + sp[35] * PI4[0][9][2] + sp[29] * PI5[0][9][2] + sp[32] * PI6[0][9][2] + sp[28] * PI2[0][2][9] + sp[29] * PI5[0][2][9] + sp[26] * PI7[0][9][2] + sp[27] * PI8[0][9][2] + sp[31] * PI3[0][2][9] + sp[32] * PI6[0][2][9] + sp[27] * PI8[0][2][9] + sp[30] * PI9[0][9][2];
    A[138] = sp[33] * PI0[0][9][3] + sp[34] * PI1[0][9][3] + sp[28] * PI2[0][9][3] + sp[31] * PI3[0][9][3] + sp[34] * PI1[0][3][9] + sp[35] * PI4[0][9][3] + sp[29] * PI5[0][9][3] + sp[32] * PI6[0][9][3] + sp[28] * PI2[0][3][9] + sp[29] * PI5[0][3][9] + sp[26] * PI7[0][9][3] + sp[27] * PI8[0][9][3] + sp[31] * PI3[0][3][9] + sp[32] * PI6[0][3][9] + sp[27] * PI8[0][3][9] + sp[30] * PI9[0][9][3];
    A[139] = sp[33] * PI0[0][9][4] + sp[34] * PI1[0][9][4] + sp[28] * PI2[0][9][4] + sp[31] * PI3[0][9][4] + sp[34] * PI1[0][4][9] + sp[35] * PI4[0][9][4] + sp[29] * PI5[0][9][4] + sp[32] * PI6[0][9][4] + sp[28] * PI2[0][4][9] + sp[29] * PI5[0][4][9] + sp[26] * PI7[0][9][4] + sp[27] * PI8[0][9][4] + sp[31] * PI3[0][4][9] + sp[32] * PI6[0][4][9] + sp[27] * PI8[0][4][9] + sp[30] * PI9[0][9][4];
    A[140] = sp[33] * PI0[0][9][5] + sp[34] * PI1[0][9][5] + sp[28] * PI2[0][9][5] + sp[31] * PI3[0][9][5] + sp[34] * PI1[0][5][9] + sp[35] * PI4[0][9][5] + sp[29] * PI5[0][9][5] + sp[32] * PI6[0][9][5] + sp[28] * PI2[0][5][9] + sp[29] * PI5[0][5][9] + sp[26] * PI7[0][9][5] + sp[27] * PI8[0][9][5] + sp[31] * PI3[0][5][9] + sp[32] * PI6[0][5][9] + sp[27] * PI8[0][5][9] + sp[30] * PI9[0][9][5];
    A[141] = sp[33] * PI0[0][9][6] + sp[34] * PI1[0][9][6] + sp[28] * PI2[0][9][6] + sp[31] * PI3[0][9][6] + sp[34] * PI1[0][6][9] + sp[35] * PI4[0][9][6] + sp[29] * PI5[0][9][6] + sp[32] * PI6[0][9][6] + sp[28] * PI2[0][6][9] + sp[29] * PI5[0][6][9] + sp[26] * PI7[0][9][6] + sp[27] * PI8[0][9][6] + sp[31] * PI3[0][6][9] + sp[32] * PI6[0][6][9] + sp[27] * PI8[0][6][9] + sp[30] * PI9[0][9][6];
    A[142] = sp[33] * PI0[0][9][7] + sp[34] * PI1[0][9][7] + sp[28] * PI2[0][9][7] + sp[31] * PI3[0][9][7] + sp[34] * PI1[0][7][9] + sp[35] * PI4[0][9][7] + sp[29] * PI5[0][9][7] + sp[32] * PI6[0][9][7] + sp[28] * PI2[0][7][9] + sp[29] * PI5[0][7][9] + sp[26] * PI7[0][9][7] + sp[27] * PI8[0][9][7] + sp[31] * PI3[0][7][9] + sp[32] * PI6[0][7][9] + sp[27] * PI8[0][7][9] + sp[30] * PI9[0][9][7];
    A[143] = sp[33] * PI0[0][9][8] + sp[34] * PI1[0][9][8] + sp[28] * PI2[0][9][8] + sp[31] * PI3[0][9][8] + sp[34] * PI1[0][8][9] + sp[35] * PI4[0][9][8] + sp[29] * PI5[0][9][8] + sp[32] * PI6[0][9][8] + sp[28] * PI2[0][8][9] + sp[29] * PI5[0][8][9] + sp[26] * PI7[0][9][8] + sp[27] * PI8[0][9][8] + sp[31] * PI3[0][8][9] + sp[32] * PI6[0][8][9] + sp[27] * PI8[0][8][9] + sp[30] * PI9[0][9][8];
    A[144] = sp[33] * PI0[0][9][9] + sp[34] * PI1[0][9][9] + sp[28] * PI2[0][9][9] + sp[31] * PI3[0][9][9] + sp[34] * PI1[0][9][9] + sp[35] * PI4[0][9][9] + sp[29] * PI5[0][9][9] + sp[32] * PI6[0][9][9] + sp[28] * PI2[0][9][9] + sp[29] * PI5[0][9][9] + sp[26] * PI7[0][9][9] + sp[27] * PI8[0][9][9] + sp[31] * PI3[0][9][9] + sp[32] * PI6[0][9][9] + sp[27] * PI8[0][9][9] + sp[30] * PI9[0][9][9];
    A[145] = sp[33] * PI0[0][9][10] + sp[34] * PI1[0][9][10] + sp[28] * PI2[0][9][10] + sp[31] * PI3[0][9][10] + sp[34] * PI1[0][10][9] + sp[35] * PI4[0][9][10] + sp[29] * PI5[0][9][10] + sp[32] * PI6[0][9][10] + sp[28] * PI2[0][10][9] + sp[29] * PI5[0][10][9] + sp[26] * PI7[0][9][10] + sp[27] * PI8[0][9][10] + sp[31] * PI3[0][10][9] + sp[32] * PI6[0][10][9] + sp[27] * PI8[0][10][9] + sp[30] * PI9[0][9][10];
    A[146] = sp[33] * PI0[0][9][11] + sp[34] * PI1[0][9][11] + sp[28] * PI2[0][9][11] + sp[31] * PI3[0][9][11] + sp[34] * PI1[0][11][9] + sp[35] * PI4[0][9][11] + sp[29] * PI5[0][9][11] + sp[32] * PI6[0][9][11] + sp[28] * PI2[0][11][9] + sp[29] * PI5[0][11][9] + sp[26] * PI7[0][9][11] + sp[27] * PI8[0][9][11] + sp[31] * PI3[0][11][9] + sp[32] * PI6[0][11][9] + sp[27] * PI8[0][11][9] + sp[30] * PI9[0][9][11];
    A[147] = sp[33] * PI0[0][9][12] + sp[34] * PI1[0][9][12] + sp[28] * PI2[0][9][12] + sp[31] * PI3[0][9][12] + sp[34] * PI1[0][12][9] + sp[35] * PI4[0][9][12] + sp[29] * PI5[0][9][12] + sp[32] * PI6[0][9][12] + sp[28] * PI2[0][12][9] + sp[29] * PI5[0][12][9] + sp[26] * PI7[0][9][12] + sp[27] * PI8[0][9][12] + sp[31] * PI3[0][12][9] + sp[32] * PI6[0][12][9] + sp[27] * PI8[0][12][9] + sp[30] * PI9[0][9][12];
    A[148] = sp[33] * PI0[0][9][13] + sp[34] * PI1[0][9][13] + sp[28] * PI2[0][9][13] + sp[31] * PI3[0][9][13] + sp[34] * PI1[0][13][9] + sp[35] * PI4[0][9][13] + sp[29] * PI5[0][9][13] + sp[32] * PI6[0][9][13] + sp[28] * PI2[0][13][9] + sp[29] * PI5[0][13][9] + sp[26] * PI7[0][9][13] + sp[27] * PI8[0][9][13] + sp[31] * PI3[0][13][9] + sp[32] * PI6[0][13][9] + sp[27] * PI8[0][13][9] + sp[30] * PI9[0][9][13];
    A[149] = sp[33] * PI0[0][9][14] + sp[34] * PI1[0][9][14] + sp[28] * PI2[0][9][14] + sp[31] * PI3[0][9][14] + sp[34] * PI1[0][14][9] + sp[35] * PI4[0][9][14] + sp[29] * PI5[0][9][14] + sp[32] * PI6[0][9][14] + sp[28] * PI2[0][14][9] + sp[29] * PI5[0][14][9] + sp[26] * PI7[0][9][14] + sp[27] * PI8[0][9][14] + sp[31] * PI3[0][14][9] + sp[32] * PI6[0][14][9] + sp[27] * PI8[0][14][9] + sp[30] * PI9[0][9][14];
    A[150] = sp[33] * PI0[0][10][0] + sp[34] * PI1[0][10][0] + sp[28] * PI2[0][10][0] + sp[31] * PI3[0][10][0] + sp[34] * PI1[0][0][10] + sp[35] * PI4[0][10][0] + sp[29] * PI5[0][10][0] + sp[32] * PI6[0][10][0] + sp[28] * PI2[0][0][10] + sp[29] * PI5[0][0][10] + sp[26] * PI7[0][10][0] + sp[27] * PI8[0][10][0] + sp[31] * PI3[0][0][10] + sp[32] * PI6[0][0][10] + sp[27] * PI8[0][0][10] + sp[30] * PI9[0][10][0];
    A[151] = sp[33] * PI0[0][10][1] + sp[34] * PI1[0][10][1] + sp[28] * PI2[0][10][1] + sp[31] * PI3[0][10][1] + sp[34] * PI1[0][1][10] + sp[35] * PI4[0][10][1] + sp[29] * PI5[0][10][1] + sp[32] * PI6[0][10][1] + sp[28] * PI2[0][1][10] + sp[29] * PI5[0][1][10] + sp[26] * PI7[0][10][1] + sp[27] * PI8[0][10][1] + sp[31] * PI3[0][1][10] + sp[32] * PI6[0][1][10] + sp[27] * PI8[0][1][10] + sp[30] * PI9[0][10][1];
    A[152] = sp[33] * PI0[0][10][2] + sp[34] * PI1[0][10][2] + sp[28] * PI2[0][10][2] + sp[31] * PI3[0][10][2] + sp[34] * PI1[0][2][10] + sp[35] * PI4[0][10][2] + sp[29] * PI5[0][10][2] + sp[32] * PI6[0][10][2] + sp[28] * PI2[0][2][10] + sp[29] * PI5[0][2][10] + sp[26] * PI7[0][10][2] + sp[27] * PI8[0][10][2] + sp[31] * PI3[0][2][10] + sp[32] * PI6[0][2][10] + sp[27] * PI8[0][2][10] + sp[30] * PI9[0][10][2];
    A[153] = sp[33] * PI0[0][10][3] + sp[34] * PI1[0][10][3] + sp[28] * PI2[0][10][3] + sp[31] * PI3[0][10][3] + sp[34] * PI1[0][3][10] + sp[35] * PI4[0][10][3] + sp[29] * PI5[0][10][3] + sp[32] * PI6[0][10][3] + sp[28] * PI2[0][3][10] + sp[29] * PI5[0][3][10] + sp[26] * PI7[0][10][3] + sp[27] * PI8[0][10][3] + sp[31] * PI3[0][3][10] + sp[32] * PI6[0][3][10] + sp[27] * PI8[0][3][10] + sp[30] * PI9[0][10][3];
    A[154] = sp[33] * PI0[0][10][4] + sp[34] * PI1[0][10][4] + sp[28] * PI2[0][10][4] + sp[31] * PI3[0][10][4] + sp[34] * PI1[0][4][10] + sp[35] * PI4[0][10][4] + sp[29] * PI5[0][10][4] + sp[32] * PI6[0][10][4] + sp[28] * PI2[0][4][10] + sp[29] * PI5[0][4][10] + sp[26] * PI7[0][10][4] + sp[27] * PI8[0][10][4] + sp[31] * PI3[0][4][10] + sp[32] * PI6[0][4][10] + sp[27] * PI8[0][4][10] + sp[30] * PI9[0][10][4];
    A[155] = sp[33] * PI0[0][10][5] + sp[34] * PI1[0][10][5] + sp[28] * PI2[0][10][5] + sp[31] * PI3[0][10][5] + sp[34] * PI1[0][5][10] + sp[35] * PI4[0][10][5] + sp[29] * PI5[0][10][5] + sp[32] * PI6[0][10][5] + sp[28] * PI2[0][5][10] + sp[29] * PI5[0][5][10] + sp[26] * PI7[0][10][5] + sp[27] * PI8[0][10][5] + sp[31] * PI3[0][5][10] + sp[32] * PI6[0][5][10] + sp[27] * PI8[0][5][10] + sp[30] * PI9[0][10][5];
    A[156] = sp[33] * PI0[0][10][6] + sp[34] * PI1[0][10][6] + sp[28] * PI2[0][10][6] + sp[31] * PI3[0][10][6] + sp[34] * PI1[0][6][10] + sp[35] * PI4[0][10][6] + sp[29] * PI5[0][10][6] + sp[32] * PI6[0][10][6] + sp[28] * PI2[0][6][10] + sp[29] * PI5[0][6][10] + sp[26] * PI7[0][10][6] + sp[27] * PI8[0][10][6] + sp[31] * PI3[0][6][10] + sp[32] * PI6[0][6][10] + sp[27] * PI8[0][6][10] + sp[30] * PI9[0][10][6];
    A[157] = sp[33] * PI0[0][10][7] + sp[34] * PI1[0][10][7] + sp[28] * PI2[0][10][7] + sp[31] * PI3[0][10][7] + sp[34] * PI1[0][7][10] + sp[35] * PI4[0][10][7] + sp[29] * PI5[0][10][7] + sp[32] * PI6[0][10][7] + sp[28] * PI2[0][7][10] + sp[29] * PI5[0][7][10] + sp[26] * PI7[0][10][7] + sp[27] * PI8[0][10][7] + sp[31] * PI3[0][7][10] + sp[32] * PI6[0][7][10] + sp[27] * PI8[0][7][10] + sp[30] * PI9[0][10][7];
    A[158] = sp[33] * PI0[0][10][8] + sp[34] * PI1[0][10][8] + sp[28] * PI2[0][10][8] + sp[31] * PI3[0][10][8] + sp[34] * PI1[0][8][10] + sp[35] * PI4[0][10][8] + sp[29] * PI5[0][10][8] + sp[32] * PI6[0][10][8] + sp[28] * PI2[0][8][10] + sp[29] * PI5[0][8][10] + sp[26] * PI7[0][10][8] + sp[27] * PI8[0][10][8] + sp[31] * PI3[0][8][10] + sp[32] * PI6[0][8][10] + sp[27] * PI8[0][8][10] + sp[30] * PI9[0][10][8];
    A[159] = sp[33] * PI0[0][10][9] + sp[34] * PI1[0][10][9] + sp[28] * PI2[0][10][9] + sp[31] * PI3[0][10][9] + sp[34] * PI1[0][9][10] + sp[35] * PI4[0][10][9] + sp[29] * PI5[0][10][9] + sp[32] * PI6[0][10][9] + sp[28] * PI2[0][9][10] + sp[29] * PI5[0][9][10] + sp[26] * PI7[0][10][9] + sp[27] * PI8[0][10][9] + sp[31] * PI3[0][9][10] + sp[32] * PI6[0][9][10] + sp[27] * PI8[0][9][10] + sp[30] * PI9[0][10][9];
    A[160] = sp[33] * PI0[0][10][10] + sp[34] * PI1[0][10][10] + sp[28] * PI2[0][10][10] + sp[31] * PI3[0][10][10] + sp[34] * PI1[0][10][10] + sp[35] * PI4[0][10][10] + sp[29] * PI5[0][10][10] + sp[32] * PI6[0][10][10] + sp[28] * PI2[0][10][10] + sp[29] * PI5[0][10][10] + sp[26] * PI7[0][10][10] + sp[27] * PI8[0][10][10] + sp[31] * PI3[0][10][10] + sp[32] * PI6[0][10][10] + sp[27] * PI8[0][10][10] + sp[30] * PI9[0][10][10];
    A[161] = sp[33] * PI0[0][10][11] + sp[34] * PI1[0][10][11] + sp[28] * PI2[0][10][11] + sp[31] * PI3[0][10][11] + sp[34] * PI1[0][11][10] + sp[35] * PI4[0][10][11] + sp[29] * PI5[0][10][11] + sp[32] * PI6[0][10][11] + sp[28] * PI2[0][11][10] + sp[29] * PI5[0][11][10] + sp[26] * PI7[0][10][11] + sp[27] * PI8[0][10][11] + sp[31] * PI3[0][11][10] + sp[32] * PI6[0][11][10] + sp[27] * PI8[0][11][10] + sp[30] * PI9[0][10][11];
    A[162] = sp[33] * PI0[0][10][12] + sp[34] * PI1[0][10][12] + sp[28] * PI2[0][10][12] + sp[31] * PI3[0][10][12] + sp[34] * PI1[0][12][10] + sp[35] * PI4[0][10][12] + sp[29] * PI5[0][10][12] + sp[32] * PI6[0][10][12] + sp[28] * PI2[0][12][10] + sp[29] * PI5[0][12][10] + sp[26] * PI7[0][10][12] + sp[27] * PI8[0][10][12] + sp[31] * PI3[0][12][10] + sp[32] * PI6[0][12][10] + sp[27] * PI8[0][12][10] + sp[30] * PI9[0][10][12];
    A[163] = sp[33] * PI0[0][10][13] + sp[34] * PI1[0][10][13] + sp[28] * PI2[0][10][13] + sp[31] * PI3[0][10][13] + sp[34] * PI1[0][13][10] + sp[35] * PI4[0][10][13] + sp[29] * PI5[0][10][13] + sp[32] * PI6[0][10][13] + sp[28] * PI2[0][13][10] + sp[29] * PI5[0][13][10] + sp[26] * PI7[0][10][13] + sp[27] * PI8[0][10][13] + sp[31] * PI3[0][13][10] + sp[32] * PI6[0][13][10] + sp[27] * PI8[0][13][10] + sp[30] * PI9[0][10][13];
    A[164] = sp[33] * PI0[0][10][14] + sp[34] * PI1[0][10][14] + sp[28] * PI2[0][10][14] + sp[31] * PI3[0][10][14] + sp[34] * PI1[0][14][10] + sp[35] * PI4[0][10][14] + sp[29] * PI5[0][10][14] + sp[32] * PI6[0][10][14] + sp[28] * PI2[0][14][10] + sp[29] * PI5[0][14][10] + sp[26] * PI7[0][10][14] + sp[27] * PI8[0][10][14] + sp[31] * PI3[0][14][10] + sp[32] * PI6[0][14][10] + sp[27] * PI8[0][14][10] + sp[30] * PI9[0][10][14];
    A[165] = sp[33] * PI0[0][11][0] + sp[34] * PI1[0][11][0] + sp[28] * PI2[0][11][0] + sp[31] * PI3[0][11][0] + sp[34] * PI1[0][0][11] + sp[35] * PI4[0][11][0] + sp[29] * PI5[0][11][0] + sp[32] * PI6[0][11][0] + sp[28] * PI2[0][0][11] + sp[29] * PI5[0][0][11] + sp[26] * PI7[0][11][0] + sp[27] * PI8[0][11][0] + sp[31] * PI3[0][0][11] + sp[32] * PI6[0][0][11] + sp[27] * PI8[0][0][11] + sp[30] * PI9[0][11][0];
    A[166] = sp[33] * PI0[0][11][1] + sp[34] * PI1[0][11][1] + sp[28] * PI2[0][11][1] + sp[31] * PI3[0][11][1] + sp[34] * PI1[0][1][11] + sp[35] * PI4[0][11][1] + sp[29] * PI5[0][11][1] + sp[32] * PI6[0][11][1] + sp[28] * PI2[0][1][11] + sp[29] * PI5[0][1][11] + sp[26] * PI7[0][11][1] + sp[27] * PI8[0][11][1] + sp[31] * PI3[0][1][11] + sp[32] * PI6[0][1][11] + sp[27] * PI8[0][1][11] + sp[30] * PI9[0][11][1];
    A[167] = sp[33] * PI0[0][11][2] + sp[34] * PI1[0][11][2] + sp[28] * PI2[0][11][2] + sp[31] * PI3[0][11][2] + sp[34] * PI1[0][2][11] + sp[35] * PI4[0][11][2] + sp[29] * PI5[0][11][2] + sp[32] * PI6[0][11][2] + sp[28] * PI2[0][2][11] + sp[29] * PI5[0][2][11] + sp[26] * PI7[0][11][2] + sp[27] * PI8[0][11][2] + sp[31] * PI3[0][2][11] + sp[32] * PI6[0][2][11] + sp[27] * PI8[0][2][11] + sp[30] * PI9[0][11][2];
    A[168] = sp[33] * PI0[0][11][3] + sp[34] * PI1[0][11][3] + sp[28] * PI2[0][11][3] + sp[31] * PI3[0][11][3] + sp[34] * PI1[0][3][11] + sp[35] * PI4[0][11][3] + sp[29] * PI5[0][11][3] + sp[32] * PI6[0][11][3] + sp[28] * PI2[0][3][11] + sp[29] * PI5[0][3][11] + sp[26] * PI7[0][11][3] + sp[27] * PI8[0][11][3] + sp[31] * PI3[0][3][11] + sp[32] * PI6[0][3][11] + sp[27] * PI8[0][3][11] + sp[30] * PI9[0][11][3];
    A[169] = sp[33] * PI0[0][11][4] + sp[34] * PI1[0][11][4] + sp[28] * PI2[0][11][4] + sp[31] * PI3[0][11][4] + sp[34] * PI1[0][4][11] + sp[35] * PI4[0][11][4] + sp[29] * PI5[0][11][4] + sp[32] * PI6[0][11][4] + sp[28] * PI2[0][4][11] + sp[29] * PI5[0][4][11] + sp[26] * PI7[0][11][4] + sp[27] * PI8[0][11][4] + sp[31] * PI3[0][4][11] + sp[32] * PI6[0][4][11] + sp[27] * PI8[0][4][11] + sp[30] * PI9[0][11][4];
    A[170] = sp[33] * PI0[0][11][5] + sp[34] * PI1[0][11][5] + sp[28] * PI2[0][11][5] + sp[31] * PI3[0][11][5] + sp[34] * PI1[0][5][11] + sp[35] * PI4[0][11][5] + sp[29] * PI5[0][11][5] + sp[32] * PI6[0][11][5] + sp[28] * PI2[0][5][11] + sp[29] * PI5[0][5][11] + sp[26] * PI7[0][11][5] + sp[27] * PI8[0][11][5] + sp[31] * PI3[0][5][11] + sp[32] * PI6[0][5][11] + sp[27] * PI8[0][5][11] + sp[30] * PI9[0][11][5];
    A[171] = sp[33] * PI0[0][11][6] + sp[34] * PI1[0][11][6] + sp[28] * PI2[0][11][6] + sp[31] * PI3[0][11][6] + sp[34] * PI1[0][6][11] + sp[35] * PI4[0][11][6] + sp[29] * PI5[0][11][6] + sp[32] * PI6[0][11][6] + sp[28] * PI2[0][6][11] + sp[29] * PI5[0][6][11] + sp[26] * PI7[0][11][6] + sp[27] * PI8[0][11][6] + sp[31] * PI3[0][6][11] + sp[32] * PI6[0][6][11] + sp[27] * PI8[0][6][11] + sp[30] * PI9[0][11][6];
    A[172] = sp[33] * PI0[0][11][7] + sp[34] * PI1[0][11][7] + sp[28] * PI2[0][11][7] + sp[31] * PI3[0][11][7] + sp[34] * PI1[0][7][11] + sp[35] * PI4[0][11][7] + sp[29] * PI5[0][11][7] + sp[32] * PI6[0][11][7] + sp[28] * PI2[0][7][11] + sp[29] * PI5[0][7][11] + sp[26] * PI7[0][11][7] + sp[27] * PI8[0][11][7] + sp[31] * PI3[0][7][11] + sp[32] * PI6[0][7][11] + sp[27] * PI8[0][7][11] + sp[30] * PI9[0][11][7];
    A[173] = sp[33] * PI0[0][11][8] + sp[34] * PI1[0][11][8] + sp[28] * PI2[0][11][8] + sp[31] * PI3[0][11][8] + sp[34] * PI1[0][8][11] + sp[35] * PI4[0][11][8] + sp[29] * PI5[0][11][8] + sp[32] * PI6[0][11][8] + sp[28] * PI2[0][8][11] + sp[29] * PI5[0][8][11] + sp[26] * PI7[0][11][8] + sp[27] * PI8[0][11][8] + sp[31] * PI3[0][8][11] + sp[32] * PI6[0][8][11] + sp[27] * PI8[0][8][11] + sp[30] * PI9[0][11][8];
    A[174] = sp[33] * PI0[0][11][9] + sp[34] * PI1[0][11][9] + sp[28] * PI2[0][11][9] + sp[31] * PI3[0][11][9] + sp[34] * PI1[0][9][11] + sp[35] * PI4[0][11][9] + sp[29] * PI5[0][11][9] + sp[32] * PI6[0][11][9] + sp[28] * PI2[0][9][11] + sp[29] * PI5[0][9][11] + sp[26] * PI7[0][11][9] + sp[27] * PI8[0][11][9] + sp[31] * PI3[0][9][11] + sp[32] * PI6[0][9][11] + sp[27] * PI8[0][9][11] + sp[30] * PI9[0][11][9];
    A[175] = sp[33] * PI0[0][11][10] + sp[34] * PI1[0][11][10] + sp[28] * PI2[0][11][10] + sp[31] * PI3[0][11][10] + sp[34] * PI1[0][10][11] + sp[35] * PI4[0][11][10] + sp[29] * PI5[0][11][10] + sp[32] * PI6[0][11][10] + sp[28] * PI2[0][10][11] + sp[29] * PI5[0][10][11] + sp[26] * PI7[0][11][10] + sp[27] * PI8[0][11][10] + sp[31] * PI3[0][10][11] + sp[32] * PI6[0][10][11] + sp[27] * PI8[0][10][11] + sp[30] * PI9[0][11][10];
    A[176] = sp[33] * PI0[0][11][11] + sp[34] * PI1[0][11][11] + sp[28] * PI2[0][11][11] + sp[31] * PI3[0][11][11] + sp[34] * PI1[0][11][11] + sp[35] * PI4[0][11][11] + sp[29] * PI5[0][11][11] + sp[32] * PI6[0][11][11] + sp[28] * PI2[0][11][11] + sp[29] * PI5[0][11][11] + sp[26] * PI7[0][11][11] + sp[27] * PI8[0][11][11] + sp[31] * PI3[0][11][11] + sp[32] * PI6[0][11][11] + sp[27] * PI8[0][11][11] + sp[30] * PI9[0][11][11];
    A[177] = sp[33] * PI0[0][11][12] + sp[34] * PI1[0][11][12] + sp[28] * PI2[0][11][12] + sp[31] * PI3[0][11][12] + sp[34] * PI1[0][12][11] + sp[35] * PI4[0][11][12] + sp[29] * PI5[0][11][12] + sp[32] * PI6[0][11][12] + sp[28] * PI2[0][12][11] + sp[29] * PI5[0][12][11] + sp[26] * PI7[0][11][12] + sp[27] * PI8[0][11][12] + sp[31] * PI3[0][12][11] + sp[32] * PI6[0][12][11] + sp[27] * PI8[0][12][11] + sp[30] * PI9[0][11][12];
    A[178] = sp[33] * PI0[0][11][13] + sp[34] * PI1[0][11][13] + sp[28] * PI2[0][11][13] + sp[31] * PI3[0][11][13] + sp[34] * PI1[0][13][11] + sp[35] * PI4[0][11][13] + sp[29] * PI5[0][11][13] + sp[32] * PI6[0][11][13] + sp[28] * PI2[0][13][11] + sp[29] * PI5[0][13][11] + sp[26] * PI7[0][11][13] + sp[27] * PI8[0][11][13] + sp[31] * PI3[0][13][11] + sp[32] * PI6[0][13][11] + sp[27] * PI8[0][13][11] + sp[30] * PI9[0][11][13];
    A[179] = sp[33] * PI0[0][11][14] + sp[34] * PI1[0][11][14] + sp[28] * PI2[0][11][14] + sp[31] * PI3[0][11][14] + sp[34] * PI1[0][14][11] + sp[35] * PI4[0][11][14] + sp[29] * PI5[0][11][14] + sp[32] * PI6[0][11][14] + sp[28] * PI2[0][14][11] + sp[29] * PI5[0][14][11] + sp[26] * PI7[0][11][14] + sp[27] * PI8[0][11][14] + sp[31] * PI3[0][14][11] + sp[32] * PI6[0][14][11] + sp[27] * PI8[0][14][11] + sp[30] * PI9[0][11][14];
    A[180] = sp[33] * PI0[0][12][0] + sp[34] * PI1[0][12][0] + sp[28] * PI2[0][12][0] + sp[31] * PI3[0][12][0] + sp[34] * PI1[0][0][12] + sp[35] * PI4[0][12][0] + sp[29] * PI5[0][12][0] + sp[32] * PI6[0][12][0] + sp[28] * PI2[0][0][12] + sp[29] * PI5[0][0][12] + sp[26] * PI7[0][12][0] + sp[27] * PI8[0][12][0] + sp[31] * PI3[0][0][12] + sp[32] * PI6[0][0][12] + sp[27] * PI8[0][0][12] + sp[30] * PI9[0][12][0];
    A[181] = sp[33] * PI0[0][12][1] + sp[34] * PI1[0][12][1] + sp[28] * PI2[0][12][1] + sp[31] * PI3[0][12][1] + sp[34] * PI1[0][1][12] + sp[35] * PI4[0][12][1] + sp[29] * PI5[0][12][1] + sp[32] * PI6[0][12][1] + sp[28] * PI2[0][1][12] + sp[29] * PI5[0][1][12] + sp[26] * PI7[0][12][1] + sp[27] * PI8[0][12][1] + sp[31] * PI3[0][1][12] + sp[32] * PI6[0][1][12] + sp[27] * PI8[0][1][12] + sp[30] * PI9[0][12][1];
    A[182] = sp[33] * PI0[0][12][2] + sp[34] * PI1[0][12][2] + sp[28] * PI2[0][12][2] + sp[31] * PI3[0][12][2] + sp[34] * PI1[0][2][12] + sp[35] * PI4[0][12][2] + sp[29] * PI5[0][12][2] + sp[32] * PI6[0][12][2] + sp[28] * PI2[0][2][12] + sp[29] * PI5[0][2][12] + sp[26] * PI7[0][12][2] + sp[27] * PI8[0][12][2] + sp[31] * PI3[0][2][12] + sp[32] * PI6[0][2][12] + sp[27] * PI8[0][2][12] + sp[30] * PI9[0][12][2];
    A[183] = sp[33] * PI0[0][12][3] + sp[34] * PI1[0][12][3] + sp[28] * PI2[0][12][3] + sp[31] * PI3[0][12][3] + sp[34] * PI1[0][3][12] + sp[35] * PI4[0][12][3] + sp[29] * PI5[0][12][3] + sp[32] * PI6[0][12][3] + sp[28] * PI2[0][3][12] + sp[29] * PI5[0][3][12] + sp[26] * PI7[0][12][3] + sp[27] * PI8[0][12][3] + sp[31] * PI3[0][3][12] + sp[32] * PI6[0][3][12] + sp[27] * PI8[0][3][12] + sp[30] * PI9[0][12][3];
    A[184] = sp[33] * PI0[0][12][4] + sp[34] * PI1[0][12][4] + sp[28] * PI2[0][12][4] + sp[31] * PI3[0][12][4] + sp[34] * PI1[0][4][12] + sp[35] * PI4[0][12][4] + sp[29] * PI5[0][12][4] + sp[32] * PI6[0][12][4] + sp[28] * PI2[0][4][12] + sp[29] * PI5[0][4][12] + sp[26] * PI7[0][12][4] + sp[27] * PI8[0][12][4] + sp[31] * PI3[0][4][12] + sp[32] * PI6[0][4][12] + sp[27] * PI8[0][4][12] + sp[30] * PI9[0][12][4];
    A[185] = sp[33] * PI0[0][12][5] + sp[34] * PI1[0][12][5] + sp[28] * PI2[0][12][5] + sp[31] * PI3[0][12][5] + sp[34] * PI1[0][5][12] + sp[35] * PI4[0][12][5] + sp[29] * PI5[0][12][5] + sp[32] * PI6[0][12][5] + sp[28] * PI2[0][5][12] + sp[29] * PI5[0][5][12] + sp[26] * PI7[0][12][5] + sp[27] * PI8[0][12][5] + sp[31] * PI3[0][5][12] + sp[32] * PI6[0][5][12] + sp[27] * PI8[0][5][12] + sp[30] * PI9[0][12][5];
    A[186] = sp[33] * PI0[0][12][6] + sp[34] * PI1[0][12][6] + sp[28] * PI2[0][12][6] + sp[31] * PI3[0][12][6] + sp[34] * PI1[0][6][12] + sp[35] * PI4[0][12][6] + sp[29] * PI5[0][12][6] + sp[32] * PI6[0][12][6] + sp[28] * PI2[0][6][12] + sp[29] * PI5[0][6][12] + sp[26] * PI7[0][12][6] + sp[27] * PI8[0][12][6] + sp[31] * PI3[0][6][12] + sp[32] * PI6[0][6][12] + sp[27] * PI8[0][6][12] + sp[30] * PI9[0][12][6];
    A[187] = sp[33] * PI0[0][12][7] + sp[34] * PI1[0][12][7] + sp[28] * PI2[0][12][7] + sp[31] * PI3[0][12][7] + sp[34] * PI1[0][7][12] + sp[35] * PI4[0][12][7] + sp[29] * PI5[0][12][7] + sp[32] * PI6[0][12][7] + sp[28] * PI2[0][7][12] + sp[29] * PI5[0][7][12] + sp[26] * PI7[0][12][7] + sp[27] * PI8[0][12][7] + sp[31] * PI3[0][7][12] + sp[32] * PI6[0][7][12] + sp[27] * PI8[0][7][12] + sp[30] * PI9[0][12][7];
    A[188] = sp[33] * PI0[0][12][8] + sp[34] * PI1[0][12][8] + sp[28] * PI2[0][12][8] + sp[31] * PI3[0][12][8] + sp[34] * PI1[0][8][12] + sp[35] * PI4[0][12][8] + sp[29] * PI5[0][12][8] + sp[32] * PI6[0][12][8] + sp[28] * PI2[0][8][12] + sp[29] * PI5[0][8][12] + sp[26] * PI7[0][12][8] + sp[27] * PI8[0][12][8] + sp[31] * PI3[0][8][12] + sp[32] * PI6[0][8][12] + sp[27] * PI8[0][8][12] + sp[30] * PI9[0][12][8];
    A[189] = sp[33] * PI0[0][12][9] + sp[34] * PI1[0][12][9] + sp[28] * PI2[0][12][9] + sp[31] * PI3[0][12][9] + sp[34] * PI1[0][9][12] + sp[35] * PI4[0][12][9] + sp[29] * PI5[0][12][9] + sp[32] * PI6[0][12][9] + sp[28] * PI2[0][9][12] + sp[29] * PI5[0][9][12] + sp[26] * PI7[0][12][9] + sp[27] * PI8[0][12][9] + sp[31] * PI3[0][9][12] + sp[32] * PI6[0][9][12] + sp[27] * PI8[0][9][12] + sp[30] * PI9[0][12][9];
    A[190] = sp[33] * PI0[0][12][10] + sp[34] * PI1[0][12][10] + sp[28] * PI2[0][12][10] + sp[31] * PI3[0][12][10] + sp[34] * PI1[0][10][12] + sp[35] * PI4[0][12][10] + sp[29] * PI5[0][12][10] + sp[32] * PI6[0][12][10] + sp[28] * PI2[0][10][12] + sp[29] * PI5[0][10][12] + sp[26] * PI7[0][12][10] + sp[27] * PI8[0][12][10] + sp[31] * PI3[0][10][12] + sp[32] * PI6[0][10][12] + sp[27] * PI8[0][10][12] + sp[30] * PI9[0][12][10];
    A[191] = sp[33] * PI0[0][12][11] + sp[34] * PI1[0][12][11] + sp[28] * PI2[0][12][11] + sp[31] * PI3[0][12][11] + sp[34] * PI1[0][11][12] + sp[35] * PI4[0][12][11] + sp[29] * PI5[0][12][11] + sp[32] * PI6[0][12][11] + sp[28] * PI2[0][11][12] + sp[29] * PI5[0][11][12] + sp[26] * PI7[0][12][11] + sp[27] * PI8[0][12][11] + sp[31] * PI3[0][11][12] + sp[32] * PI6[0][11][12] + sp[27] * PI8[0][11][12] + sp[30] * PI9[0][12][11];
    A[192] = sp[33] * PI0[0][12][12] + sp[34] * PI1[0][12][12] + sp[28] * PI2[0][12][12] + sp[31] * PI3[0][12][12] + sp[34] * PI1[0][12][12] + sp[35] * PI4[0][12][12] + sp[29] * PI5[0][12][12] + sp[32] * PI6[0][12][12] + sp[28] * PI2[0][12][12] + sp[29] * PI5[0][12][12] + sp[26] * PI7[0][12][12] + sp[27] * PI8[0][12][12] + sp[31] * PI3[0][12][12] + sp[32] * PI6[0][12][12] + sp[27] * PI8[0][12][12] + sp[30] * PI9[0][12][12];
    A[193] = sp[33] * PI0[0][12][13] + sp[34] * PI1[0][12][13] + sp[28] * PI2[0][12][13] + sp[31] * PI3[0][12][13] + sp[34] * PI1[0][13][12] + sp[35] * PI4[0][12][13] + sp[29] * PI5[0][12][13] + sp[32] * PI6[0][12][13] + sp[28] * PI2[0][13][12] + sp[29] * PI5[0][13][12] + sp[26] * PI7[0][12][13] + sp[27] * PI8[0][12][13] + sp[31] * PI3[0][13][12] + sp[32] * PI6[0][13][12] + sp[27] * PI8[0][13][12] + sp[30] * PI9[0][12][13];
    A[194] = sp[33] * PI0[0][12][14] + sp[34] * PI1[0][12][14] + sp[28] * PI2[0][12][14] + sp[31] * PI3[0][12][14] + sp[34] * PI1[0][14][12] + sp[35] * PI4[0][12][14] + sp[29] * PI5[0][12][14] + sp[32] * PI6[0][12][14] + sp[28] * PI2[0][14][12] + sp[29] * PI5[0][14][12] + sp[26] * PI7[0][12][14] + sp[27] * PI8[0][12][14] + sp[31] * PI3[0][14][12] + sp[32] * PI6[0][14][12] + sp[27] * PI8[0][14][12] + sp[30] * PI9[0][12][14];
    A[195] = sp[33] * PI0[0][13][0] + sp[34] * PI1[0][13][0] + sp[28] * PI2[0][13][0] + sp[31] * PI3[0][13][0] + sp[34] * PI1[0][0][13] + sp[35] * PI4[0][13][0] + sp[29] * PI5[0][13][0] + sp[32] * PI6[0][13][0] + sp[28] * PI2[0][0][13] + sp[29] * PI5[0][0][13] + sp[26] * PI7[0][13][0] + sp[27] * PI8[0][13][0] + sp[31] * PI3[0][0][13] + sp[32] * PI6[0][0][13] + sp[27] * PI8[0][0][13] + sp[30] * PI9[0][13][0];
    A[196] = sp[33] * PI0[0][13][1] + sp[34] * PI1[0][13][1] + sp[28] * PI2[0][13][1] + sp[31] * PI3[0][13][1] + sp[34] * PI1[0][1][13] + sp[35] * PI4[0][13][1] + sp[29] * PI5[0][13][1] + sp[32] * PI6[0][13][1] + sp[28] * PI2[0][1][13] + sp[29] * PI5[0][1][13] + sp[26] * PI7[0][13][1] + sp[27] * PI8[0][13][1] + sp[31] * PI3[0][1][13] + sp[32] * PI6[0][1][13] + sp[27] * PI8[0][1][13] + sp[30] * PI9[0][13][1];
    A[197] = sp[33] * PI0[0][13][2] + sp[34] * PI1[0][13][2] + sp[28] * PI2[0][13][2] + sp[31] * PI3[0][13][2] + sp[34] * PI1[0][2][13] + sp[35] * PI4[0][13][2] + sp[29] * PI5[0][13][2] + sp[32] * PI6[0][13][2] + sp[28] * PI2[0][2][13] + sp[29] * PI5[0][2][13] + sp[26] * PI7[0][13][2] + sp[27] * PI8[0][13][2] + sp[31] * PI3[0][2][13] + sp[32] * PI6[0][2][13] + sp[27] * PI8[0][2][13] + sp[30] * PI9[0][13][2];
    A[198] = sp[33] * PI0[0][13][3] + sp[34] * PI1[0][13][3] + sp[28] * PI2[0][13][3] + sp[31] * PI3[0][13][3] + sp[34] * PI1[0][3][13] + sp[35] * PI4[0][13][3] + sp[29] * PI5[0][13][3] + sp[32] * PI6[0][13][3] + sp[28] * PI2[0][3][13] + sp[29] * PI5[0][3][13] + sp[26] * PI7[0][13][3] + sp[27] * PI8[0][13][3] + sp[31] * PI3[0][3][13] + sp[32] * PI6[0][3][13] + sp[27] * PI8[0][3][13] + sp[30] * PI9[0][13][3];
    A[199] = sp[33] * PI0[0][13][4] + sp[34] * PI1[0][13][4] + sp[28] * PI2[0][13][4] + sp[31] * PI3[0][13][4] + sp[34] * PI1[0][4][13] + sp[35] * PI4[0][13][4] + sp[29] * PI5[0][13][4] + sp[32] * PI6[0][13][4] + sp[28] * PI2[0][4][13] + sp[29] * PI5[0][4][13] + sp[26] * PI7[0][13][4] + sp[27] * PI8[0][13][4] + sp[31] * PI3[0][4][13] + sp[32] * PI6[0][4][13] + sp[27] * PI8[0][4][13] + sp[30] * PI9[0][13][4];
    A[200] = sp[33] * PI0[0][13][5] + sp[34] * PI1[0][13][5] + sp[28] * PI2[0][13][5] + sp[31] * PI3[0][13][5] + sp[34] * PI1[0][5][13] + sp[35] * PI4[0][13][5] + sp[29] * PI5[0][13][5] + sp[32] * PI6[0][13][5] + sp[28] * PI2[0][5][13] + sp[29] * PI5[0][5][13] + sp[26] * PI7[0][13][5] + sp[27] * PI8[0][13][5] + sp[31] * PI3[0][5][13] + sp[32] * PI6[0][5][13] + sp[27] * PI8[0][5][13] + sp[30] * PI9[0][13][5];
    A[201] = sp[33] * PI0[0][13][6] + sp[34] * PI1[0][13][6] + sp[28] * PI2[0][13][6] + sp[31] * PI3[0][13][6] + sp[34] * PI1[0][6][13] + sp[35] * PI4[0][13][6] + sp[29] * PI5[0][13][6] + sp[32] * PI6[0][13][6] + sp[28] * PI2[0][6][13] + sp[29] * PI5[0][6][13] + sp[26] * PI7[0][13][6] + sp[27] * PI8[0][13][6] + sp[31] * PI3[0][6][13] + sp[32] * PI6[0][6][13] + sp[27] * PI8[0][6][13] + sp[30] * PI9[0][13][6];
    A[202] = sp[33] * PI0[0][13][7] + sp[34] * PI1[0][13][7] + sp[28] * PI2[0][13][7] + sp[31] * PI3[0][13][7] + sp[34] * PI1[0][7][13] + sp[35] * PI4[0][13][7] + sp[29] * PI5[0][13][7] + sp[32] * PI6[0][13][7] + sp[28] * PI2[0][7][13] + sp[29] * PI5[0][7][13] + sp[26] * PI7[0][13][7] + sp[27] * PI8[0][13][7] + sp[31] * PI3[0][7][13] + sp[32] * PI6[0][7][13] + sp[27] * PI8[0][7][13] + sp[30] * PI9[0][13][7];
    A[203] = sp[33] * PI0[0][13][8] + sp[34] * PI1[0][13][8] + sp[28] * PI2[0][13][8] + sp[31] * PI3[0][13][8] + sp[34] * PI1[0][8][13] + sp[35] * PI4[0][13][8] + sp[29] * PI5[0][13][8] + sp[32] * PI6[0][13][8] + sp[28] * PI2[0][8][13] + sp[29] * PI5[0][8][13] + sp[26] * PI7[0][13][8] + sp[27] * PI8[0][13][8] + sp[31] * PI3[0][8][13] + sp[32] * PI6[0][8][13] + sp[27] * PI8[0][8][13] + sp[30] * PI9[0][13][8];
    A[204] = sp[33] * PI0[0][13][9] + sp[34] * PI1[0][13][9] + sp[28] * PI2[0][13][9] + sp[31] * PI3[0][13][9] + sp[34] * PI1[0][9][13] + sp[35] * PI4[0][13][9] + sp[29] * PI5[0][13][9] + sp[32] * PI6[0][13][9] + sp[28] * PI2[0][9][13] + sp[29] * PI5[0][9][13] + sp[26] * PI7[0][13][9] + sp[27] * PI8[0][13][9] + sp[31] * PI3[0][9][13] + sp[32] * PI6[0][9][13] + sp[27] * PI8[0][9][13] + sp[30] * PI9[0][13][9];
    A[205] = sp[33] * PI0[0][13][10] + sp[34] * PI1[0][13][10] + sp[28] * PI2[0][13][10] + sp[31] * PI3[0][13][10] + sp[34] * PI1[0][10][13] + sp[35] * PI4[0][13][10] + sp[29] * PI5[0][13][10] + sp[32] * PI6[0][13][10] + sp[28] * PI2[0][10][13] + sp[29] * PI5[0][10][13] + sp[26] * PI7[0][13][10] + sp[27] * PI8[0][13][10] + sp[31] * PI3[0][10][13] + sp[32] * PI6[0][10][13] + sp[27] * PI8[0][10][13] + sp[30] * PI9[0][13][10];
    A[206] = sp[33] * PI0[0][13][11] + sp[34] * PI1[0][13][11] + sp[28] * PI2[0][13][11] + sp[31] * PI3[0][13][11] + sp[34] * PI1[0][11][13] + sp[35] * PI4[0][13][11] + sp[29] * PI5[0][13][11] + sp[32] * PI6[0][13][11] + sp[28] * PI2[0][11][13] + sp[29] * PI5[0][11][13] + sp[26] * PI7[0][13][11] + sp[27] * PI8[0][13][11] + sp[31] * PI3[0][11][13] + sp[32] * PI6[0][11][13] + sp[27] * PI8[0][11][13] + sp[30] * PI9[0][13][11];
    A[207] = sp[33] * PI0[0][13][12] + sp[34] * PI1[0][13][12] + sp[28] * PI2[0][13][12] + sp[31] * PI3[0][13][12] + sp[34] * PI1[0][12][13] + sp[35] * PI4[0][13][12] + sp[29] * PI5[0][13][12] + sp[32] * PI6[0][13][12] + sp[28] * PI2[0][12][13] + sp[29] * PI5[0][12][13] + sp[26] * PI7[0][13][12] + sp[27] * PI8[0][13][12] + sp[31] * PI3[0][12][13] + sp[32] * PI6[0][12][13] + sp[27] * PI8[0][12][13] + sp[30] * PI9[0][13][12];
    A[208] = sp[33] * PI0[0][13][13] + sp[34] * PI1[0][13][13] + sp[28] * PI2[0][13][13] + sp[31] * PI3[0][13][13] + sp[34] * PI1[0][13][13] + sp[35] * PI4[0][13][13] + sp[29] * PI5[0][13][13] + sp[32] * PI6[0][13][13] + sp[28] * PI2[0][13][13] + sp[29] * PI5[0][13][13] + sp[26] * PI7[0][13][13] + sp[27] * PI8[0][13][13] + sp[31] * PI3[0][13][13] + sp[32] * PI6[0][13][13] + sp[27] * PI8[0][13][13] + sp[30] * PI9[0][13][13];
    A[209] = sp[33] * PI0[0][13][14] + sp[34] * PI1[0][13][14] + sp[28] * PI2[0][13][14] + sp[31] * PI3[0][13][14] + sp[34] * PI1[0][14][13] + sp[35] * PI4[0][13][14] + sp[29] * PI5[0][13][14] + sp[32] * PI6[0][13][14] + sp[28] * PI2[0][14][13] + sp[29] * PI5[0][14][13] + sp[26] * PI7[0][13][14] + sp[27] * PI8[0][13][14] + sp[31] * PI3[0][14][13] + sp[32] * PI6[0][14][13] + sp[27] * PI8[0][14][13] + sp[30] * PI9[0][13][14];
    A[210] = sp[33] * PI0[0][14][0] + sp[34] * PI1[0][14][0] + sp[28] * PI2[0][14][0] + sp[31] * PI3[0][14][0] + sp[34] * PI1[0][0][14] + sp[35] * PI4[0][14][0] + sp[29] * PI5[0][14][0] + sp[32] * PI6[0][14][0] + sp[28] * PI2[0][0][14] + sp[29] * PI5[0][0][14] + sp[26] * PI7[0][14][0] + sp[27] * PI8[0][14][0] + sp[31] * PI3[0][0][14] + sp[32] * PI6[0][0][14] + sp[27] * PI8[0][0][14] + sp[30] * PI9[0][14][0];
    A[211] = sp[33] * PI0[0][14][1] + sp[34] * PI1[0][14][1] + sp[28] * PI2[0][14][1] + sp[31] * PI3[0][14][1] + sp[34] * PI1[0][1][14] + sp[35] * PI4[0][14][1] + sp[29] * PI5[0][14][1] + sp[32] * PI6[0][14][1] + sp[28] * PI2[0][1][14] + sp[29] * PI5[0][1][14] + sp[26] * PI7[0][14][1] + sp[27] * PI8[0][14][1] + sp[31] * PI3[0][1][14] + sp[32] * PI6[0][1][14] + sp[27] * PI8[0][1][14] + sp[30] * PI9[0][14][1];
    A[212] = sp[33] * PI0[0][14][2] + sp[34] * PI1[0][14][2] + sp[28] * PI2[0][14][2] + sp[31] * PI3[0][14][2] + sp[34] * PI1[0][2][14] + sp[35] * PI4[0][14][2] + sp[29] * PI5[0][14][2] + sp[32] * PI6[0][14][2] + sp[28] * PI2[0][2][14] + sp[29] * PI5[0][2][14] + sp[26] * PI7[0][14][2] + sp[27] * PI8[0][14][2] + sp[31] * PI3[0][2][14] + sp[32] * PI6[0][2][14] + sp[27] * PI8[0][2][14] + sp[30] * PI9[0][14][2];
    A[213] = sp[33] * PI0[0][14][3] + sp[34] * PI1[0][14][3] + sp[28] * PI2[0][14][3] + sp[31] * PI3[0][14][3] + sp[34] * PI1[0][3][14] + sp[35] * PI4[0][14][3] + sp[29] * PI5[0][14][3] + sp[32] * PI6[0][14][3] + sp[28] * PI2[0][3][14] + sp[29] * PI5[0][3][14] + sp[26] * PI7[0][14][3] + sp[27] * PI8[0][14][3] + sp[31] * PI3[0][3][14] + sp[32] * PI6[0][3][14] + sp[27] * PI8[0][3][14] + sp[30] * PI9[0][14][3];
    A[214] = sp[33] * PI0[0][14][4] + sp[34] * PI1[0][14][4] + sp[28] * PI2[0][14][4] + sp[31] * PI3[0][14][4] + sp[34] * PI1[0][4][14] + sp[35] * PI4[0][14][4] + sp[29] * PI5[0][14][4] + sp[32] * PI6[0][14][4] + sp[28] * PI2[0][4][14] + sp[29] * PI5[0][4][14] + sp[26] * PI7[0][14][4] + sp[27] * PI8[0][14][4] + sp[31] * PI3[0][4][14] + sp[32] * PI6[0][4][14] + sp[27] * PI8[0][4][14] + sp[30] * PI9[0][14][4];
    A[215] = sp[33] * PI0[0][14][5] + sp[34] * PI1[0][14][5] + sp[28] * PI2[0][14][5] + sp[31] * PI3[0][14][5] + sp[34] * PI1[0][5][14] + sp[35] * PI4[0][14][5] + sp[29] * PI5[0][14][5] + sp[32] * PI6[0][14][5] + sp[28] * PI2[0][5][14] + sp[29] * PI5[0][5][14] + sp[26] * PI7[0][14][5] + sp[27] * PI8[0][14][5] + sp[31] * PI3[0][5][14] + sp[32] * PI6[0][5][14] + sp[27] * PI8[0][5][14] + sp[30] * PI9[0][14][5];
    A[216] = sp[33] * PI0[0][14][6] + sp[34] * PI1[0][14][6] + sp[28] * PI2[0][14][6] + sp[31] * PI3[0][14][6] + sp[34] * PI1[0][6][14] + sp[35] * PI4[0][14][6] + sp[29] * PI5[0][14][6] + sp[32] * PI6[0][14][6] + sp[28] * PI2[0][6][14] + sp[29] * PI5[0][6][14] + sp[26] * PI7[0][14][6] + sp[27] * PI8[0][14][6] + sp[31] * PI3[0][6][14] + sp[32] * PI6[0][6][14] + sp[27] * PI8[0][6][14] + sp[30] * PI9[0][14][6];
    A[217] = sp[33] * PI0[0][14][7] + sp[34] * PI1[0][14][7] + sp[28] * PI2[0][14][7] + sp[31] * PI3[0][14][7] + sp[34] * PI1[0][7][14] + sp[35] * PI4[0][14][7] + sp[29] * PI5[0][14][7] + sp[32] * PI6[0][14][7] + sp[28] * PI2[0][7][14] + sp[29] * PI5[0][7][14] + sp[26] * PI7[0][14][7] + sp[27] * PI8[0][14][7] + sp[31] * PI3[0][7][14] + sp[32] * PI6[0][7][14] + sp[27] * PI8[0][7][14] + sp[30] * PI9[0][14][7];
    A[218] = sp[33] * PI0[0][14][8] + sp[34] * PI1[0][14][8] + sp[28] * PI2[0][14][8] + sp[31] * PI3[0][14][8] + sp[34] * PI1[0][8][14] + sp[35] * PI4[0][14][8] + sp[29] * PI5[0][14][8] + sp[32] * PI6[0][14][8] + sp[28] * PI2[0][8][14] + sp[29] * PI5[0][8][14] + sp[26] * PI7[0][14][8] + sp[27] * PI8[0][14][8] + sp[31] * PI3[0][8][14] + sp[32] * PI6[0][8][14] + sp[27] * PI8[0][8][14] + sp[30] * PI9[0][14][8];
    A[219] = sp[33] * PI0[0][14][9] + sp[34] * PI1[0][14][9] + sp[28] * PI2[0][14][9] + sp[31] * PI3[0][14][9] + sp[34] * PI1[0][9][14] + sp[35] * PI4[0][14][9] + sp[29] * PI5[0][14][9] + sp[32] * PI6[0][14][9] + sp[28] * PI2[0][9][14] + sp[29] * PI5[0][9][14] + sp[26] * PI7[0][14][9] + sp[27] * PI8[0][14][9] + sp[31] * PI3[0][9][14] + sp[32] * PI6[0][9][14] + sp[27] * PI8[0][9][14] + sp[30] * PI9[0][14][9];
    A[220] = sp[33] * PI0[0][14][10] + sp[34] * PI1[0][14][10] + sp[28] * PI2[0][14][10] + sp[31] * PI3[0][14][10] + sp[34] * PI1[0][10][14] + sp[35] * PI4[0][14][10] + sp[29] * PI5[0][14][10] + sp[32] * PI6[0][14][10] + sp[28] * PI2[0][10][14] + sp[29] * PI5[0][10][14] + sp[26] * PI7[0][14][10] + sp[27] * PI8[0][14][10] + sp[31] * PI3[0][10][14] + sp[32] * PI6[0][10][14] + sp[27] * PI8[0][10][14] + sp[30] * PI9[0][14][10];
    A[221] = sp[33] * PI0[0][14][11] + sp[34] * PI1[0][14][11] + sp[28] * PI2[0][14][11] + sp[31] * PI3[0][14][11] + sp[34] * PI1[0][11][14] + sp[35] * PI4[0][14][11] + sp[29] * PI5[0][14][11] + sp[32] * PI6[0][14][11] + sp[28] * PI2[0][11][14] + sp[29] * PI5[0][11][14] + sp[26] * PI7[0][14][11] + sp[27] * PI8[0][14][11] + sp[31] * PI3[0][11][14] + sp[32] * PI6[0][11][14] + sp[27] * PI8[0][11][14] + sp[30] * PI9[0][14][11];
    A[222] = sp[33] * PI0[0][14][12] + sp[34] * PI1[0][14][12] + sp[28] * PI2[0][14][12] + sp[31] * PI3[0][14][12] + sp[34] * PI1[0][12][14] + sp[35] * PI4[0][14][12] + sp[29] * PI5[0][14][12] + sp[32] * PI6[0][14][12] + sp[28] * PI2[0][12][14] + sp[29] * PI5[0][12][14] + sp[26] * PI7[0][14][12] + sp[27] * PI8[0][14][12] + sp[31] * PI3[0][12][14] + sp[32] * PI6[0][12][14] + sp[27] * PI8[0][12][14] + sp[30] * PI9[0][14][12];
    A[223] = sp[33] * PI0[0][14][13] + sp[34] * PI1[0][14][13] + sp[28] * PI2[0][14][13] + sp[31] * PI3[0][14][13] + sp[34] * PI1[0][13][14] + sp[35] * PI4[0][14][13] + sp[29] * PI5[0][14][13] + sp[32] * PI6[0][14][13] + sp[28] * PI2[0][13][14] + sp[29] * PI5[0][13][14] + sp[26] * PI7[0][14][13] + sp[27] * PI8[0][14][13] + sp[31] * PI3[0][13][14] + sp[32] * PI6[0][13][14] + sp[27] * PI8[0][13][14] + sp[30] * PI9[0][14][13];
    A[224] = sp[33] * PI0[0][14][14] + sp[34] * PI1[0][14][14] + sp[28] * PI2[0][14][14] + sp[31] * PI3[0][14][14] + sp[34] * PI1[0][14][14] + sp[35] * PI4[0][14][14] + sp[29] * PI5[0][14][14] + sp[32] * PI6[0][14][14] + sp[28] * PI2[0][14][14] + sp[29] * PI5[0][14][14] + sp[26] * PI7[0][14][14] + sp[27] * PI8[0][14][14] + sp[31] * PI3[0][14][14] + sp[32] * PI6[0][14][14] + sp[27] * PI8[0][14][14] + sp[30] * PI9[0][14][14];
  }

};


class forms_cell_integral_1_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_1_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_1_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation,
                       std::size_t local_facet) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 6
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 6
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           6
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q12[1][1][2] = { { { -1.0, 1.0 } } };
    alignas(32) static const double PI0[1][15][15] =
        { { { 0.02162698412698432, -0.02986111111111122, 0.01765873015873011, -0.0154265873015874, 0.0174603174603174, -0.02385912698412701, -0.01314484126984126, 0.02777777777777797, -0.02058531746031759, 0.04349267900155103, 0.06529556615835211, -0.01686507936508128, 0.03507474113028566, -0.1005208057964093, 0.06200396825396926 },
            { -0.02986111111111122, 0.068650793650794, -0.0487103174603176, 0.01746031746031738, -0.04384920634920637, 0.06111111111111139, 0.01041666666666662, -0.01785714285714292, 0.02529761904761927, -0.07856742013183717, -0.05326743555023459, -0.004960317460314847, -0.07014948226057134, 0.04639421805988029, -0.1240079365079386 },
            { 0.01765873015873011, -0.0487103174603176, 0.05734126984127019, -0.02385912698412706, 0.0611111111111115, -0.05114087301587324, -0.01860119047619065, 0.01190476190476196, -0.01116071428571436, 0.1248660784238152, -0.003436608745177558, 0.100198412698412, -0.03507474113028557, -0.02319710902993982, -0.06200396825396914 },
            { -0.0154265873015874, 0.01746031746031738, -0.02385912698412706, 0.02162698412698433, -0.02986111111111127, 0.01765873015873011, 0.02058531746031758, -0.02777777777777797, 0.01314484126984128, -0.07856742013183686, -0.03522523963805742, -0.04513888888888811, 0.03507474113028562, 0.1005208057964094, 0.06200396825396924 },
            { 0.0174603174603174, -0.04384920634920637, 0.0611111111111115, -0.02986111111111127, 0.06865079365079411, -0.0487103174603176, -0.02529761904761932, 0.01785714285714298, -0.0104166666666667, 0.1487169023924089, -0.006873217490354546, 0.1289682539682533, -0.0701494822605712, -0.04639421805988057, -0.1240079365079384 },
            { -0.02385912698412701, 0.06111111111111139, -0.05114087301587324, 0.01765873015873011, -0.0487103174603176, 0.05734126984127012, 0.01116071428571433, -0.01190476190476195, 0.01860119047619065, -0.08979133729352938, -0.02663371777511694, -0.03819444444444255, -0.03507474113028564, 0.02319710902993963, -0.06200396825396924 },
            { -0.01314484126984126, 0.01041666666666662, -0.01860119047619065, 0.02058531746031758, -0.02529761904761932, 0.01116071428571433, 0.1012896825396833, -0.09444444444444479, 0.04474206349206345, -0.2062394778460753, 0.131450284502998, 0.1473214285714275, 0.04208968935634266, 0.1030982623552905, 0.07440476190476314 },
            { 0.02777777777777797, -0.01785714285714292, 0.01190476190476196, -0.02777777777777797, 0.01785714285714298, -0.01190476190476195, -0.09444444444444479, 0.1630952380952392, -0.09444444444444486, 0.1346870059402921, 0.1030982623552915, -0.1071428571428562, 0.0, -0.206196524710582, 0.0 },
            { -0.02058531746031759, 0.02529761904761927, -0.01116071428571436, 0.01314484126984128, -0.0104166666666667, 0.01860119047619065, 0.04474206349206345, -0.09444444444444486, 0.1012896825396833, -0.1641497884897317, -0.234548546858288, 0.2217261904761905, -0.04208968935634272, 0.1030982623552905, -0.07440476190476301 },
            { 0.04349267900155103, -0.07856742013183717, 0.1248660784238152, -0.07856742013183686, 0.1487169023924089, -0.08979133729352938, -0.2062394778460753, 0.1346870059402921, -0.1641497884897317, 4.920634920634907, 0.02430049347996754, -0.5191061687282026, -0.1984126984127014, -0.218704441319909, -0.3507474113028561 },
            { 0.06529556615835211, -0.05326743555023459, -0.003436608745177558, -0.03522523963805742, -0.006873217490354546, -0.02663371777511694, 0.131450284502998, 0.1030982623552915, -0.234548546858288, 0.02430049347996754, 5.416666666666709, -0.189013480984707, 0.1701034543599514, -0.4017857142857212, 0.300703265202946 },
            { -0.01686507936508128, -0.004960317460314847, 0.100198412698412, -0.04513888888888811, 0.1289682539682533, -0.03819444444444255, 0.1473214285714275, -0.1071428571428562, 0.2217261904761905, -0.5191061687282026, -0.189013480984707, 5.55555555555557, -0.3507474113028565, 0.07732369676647452, -0.6200396825396929 },
            { 0.03507474113028566, -0.07014948226057134, -0.03507474113028557, 0.03507474113028562, -0.0701494822605712, -0.03507474113028564, 0.04208968935634266, 0.0, -0.04208968935634272, -0.1984126984127014, 0.1701034543599514, -0.3507474113028565, 0.3968253968254026, 0.0, 0.7014948226057125 },
            { -0.1005208057964093, 0.04639421805988029, -0.02319710902993982, 0.1005208057964094, -0.04639421805988057, 0.02319710902993963, 0.1030982623552905, -0.206196524710582, 0.1030982623552905, -0.218704441319909, -0.4017857142857212, 0.07732369676647452, 0.0, 0.8035714285714409, 0.0 },
            { 0.06200396825396926, -0.1240079365079386, -0.06200396825396914, 0.06200396825396924, -0.1240079365079384, -0.06200396825396924, 0.07440476190476314, 0.0, -0.07440476190476301, -0.3507474113028561, 0.300703265202946, -0.6200396825396929, 0.7014948226057125, 0.0, 1.240079365079384 } } };
    alignas(32) static const double PI1[1][15][15] =
        { { { -0.01116071428571436, 0.00595238095238091, -0.004712301587301567, -0.02447916666666679, 0.02167658730158718, -0.03266369047619055, -0.008804563492063534, 0.01413690476190486, -0.007068452380952377, -0.02314932914598865, -0.05154913117764577, -0.007440476190475813, 0.1283735525368424, -0.06314768569261545, 0.09598214285714167 },
            { 0.009920634920635007, -0.01289682539682549, 0.005952380952380877, 0.02316468253968249, -0.05327380952380964, 0.0752480158730163, 0.004216269841269739, -0.009424603174603202, 0.01165674603174613, -0.00982092751647979, -0.008591521862941527, 0.01984126984126898, -0.1360899955855055, 0.04897167461876206, -0.2405753968253961 },
            { -0.004712301587301623, 0.009920634920635003, -0.01116071428571434, -0.03067956349206365, 0.07276785714285768, -0.05820932539682568, -0.009052579365079383, 0.005704365079365085, -0.006820436507936569, 0.011925411984297, -0.01718304372588155, -0.0719246031746034, 0.06243303921190654, 0.00128872827944088, 0.1460813492063476 },
            { 0.009052579365079397, -0.004216269841269773, 0.008804563492063549, 0.03278769841269869, -0.03581349206349218, 0.02237103174603168, 0.0135168650793652, -0.0136408730158731, 0.004340277777777729, 0.02665680325901717, 0.07947157723220404, 0.04340277777777813, -0.09329881140655687, 0.03737312010379372, -0.03397817460317264 },
            { -0.005704365079365108, 0.009424603174603226, -0.01413690476190486, -0.03978174603174633, 0.08154761904761966, -0.05466269841269859, -0.0136408730158731, 0.008432539682539712, -0.006200396825396851, 0.002805979290422719, -0.0472533702461751, -0.09176587301587363, 0.06594051332493459, 0.002577456558881414, 0.1165674603174579 },
            { 0.006820436507936572, -0.01165674603174613, 0.00706845238095235, 0.02237103174603175, -0.0586309523809527, 0.06850198412698452, 0.004340277777777706, -0.006200396825396829, 0.009548611111111206, -0.01543288609732553, -0.01073940232867671, 0.03596230158730111, -0.09750778034219194, 0.02448583730938078, -0.2080853174603165 },
            { 0.03067956349206365, -0.02316468253968259, 0.02447916666666686, 0.0787946428571432, -0.1005456349206356, 0.04382440476190488, 0.0327876984126987, -0.03978174603174627, 0.0223710317460318, 0.04700015311458278, 0.1576544261849665, 0.1068948412698423, -0.1529258713280409, 0.01546473935329256, 0.01537698412698345 },
            { -0.07276785714285774, 0.05327380952380985, -0.0216765873015873, -0.1005456349206355, 0.0711309523809525, -0.03358134920634893, -0.03581349206349218, 0.08154761904761969, -0.05863095238095285, -0.07997040977705114, -0.1520699369740538, 0.01934523809523985, 0.2946278254943945, -0.1030982623552908, -0.1458333333333377 },
            { 0.05820932539682568, -0.07524801587301654, 0.03266369047619071, 0.04382440476190491, -0.03358134920634914, 0.0430803571428573, 0.02237103174603173, -0.05466269841269859, 0.06850198412698469, -0.05822407027627438, -0.06142938132002947, 0.09945436507936588, -0.1950155606843829, 0.08763352300199841, -0.05902777777777912 },
            { -0.06243303921190631, 0.1360899955855056, -0.1283735525368426, -0.1529258713280411, 0.2946278254943951, -0.1950155606843833, -0.0932988114065568, 0.06594051332493474, -0.09750778034219217, 0.198412698412702, -0.06075123369997135, -0.8067190459965543, 4.305555555555533, -0.03645074021998873, 0.5401510134063858 },
            { -0.1271545235715236, 0.1838585678669348, -0.05154913117764418, 0.02104922856420379, -0.1778445025628793, -0.007302793583500375, -0.01073940232867409, 0.1022391101689944, -0.167964252420494, 0.2308546880599298, 0.4315476190476349, -0.06873217490352201, 0.449559129379841, 3.593749999999993, 0.1761261981902886 },
            { 0.07192460317460259, -0.1626984126984122, 0.1026785714285716, 0.005704365079364761, -0.01636904761904655, 0.1054067460317481, 0.04935515873015899, -0.05605158730158718, 0.1252480158730154, -0.301642773720452, -0.2749286996141053, 0.5902777777777806, -0.3016427737204441, 0.1675346763273487, 3.395337301587297 },
            { -0.0119254119842971, 0.009820927516479895, 0.02314932914598859, 0.04700015311458266, -0.07997040977705101, -0.05822407027627423, 0.02665680325901711, 0.002805979290422844, -0.01543288609732561, 0.0198412698412698, 0.1579532076199492, 0.2034334985556573, 0.1984126984127016, -0.1458029608799466, 0.3507474113028557 },
            { 0.07088005536926237, -0.01288728279441053, 0.03221820698602836, 0.1714008611656717, -0.059281500854291, 0.05541531601596773, 0.07732369676646852, -0.103098262355291, 0.02577456558882212, 0.2551551815399187, 0.5580357142857224, 0.06443641397205685, -0.7290148043997463, 0.4017857142857196, -0.05154913117763563 },
            { -0.02108134920634956, 0.01736111111111133, 0.04092261904761981, 0.08308531746031883, -0.1413690476190497, -0.102926587301589, 0.0471230158730167, 0.004960317460317547, -0.02728174603174641, 0.03507474113028524, 0.2792244605455824, 0.3596230158730227, 0.3507474113028569, -0.2577456558882175, 0.6200396825396913 } } };
    alignas(32) static const double PI2[1][15][15] =
        { { { 0.05734126984127032, -0.04871031746031779, 0.01765873015873018, 0.01860119047619068, -0.01190476190476192, 0.01116071428571417, 0.02385912698412709, -0.06111111111111159, 0.05114087301587342, 0.03507474113028567, 0.06529556615835073, -0.01091269841269952, -0.1248660784238149, -0.08505606644311325, 0.05307539682539869 },
            { -0.04871031746031779, 0.06865079365079435, -0.02986111111111137, -0.01041666666666669, 0.01785714285714289, -0.02529761904761913, -0.01746031746031749, 0.04384920634920657, -0.06111111111111171, 0.07014948226057137, 0.08419691425682257, -0.1021825396825407, 0.0785674201318371, 0.03092947870658548, 0.04365079365079499 },
            { 0.01765873015873018, -0.02986111111111137, 0.0216269841269844, 0.01314484126984132, -0.02777777777777796, 0.02058531746031754, 0.01542658730158745, -0.01746031746031746, 0.02385912698412715, -0.03507474113028573, -0.003436608745176647, 0.1180555555555575, -0.04349267900155121, -0.01804219591217453, -0.06498015873016053 },
            { 0.01860119047619068, -0.01041666666666669, 0.01314484126984132, 0.1012896825396832, -0.09444444444444479, 0.0447420634920634, 0.02058531746031759, -0.02529761904761929, 0.01116071428571437, 0.04208968935634292, 0.1159855451497026, 0.05208333333333318, -0.2062394778460752, 0.1933092419161692, 0.04017857142857466 },
            { -0.01190476190476192, 0.01785714285714289, -0.02777777777777796, -0.09444444444444479, 0.1630952380952393, -0.09444444444444491, -0.02777777777777795, 0.01785714285714289, -0.01190476190476191, 0.0, -0.1030982623552912, -0.17857142857143, 0.1346870059402923, -0.04123930494211479, 0.1428571428571432 },
            { 0.01116071428571417, -0.02529761904761913, 0.02058531746031754, 0.0447420634920634, -0.09444444444444491, 0.1012896825396832, 0.01314484126984123, -0.01041666666666648, 0.01860119047619049, -0.04208968935634259, -0.01288728279441213, 0.1264880952380961, -0.1641497884897316, 0.07474624020758398, -0.3139880952380977 },
            { 0.02385912698412709, -0.01746031746031749, 0.01542658730158745, 0.02058531746031759, -0.02777777777777795, 0.01314484126984123, 0.02162698412698434, -0.02986111111111127, 0.01765873015873019, 0.03507474113028554, 0.1039574145415856, 0.05605158730158818, -0.07856742013183665, -0.05670404429540882, -0.007936507936507841 },
            { -0.06111111111111159, 0.04384920634920657, -0.01746031746031746, -0.02529761904761929, 0.01785714285714289, -0.01041666666666648, -0.02986111111111127, 0.0686507936507942, -0.04871031746031777, -0.07014948226057124, -0.1305911323167022, 0.02182539682539806, 0.1487169023924089, 0.1082531754730537, -0.07043650793651079 },
            { 0.05114087301587342, -0.06111111111111171, 0.02385912698412715, 0.01116071428571437, -0.01190476190476191, 0.01860119047619049, 0.01765873015873019, -0.04871031746031777, 0.05734126984127039, -0.03507474113028574, -0.04209845712841177, 0.05109126984126992, -0.08979133729352935, -0.04639421805987924, -0.003968253968253938 },
            { 0.03507474113028567, 0.07014948226057137, -0.03507474113028573, 0.04208968935634292, 0.0, -0.04208968935634259, 0.03507474113028554, -0.07014948226057124, -0.03507474113028574, 0.3968253968254031, 0.6075123369998054, -0.350747411302857, -0.1984126984127011, -0.2187044413199267, 0.3226876183986327 },
            { 0.06529556615835073, 0.08419691425682257, -0.003436608745176647, 0.1159855451497026, -0.1030982623552912, -0.01288728279441213, 0.1039574145415856, -0.1305911323167022, -0.04209845712841177, 0.6075123369998054, 1.130952380952398, -0.1890134809847014, -0.4131083891598576, -0.4017857142857136, 0.3007032652029413 },
            { -0.01091269841269952, -0.1021825396825407, 0.1180555555555575, 0.05208333333333318, -0.17857142857143, 0.1264880952380961, 0.05605158730158818, 0.02182539682539806, 0.05109126984126992, -0.350747411302857, -0.1890134809847014, 0.9126984126984302, -0.01402989645209707, 0.07732369676647405, -0.6200396825397008 },
            { -0.1248660784238149, 0.0785674201318371, -0.04349267900155121, -0.2062394778460752, 0.1346870059402923, -0.1641497884897316, -0.07856742013183665, 0.1487169023924089, -0.08979133729352935, -0.1984126984127011, -0.4131083891598576, -0.01402989645209707, 4.920634920634908, -0.4374088826398519, 0.2805979290422569 },
            { -0.08505606644311325, 0.03092947870658548, -0.01804219591217453, 0.1933092419161692, -0.04123930494211479, 0.07474624020758398, -0.05670404429540882, 0.1082531754730537, -0.04639421805987924, -0.2187044413199267, -0.4017857142857136, 0.07732369676647405, -0.4374088826398519, 5.357142857142859, -0.1546473935329284 },
            { 0.05307539682539869, 0.04365079365079499, -0.06498015873016053, 0.04017857142857466, 0.1428571428571432, -0.3139880952380977, -0.007936507936507841, -0.07043650793651079, -0.003968253968253938, 0.3226876183986327, 0.3007032652029413, -0.6200396825397008, 0.2805979290422569, -0.1546473935329284, 5.615079365079414 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q12[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q12[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q12[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q12[0][0][1];
    alignas(32) double sp[20];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 / sp[2];
    sp[4] = -1 * J_c1 / sp[2];
    sp[5] = sp[3] * sp[3];
    sp[6] = sp[3] * sp[4];
    sp[7] = sp[4] * sp[4];
    sp[8] = J_c3 / sp[2];
    sp[9] = -1 * J_c2 / sp[2];
    sp[10] = sp[9] * sp[9];
    sp[11] = sp[8] * sp[9];
    sp[12] = sp[8] * sp[8];
    sp[13] = sp[5] + sp[10];
    sp[14] = sp[6] + sp[11];
    sp[15] = sp[12] + sp[7];
    sp[16] = std::abs(sp[2]);
    sp[17] = sp[13] * sp[16];
    sp[18] = sp[14] * sp[16];
    sp[19] = sp[15] * sp[16];
    A[0] = sp[19] * PI0[0][0][0] + sp[18] * PI1[0][0][0] + sp[18] * PI1[0][0][0] + sp[17] * PI2[0][0][0];
    A[1] = sp[19] * PI0[0][0][1] + sp[18] * PI1[0][0][1] + sp[18] * PI1[0][1][0] + sp[17] * PI2[0][0][1];
    A[2] = sp[19] * PI0[0][0][2] + sp[18] * PI1[0][0][2] + sp[18] * PI1[0][2][0] + sp[17] * PI2[0][0][2];
    A[3] = sp[19] * PI0[0][0][3] + sp[18] * PI1[0][0][3] + sp[18] * PI1[0][3][0] + sp[17] * PI2[0][0][3];
    A[4] = sp[19] * PI0[0][0][4] + sp[18] * PI1[0][0][4] + sp[18] * PI1[0][4][0] + sp[17] * PI2[0][0][4];
    A[5] = sp[19] * PI0[0][0][5] + sp[18] * PI1[0][0][5] + sp[18] * PI1[0][5][0] + sp[17] * PI2[0][0][5];
    A[6] = sp[19] * PI0[0][0][6] + sp[18] * PI1[0][0][6] + sp[18] * PI1[0][6][0] + sp[17] * PI2[0][0][6];
    A[7] = sp[19] * PI0[0][0][7] + sp[18] * PI1[0][0][7] + sp[18] * PI1[0][7][0] + sp[17] * PI2[0][0][7];
    A[8] = sp[19] * PI0[0][0][8] + sp[18] * PI1[0][0][8] + sp[18] * PI1[0][8][0] + sp[17] * PI2[0][0][8];
    A[9] = sp[19] * PI0[0][0][9] + sp[18] * PI1[0][0][9] + sp[18] * PI1[0][9][0] + sp[17] * PI2[0][0][9];
    A[10] = sp[19] * PI0[0][0][10] + sp[18] * PI1[0][0][10] + sp[18] * PI1[0][10][0] + sp[17] * PI2[0][0][10];
    A[11] = sp[19] * PI0[0][0][11] + sp[18] * PI1[0][0][11] + sp[18] * PI1[0][11][0] + sp[17] * PI2[0][0][11];
    A[12] = sp[19] * PI0[0][0][12] + sp[18] * PI1[0][0][12] + sp[18] * PI1[0][12][0] + sp[17] * PI2[0][0][12];
    A[13] = sp[19] * PI0[0][0][13] + sp[18] * PI1[0][0][13] + sp[18] * PI1[0][13][0] + sp[17] * PI2[0][0][13];
    A[14] = sp[19] * PI0[0][0][14] + sp[18] * PI1[0][0][14] + sp[18] * PI1[0][14][0] + sp[17] * PI2[0][0][14];
    A[15] = sp[19] * PI0[0][1][0] + sp[18] * PI1[0][1][0] + sp[18] * PI1[0][0][1] + sp[17] * PI2[0][1][0];
    A[16] = sp[19] * PI0[0][1][1] + sp[18] * PI1[0][1][1] + sp[18] * PI1[0][1][1] + sp[17] * PI2[0][1][1];
    A[17] = sp[19] * PI0[0][1][2] + sp[18] * PI1[0][1][2] + sp[18] * PI1[0][2][1] + sp[17] * PI2[0][1][2];
    A[18] = sp[19] * PI0[0][1][3] + sp[18] * PI1[0][1][3] + sp[18] * PI1[0][3][1] + sp[17] * PI2[0][1][3];
    A[19] = sp[19] * PI0[0][1][4] + sp[18] * PI1[0][1][4] + sp[18] * PI1[0][4][1] + sp[17] * PI2[0][1][4];
    A[20] = sp[19] * PI0[0][1][5] + sp[18] * PI1[0][1][5] + sp[18] * PI1[0][5][1] + sp[17] * PI2[0][1][5];
    A[21] = sp[19] * PI0[0][1][6] + sp[18] * PI1[0][1][6] + sp[18] * PI1[0][6][1] + sp[17] * PI2[0][1][6];
    A[22] = sp[19] * PI0[0][1][7] + sp[18] * PI1[0][1][7] + sp[18] * PI1[0][7][1] + sp[17] * PI2[0][1][7];
    A[23] = sp[19] * PI0[0][1][8] + sp[18] * PI1[0][1][8] + sp[18] * PI1[0][8][1] + sp[17] * PI2[0][1][8];
    A[24] = sp[19] * PI0[0][1][9] + sp[18] * PI1[0][1][9] + sp[18] * PI1[0][9][1] + sp[17] * PI2[0][1][9];
    A[25] = sp[19] * PI0[0][1][10] + sp[18] * PI1[0][1][10] + sp[18] * PI1[0][10][1] + sp[17] * PI2[0][1][10];
    A[26] = sp[19] * PI0[0][1][11] + sp[18] * PI1[0][1][11] + sp[18] * PI1[0][11][1] + sp[17] * PI2[0][1][11];
    A[27] = sp[19] * PI0[0][1][12] + sp[18] * PI1[0][1][12] + sp[18] * PI1[0][12][1] + sp[17] * PI2[0][1][12];
    A[28] = sp[19] * PI0[0][1][13] + sp[18] * PI1[0][1][13] + sp[18] * PI1[0][13][1] + sp[17] * PI2[0][1][13];
    A[29] = sp[19] * PI0[0][1][14] + sp[18] * PI1[0][1][14] + sp[18] * PI1[0][14][1] + sp[17] * PI2[0][1][14];
    A[30] = sp[19] * PI0[0][2][0] + sp[18] * PI1[0][2][0] + sp[18] * PI1[0][0][2] + sp[17] * PI2[0][2][0];
    A[31] = sp[19] * PI0[0][2][1] + sp[18] * PI1[0][2][1] + sp[18] * PI1[0][1][2] + sp[17] * PI2[0][2][1];
    A[32] = sp[19] * PI0[0][2][2] + sp[18] * PI1[0][2][2] + sp[18] * PI1[0][2][2] + sp[17] * PI2[0][2][2];
    A[33] = sp[19] * PI0[0][2][3] + sp[18] * PI1[0][2][3] + sp[18] * PI1[0][3][2] + sp[17] * PI2[0][2][3];
    A[34] = sp[19] * PI0[0][2][4] + sp[18] * PI1[0][2][4] + sp[18] * PI1[0][4][2] + sp[17] * PI2[0][2][4];
    A[35] = sp[19] * PI0[0][2][5] + sp[18] * PI1[0][2][5] + sp[18] * PI1[0][5][2] + sp[17] * PI2[0][2][5];
    A[36] = sp[19] * PI0[0][2][6] + sp[18] * PI1[0][2][6] + sp[18] * PI1[0][6][2] + sp[17] * PI2[0][2][6];
    A[37] = sp[19] * PI0[0][2][7] + sp[18] * PI1[0][2][7] + sp[18] * PI1[0][7][2] + sp[17] * PI2[0][2][7];
    A[38] = sp[19] * PI0[0][2][8] + sp[18] * PI1[0][2][8] + sp[18] * PI1[0][8][2] + sp[17] * PI2[0][2][8];
    A[39] = sp[19] * PI0[0][2][9] + sp[18] * PI1[0][2][9] + sp[18] * PI1[0][9][2] + sp[17] * PI2[0][2][9];
    A[40] = sp[19] * PI0[0][2][10] + sp[18] * PI1[0][2][10] + sp[18] * PI1[0][10][2] + sp[17] * PI2[0][2][10];
    A[41] = sp[19] * PI0[0][2][11] + sp[18] * PI1[0][2][11] + sp[18] * PI1[0][11][2] + sp[17] * PI2[0][2][11];
    A[42] = sp[19] * PI0[0][2][12] + sp[18] * PI1[0][2][12] + sp[18] * PI1[0][12][2] + sp[17] * PI2[0][2][12];
    A[43] = sp[19] * PI0[0][2][13] + sp[18] * PI1[0][2][13] + sp[18] * PI1[0][13][2] + sp[17] * PI2[0][2][13];
    A[44] = sp[19] * PI0[0][2][14] + sp[18] * PI1[0][2][14] + sp[18] * PI1[0][14][2] + sp[17] * PI2[0][2][14];
    A[45] = sp[19] * PI0[0][3][0] + sp[18] * PI1[0][3][0] + sp[18] * PI1[0][0][3] + sp[17] * PI2[0][3][0];
    A[46] = sp[19] * PI0[0][3][1] + sp[18] * PI1[0][3][1] + sp[18] * PI1[0][1][3] + sp[17] * PI2[0][3][1];
    A[47] = sp[19] * PI0[0][3][2] + sp[18] * PI1[0][3][2] + sp[18] * PI1[0][2][3] + sp[17] * PI2[0][3][2];
    A[48] = sp[19] * PI0[0][3][3] + sp[18] * PI1[0][3][3] + sp[18] * PI1[0][3][3] + sp[17] * PI2[0][3][3];
    A[49] = sp[19] * PI0[0][3][4] + sp[18] * PI1[0][3][4] + sp[18] * PI1[0][4][3] + sp[17] * PI2[0][3][4];
    A[50] = sp[19] * PI0[0][3][5] + sp[18] * PI1[0][3][5] + sp[18] * PI1[0][5][3] + sp[17] * PI2[0][3][5];
    A[51] = sp[19] * PI0[0][3][6] + sp[18] * PI1[0][3][6] + sp[18] * PI1[0][6][3] + sp[17] * PI2[0][3][6];
    A[52] = sp[19] * PI0[0][3][7] + sp[18] * PI1[0][3][7] + sp[18] * PI1[0][7][3] + sp[17] * PI2[0][3][7];
    A[53] = sp[19] * PI0[0][3][8] + sp[18] * PI1[0][3][8] + sp[18] * PI1[0][8][3] + sp[17] * PI2[0][3][8];
    A[54] = sp[19] * PI0[0][3][9] + sp[18] * PI1[0][3][9] + sp[18] * PI1[0][9][3] + sp[17] * PI2[0][3][9];
    A[55] = sp[19] * PI0[0][3][10] + sp[18] * PI1[0][3][10] + sp[18] * PI1[0][10][3] + sp[17] * PI2[0][3][10];
    A[56] = sp[19] * PI0[0][3][11] + sp[18] * PI1[0][3][11] + sp[18] * PI1[0][11][3] + sp[17] * PI2[0][3][11];
    A[57] = sp[19] * PI0[0][3][12] + sp[18] * PI1[0][3][12] + sp[18] * PI1[0][12][3] + sp[17] * PI2[0][3][12];
    A[58] = sp[19] * PI0[0][3][13] + sp[18] * PI1[0][3][13] + sp[18] * PI1[0][13][3] + sp[17] * PI2[0][3][13];
    A[59] = sp[19] * PI0[0][3][14] + sp[18] * PI1[0][3][14] + sp[18] * PI1[0][14][3] + sp[17] * PI2[0][3][14];
    A[60] = sp[19] * PI0[0][4][0] + sp[18] * PI1[0][4][0] + sp[18] * PI1[0][0][4] + sp[17] * PI2[0][4][0];
    A[61] = sp[19] * PI0[0][4][1] + sp[18] * PI1[0][4][1] + sp[18] * PI1[0][1][4] + sp[17] * PI2[0][4][1];
    A[62] = sp[19] * PI0[0][4][2] + sp[18] * PI1[0][4][2] + sp[18] * PI1[0][2][4] + sp[17] * PI2[0][4][2];
    A[63] = sp[19] * PI0[0][4][3] + sp[18] * PI1[0][4][3] + sp[18] * PI1[0][3][4] + sp[17] * PI2[0][4][3];
    A[64] = sp[19] * PI0[0][4][4] + sp[18] * PI1[0][4][4] + sp[18] * PI1[0][4][4] + sp[17] * PI2[0][4][4];
    A[65] = sp[19] * PI0[0][4][5] + sp[18] * PI1[0][4][5] + sp[18] * PI1[0][5][4] + sp[17] * PI2[0][4][5];
    A[66] = sp[19] * PI0[0][4][6] + sp[18] * PI1[0][4][6] + sp[18] * PI1[0][6][4] + sp[17] * PI2[0][4][6];
    A[67] = sp[19] * PI0[0][4][7] + sp[18] * PI1[0][4][7] + sp[18] * PI1[0][7][4] + sp[17] * PI2[0][4][7];
    A[68] = sp[19] * PI0[0][4][8] + sp[18] * PI1[0][4][8] + sp[18] * PI1[0][8][4] + sp[17] * PI2[0][4][8];
    A[69] = sp[19] * PI0[0][4][9] + sp[18] * PI1[0][4][9] + sp[18] * PI1[0][9][4] + sp[17] * PI2[0][4][9];
    A[70] = sp[19] * PI0[0][4][10] + sp[18] * PI1[0][4][10] + sp[18] * PI1[0][10][4] + sp[17] * PI2[0][4][10];
    A[71] = sp[19] * PI0[0][4][11] + sp[18] * PI1[0][4][11] + sp[18] * PI1[0][11][4] + sp[17] * PI2[0][4][11];
    A[72] = sp[19] * PI0[0][4][12] + sp[18] * PI1[0][4][12] + sp[18] * PI1[0][12][4] + sp[17] * PI2[0][4][12];
    A[73] = sp[19] * PI0[0][4][13] + sp[18] * PI1[0][4][13] + sp[18] * PI1[0][13][4] + sp[17] * PI2[0][4][13];
    A[74] = sp[19] * PI0[0][4][14] + sp[18] * PI1[0][4][14] + sp[18] * PI1[0][14][4] + sp[17] * PI2[0][4][14];
    A[75] = sp[19] * PI0[0][5][0] + sp[18] * PI1[0][5][0] + sp[18] * PI1[0][0][5] + sp[17] * PI2[0][5][0];
    A[76] = sp[19] * PI0[0][5][1] + sp[18] * PI1[0][5][1] + sp[18] * PI1[0][1][5] + sp[17] * PI2[0][5][1];
    A[77] = sp[19] * PI0[0][5][2] + sp[18] * PI1[0][5][2] + sp[18] * PI1[0][2][5] + sp[17] * PI2[0][5][2];
    A[78] = sp[19] * PI0[0][5][3] + sp[18] * PI1[0][5][3] + sp[18] * PI1[0][3][5] + sp[17] * PI2[0][5][3];
    A[79] = sp[19] * PI0[0][5][4] + sp[18] * PI1[0][5][4] + sp[18] * PI1[0][4][5] + sp[17] * PI2[0][5][4];
    A[80] = sp[19] * PI0[0][5][5] + sp[18] * PI1[0][5][5] + sp[18] * PI1[0][5][5] + sp[17] * PI2[0][5][5];
    A[81] = sp[19] * PI0[0][5][6] + sp[18] * PI1[0][5][6] + sp[18] * PI1[0][6][5] + sp[17] * PI2[0][5][6];
    A[82] = sp[19] * PI0[0][5][7] + sp[18] * PI1[0][5][7] + sp[18] * PI1[0][7][5] + sp[17] * PI2[0][5][7];
    A[83] = sp[19] * PI0[0][5][8] + sp[18] * PI1[0][5][8] + sp[18] * PI1[0][8][5] + sp[17] * PI2[0][5][8];
    A[84] = sp[19] * PI0[0][5][9] + sp[18] * PI1[0][5][9] + sp[18] * PI1[0][9][5] + sp[17] * PI2[0][5][9];
    A[85] = sp[19] * PI0[0][5][10] + sp[18] * PI1[0][5][10] + sp[18] * PI1[0][10][5] + sp[17] * PI2[0][5][10];
    A[86] = sp[19] * PI0[0][5][11] + sp[18] * PI1[0][5][11] + sp[18] * PI1[0][11][5] + sp[17] * PI2[0][5][11];
    A[87] = sp[19] * PI0[0][5][12] + sp[18] * PI1[0][5][12] + sp[18] * PI1[0][12][5] + sp[17] * PI2[0][5][12];
    A[88] = sp[19] * PI0[0][5][13] + sp[18] * PI1[0][5][13] + sp[18] * PI1[0][13][5] + sp[17] * PI2[0][5][13];
    A[89] = sp[19] * PI0[0][5][14] + sp[18] * PI1[0][5][14] + sp[18] * PI1[0][14][5] + sp[17] * PI2[0][5][14];
    A[90] = sp[19] * PI0[0][6][0] + sp[18] * PI1[0][6][0] + sp[18] * PI1[0][0][6] + sp[17] * PI2[0][6][0];
    A[91] = sp[19] * PI0[0][6][1] + sp[18] * PI1[0][6][1] + sp[18] * PI1[0][1][6] + sp[17] * PI2[0][6][1];
    A[92] = sp[19] * PI0[0][6][2] + sp[18] * PI1[0][6][2] + sp[18] * PI1[0][2][6] + sp[17] * PI2[0][6][2];
    A[93] = sp[19] * PI0[0][6][3] + sp[18] * PI1[0][6][3] + sp[18] * PI1[0][3][6] + sp[17] * PI2[0][6][3];
    A[94] = sp[19] * PI0[0][6][4] + sp[18] * PI1[0][6][4] + sp[18] * PI1[0][4][6] + sp[17] * PI2[0][6][4];
    A[95] = sp[19] * PI0[0][6][5] + sp[18] * PI1[0][6][5] + sp[18] * PI1[0][5][6] + sp[17] * PI2[0][6][5];
    A[96] = sp[19] * PI0[0][6][6] + sp[18] * PI1[0][6][6] + sp[18] * PI1[0][6][6] + sp[17] * PI2[0][6][6];
    A[97] = sp[19] * PI0[0][6][7] + sp[18] * PI1[0][6][7] + sp[18] * PI1[0][7][6] + sp[17] * PI2[0][6][7];
    A[98] = sp[19] * PI0[0][6][8] + sp[18] * PI1[0][6][8] + sp[18] * PI1[0][8][6] + sp[17] * PI2[0][6][8];
    A[99] = sp[19] * PI0[0][6][9] + sp[18] * PI1[0][6][9] + sp[18] * PI1[0][9][6] + sp[17] * PI2[0][6][9];
    A[100] = sp[19] * PI0[0][6][10] + sp[18] * PI1[0][6][10] + sp[18] * PI1[0][10][6] + sp[17] * PI2[0][6][10];
    A[101] = sp[19] * PI0[0][6][11] + sp[18] * PI1[0][6][11] + sp[18] * PI1[0][11][6] + sp[17] * PI2[0][6][11];
    A[102] = sp[19] * PI0[0][6][12] + sp[18] * PI1[0][6][12] + sp[18] * PI1[0][12][6] + sp[17] * PI2[0][6][12];
    A[103] = sp[19] * PI0[0][6][13] + sp[18] * PI1[0][6][13] + sp[18] * PI1[0][13][6] + sp[17] * PI2[0][6][13];
    A[104] = sp[19] * PI0[0][6][14] + sp[18] * PI1[0][6][14] + sp[18] * PI1[0][14][6] + sp[17] * PI2[0][6][14];
    A[105] = sp[19] * PI0[0][7][0] + sp[18] * PI1[0][7][0] + sp[18] * PI1[0][0][7] + sp[17] * PI2[0][7][0];
    A[106] = sp[19] * PI0[0][7][1] + sp[18] * PI1[0][7][1] + sp[18] * PI1[0][1][7] + sp[17] * PI2[0][7][1];
    A[107] = sp[19] * PI0[0][7][2] + sp[18] * PI1[0][7][2] + sp[18] * PI1[0][2][7] + sp[17] * PI2[0][7][2];
    A[108] = sp[19] * PI0[0][7][3] + sp[18] * PI1[0][7][3] + sp[18] * PI1[0][3][7] + sp[17] * PI2[0][7][3];
    A[109] = sp[19] * PI0[0][7][4] + sp[18] * PI1[0][7][4] + sp[18] * PI1[0][4][7] + sp[17] * PI2[0][7][4];
    A[110] = sp[19] * PI0[0][7][5] + sp[18] * PI1[0][7][5] + sp[18] * PI1[0][5][7] + sp[17] * PI2[0][7][5];
    A[111] = sp[19] * PI0[0][7][6] + sp[18] * PI1[0][7][6] + sp[18] * PI1[0][6][7] + sp[17] * PI2[0][7][6];
    A[112] = sp[19] * PI0[0][7][7] + sp[18] * PI1[0][7][7] + sp[18] * PI1[0][7][7] + sp[17] * PI2[0][7][7];
    A[113] = sp[19] * PI0[0][7][8] + sp[18] * PI1[0][7][8] + sp[18] * PI1[0][8][7] + sp[17] * PI2[0][7][8];
    A[114] = sp[19] * PI0[0][7][9] + sp[18] * PI1[0][7][9] + sp[18] * PI1[0][9][7] + sp[17] * PI2[0][7][9];
    A[115] = sp[19] * PI0[0][7][10] + sp[18] * PI1[0][7][10] + sp[18] * PI1[0][10][7] + sp[17] * PI2[0][7][10];
    A[116] = sp[19] * PI0[0][7][11] + sp[18] * PI1[0][7][11] + sp[18] * PI1[0][11][7] + sp[17] * PI2[0][7][11];
    A[117] = sp[19] * PI0[0][7][12] + sp[18] * PI1[0][7][12] + sp[18] * PI1[0][12][7] + sp[17] * PI2[0][7][12];
    A[118] = sp[19] * PI0[0][7][13] + sp[18] * PI1[0][7][13] + sp[18] * PI1[0][13][7] + sp[17] * PI2[0][7][13];
    A[119] = sp[19] * PI0[0][7][14] + sp[18] * PI1[0][7][14] + sp[18] * PI1[0][14][7] + sp[17] * PI2[0][7][14];
    A[120] = sp[19] * PI0[0][8][0] + sp[18] * PI1[0][8][0] + sp[18] * PI1[0][0][8] + sp[17] * PI2[0][8][0];
    A[121] = sp[19] * PI0[0][8][1] + sp[18] * PI1[0][8][1] + sp[18] * PI1[0][1][8] + sp[17] * PI2[0][8][1];
    A[122] = sp[19] * PI0[0][8][2] + sp[18] * PI1[0][8][2] + sp[18] * PI1[0][2][8] + sp[17] * PI2[0][8][2];
    A[123] = sp[19] * PI0[0][8][3] + sp[18] * PI1[0][8][3] + sp[18] * PI1[0][3][8] + sp[17] * PI2[0][8][3];
    A[124] = sp[19] * PI0[0][8][4] + sp[18] * PI1[0][8][4] + sp[18] * PI1[0][4][8] + sp[17] * PI2[0][8][4];
    A[125] = sp[19] * PI0[0][8][5] + sp[18] * PI1[0][8][5] + sp[18] * PI1[0][5][8] + sp[17] * PI2[0][8][5];
    A[126] = sp[19] * PI0[0][8][6] + sp[18] * PI1[0][8][6] + sp[18] * PI1[0][6][8] + sp[17] * PI2[0][8][6];
    A[127] = sp[19] * PI0[0][8][7] + sp[18] * PI1[0][8][7] + sp[18] * PI1[0][7][8] + sp[17] * PI2[0][8][7];
    A[128] = sp[19] * PI0[0][8][8] + sp[18] * PI1[0][8][8] + sp[18] * PI1[0][8][8] + sp[17] * PI2[0][8][8];
    A[129] = sp[19] * PI0[0][8][9] + sp[18] * PI1[0][8][9] + sp[18] * PI1[0][9][8] + sp[17] * PI2[0][8][9];
    A[130] = sp[19] * PI0[0][8][10] + sp[18] * PI1[0][8][10] + sp[18] * PI1[0][10][8] + sp[17] * PI2[0][8][10];
    A[131] = sp[19] * PI0[0][8][11] + sp[18] * PI1[0][8][11] + sp[18] * PI1[0][11][8] + sp[17] * PI2[0][8][11];
    A[132] = sp[19] * PI0[0][8][12] + sp[18] * PI1[0][8][12] + sp[18] * PI1[0][12][8] + sp[17] * PI2[0][8][12];
    A[133] = sp[19] * PI0[0][8][13] + sp[18] * PI1[0][8][13] + sp[18] * PI1[0][13][8] + sp[17] * PI2[0][8][13];
    A[134] = sp[19] * PI0[0][8][14] + sp[18] * PI1[0][8][14] + sp[18] * PI1[0][14][8] + sp[17] * PI2[0][8][14];
    A[135] = sp[19] * PI0[0][9][0] + sp[18] * PI1[0][9][0] + sp[18] * PI1[0][0][9] + sp[17] * PI2[0][9][0];
    A[136] = sp[19] * PI0[0][9][1] + sp[18] * PI1[0][9][1] + sp[18] * PI1[0][1][9] + sp[17] * PI2[0][9][1];
    A[137] = sp[19] * PI0[0][9][2] + sp[18] * PI1[0][9][2] + sp[18] * PI1[0][2][9] + sp[17] * PI2[0][9][2];
    A[138] = sp[19] * PI0[0][9][3] + sp[18] * PI1[0][9][3] + sp[18] * PI1[0][3][9] + sp[17] * PI2[0][9][3];
    A[139] = sp[19] * PI0[0][9][4] + sp[18] * PI1[0][9][4] + sp[18] * PI1[0][4][9] + sp[17] * PI2[0][9][4];
    A[140] = sp[19] * PI0[0][9][5] + sp[18] * PI1[0][9][5] + sp[18] * PI1[0][5][9] + sp[17] * PI2[0][9][5];
    A[141] = sp[19] * PI0[0][9][6] + sp[18] * PI1[0][9][6] + sp[18] * PI1[0][6][9] + sp[17] * PI2[0][9][6];
    A[142] = sp[19] * PI0[0][9][7] + sp[18] * PI1[0][9][7] + sp[18] * PI1[0][7][9] + sp[17] * PI2[0][9][7];
    A[143] = sp[19] * PI0[0][9][8] + sp[18] * PI1[0][9][8] + sp[18] * PI1[0][8][9] + sp[17] * PI2[0][9][8];
    A[144] = sp[19] * PI0[0][9][9] + sp[18] * PI1[0][9][9] + sp[18] * PI1[0][9][9] + sp[17] * PI2[0][9][9];
    A[145] = sp[19] * PI0[0][9][10] + sp[18] * PI1[0][9][10] + sp[18] * PI1[0][10][9] + sp[17] * PI2[0][9][10];
    A[146] = sp[19] * PI0[0][9][11] + sp[18] * PI1[0][9][11] + sp[18] * PI1[0][11][9] + sp[17] * PI2[0][9][11];
    A[147] = sp[19] * PI0[0][9][12] + sp[18] * PI1[0][9][12] + sp[18] * PI1[0][12][9] + sp[17] * PI2[0][9][12];
    A[148] = sp[19] * PI0[0][9][13] + sp[18] * PI1[0][9][13] + sp[18] * PI1[0][13][9] + sp[17] * PI2[0][9][13];
    A[149] = sp[19] * PI0[0][9][14] + sp[18] * PI1[0][9][14] + sp[18] * PI1[0][14][9] + sp[17] * PI2[0][9][14];
    A[150] = sp[19] * PI0[0][10][0] + sp[18] * PI1[0][10][0] + sp[18] * PI1[0][0][10] + sp[17] * PI2[0][10][0];
    A[151] = sp[19] * PI0[0][10][1] + sp[18] * PI1[0][10][1] + sp[18] * PI1[0][1][10] + sp[17] * PI2[0][10][1];
    A[152] = sp[19] * PI0[0][10][2] + sp[18] * PI1[0][10][2] + sp[18] * PI1[0][2][10] + sp[17] * PI2[0][10][2];
    A[153] = sp[19] * PI0[0][10][3] + sp[18] * PI1[0][10][3] + sp[18] * PI1[0][3][10] + sp[17] * PI2[0][10][3];
    A[154] = sp[19] * PI0[0][10][4] + sp[18] * PI1[0][10][4] + sp[18] * PI1[0][4][10] + sp[17] * PI2[0][10][4];
    A[155] = sp[19] * PI0[0][10][5] + sp[18] * PI1[0][10][5] + sp[18] * PI1[0][5][10] + sp[17] * PI2[0][10][5];
    A[156] = sp[19] * PI0[0][10][6] + sp[18] * PI1[0][10][6] + sp[18] * PI1[0][6][10] + sp[17] * PI2[0][10][6];
    A[157] = sp[19] * PI0[0][10][7] + sp[18] * PI1[0][10][7] + sp[18] * PI1[0][7][10] + sp[17] * PI2[0][10][7];
    A[158] = sp[19] * PI0[0][10][8] + sp[18] * PI1[0][10][8] + sp[18] * PI1[0][8][10] + sp[17] * PI2[0][10][8];
    A[159] = sp[19] * PI0[0][10][9] + sp[18] * PI1[0][10][9] + sp[18] * PI1[0][9][10] + sp[17] * PI2[0][10][9];
    A[160] = sp[19] * PI0[0][10][10] + sp[18] * PI1[0][10][10] + sp[18] * PI1[0][10][10] + sp[17] * PI2[0][10][10];
    A[161] = sp[19] * PI0[0][10][11] + sp[18] * PI1[0][10][11] + sp[18] * PI1[0][11][10] + sp[17] * PI2[0][10][11];
    A[162] = sp[19] * PI0[0][10][12] + sp[18] * PI1[0][10][12] + sp[18] * PI1[0][12][10] + sp[17] * PI2[0][10][12];
    A[163] = sp[19] * PI0[0][10][13] + sp[18] * PI1[0][10][13] + sp[18] * PI1[0][13][10] + sp[17] * PI2[0][10][13];
    A[164] = sp[19] * PI0[0][10][14] + sp[18] * PI1[0][10][14] + sp[18] * PI1[0][14][10] + sp[17] * PI2[0][10][14];
    A[165] = sp[19] * PI0[0][11][0] + sp[18] * PI1[0][11][0] + sp[18] * PI1[0][0][11] + sp[17] * PI2[0][11][0];
    A[166] = sp[19] * PI0[0][11][1] + sp[18] * PI1[0][11][1] + sp[18] * PI1[0][1][11] + sp[17] * PI2[0][11][1];
    A[167] = sp[19] * PI0[0][11][2] + sp[18] * PI1[0][11][2] + sp[18] * PI1[0][2][11] + sp[17] * PI2[0][11][2];
    A[168] = sp[19] * PI0[0][11][3] + sp[18] * PI1[0][11][3] + sp[18] * PI1[0][3][11] + sp[17] * PI2[0][11][3];
    A[169] = sp[19] * PI0[0][11][4] + sp[18] * PI1[0][11][4] + sp[18] * PI1[0][4][11] + sp[17] * PI2[0][11][4];
    A[170] = sp[19] * PI0[0][11][5] + sp[18] * PI1[0][11][5] + sp[18] * PI1[0][5][11] + sp[17] * PI2[0][11][5];
    A[171] = sp[19] * PI0[0][11][6] + sp[18] * PI1[0][11][6] + sp[18] * PI1[0][6][11] + sp[17] * PI2[0][11][6];
    A[172] = sp[19] * PI0[0][11][7] + sp[18] * PI1[0][11][7] + sp[18] * PI1[0][7][11] + sp[17] * PI2[0][11][7];
    A[173] = sp[19] * PI0[0][11][8] + sp[18] * PI1[0][11][8] + sp[18] * PI1[0][8][11] + sp[17] * PI2[0][11][8];
    A[174] = sp[19] * PI0[0][11][9] + sp[18] * PI1[0][11][9] + sp[18] * PI1[0][9][11] + sp[17] * PI2[0][11][9];
    A[175] = sp[19] * PI0[0][11][10] + sp[18] * PI1[0][11][10] + sp[18] * PI1[0][10][11] + sp[17] * PI2[0][11][10];
    A[176] = sp[19] * PI0[0][11][11] + sp[18] * PI1[0][11][11] + sp[18] * PI1[0][11][11] + sp[17] * PI2[0][11][11];
    A[177] = sp[19] * PI0[0][11][12] + sp[18] * PI1[0][11][12] + sp[18] * PI1[0][12][11] + sp[17] * PI2[0][11][12];
    A[178] = sp[19] * PI0[0][11][13] + sp[18] * PI1[0][11][13] + sp[18] * PI1[0][13][11] + sp[17] * PI2[0][11][13];
    A[179] = sp[19] * PI0[0][11][14] + sp[18] * PI1[0][11][14] + sp[18] * PI1[0][14][11] + sp[17] * PI2[0][11][14];
    A[180] = sp[19] * PI0[0][12][0] + sp[18] * PI1[0][12][0] + sp[18] * PI1[0][0][12] + sp[17] * PI2[0][12][0];
    A[181] = sp[19] * PI0[0][12][1] + sp[18] * PI1[0][12][1] + sp[18] * PI1[0][1][12] + sp[17] * PI2[0][12][1];
    A[182] = sp[19] * PI0[0][12][2] + sp[18] * PI1[0][12][2] + sp[18] * PI1[0][2][12] + sp[17] * PI2[0][12][2];
    A[183] = sp[19] * PI0[0][12][3] + sp[18] * PI1[0][12][3] + sp[18] * PI1[0][3][12] + sp[17] * PI2[0][12][3];
    A[184] = sp[19] * PI0[0][12][4] + sp[18] * PI1[0][12][4] + sp[18] * PI1[0][4][12] + sp[17] * PI2[0][12][4];
    A[185] = sp[19] * PI0[0][12][5] + sp[18] * PI1[0][12][5] + sp[18] * PI1[0][5][12] + sp[17] * PI2[0][12][5];
    A[186] = sp[19] * PI0[0][12][6] + sp[18] * PI1[0][12][6] + sp[18] * PI1[0][6][12] + sp[17] * PI2[0][12][6];
    A[187] = sp[19] * PI0[0][12][7] + sp[18] * PI1[0][12][7] + sp[18] * PI1[0][7][12] + sp[17] * PI2[0][12][7];
    A[188] = sp[19] * PI0[0][12][8] + sp[18] * PI1[0][12][8] + sp[18] * PI1[0][8][12] + sp[17] * PI2[0][12][8];
    A[189] = sp[19] * PI0[0][12][9] + sp[18] * PI1[0][12][9] + sp[18] * PI1[0][9][12] + sp[17] * PI2[0][12][9];
    A[190] = sp[19] * PI0[0][12][10] + sp[18] * PI1[0][12][10] + sp[18] * PI1[0][10][12] + sp[17] * PI2[0][12][10];
    A[191] = sp[19] * PI0[0][12][11] + sp[18] * PI1[0][12][11] + sp[18] * PI1[0][11][12] + sp[17] * PI2[0][12][11];
    A[192] = sp[19] * PI0[0][12][12] + sp[18] * PI1[0][12][12] + sp[18] * PI1[0][12][12] + sp[17] * PI2[0][12][12];
    A[193] = sp[19] * PI0[0][12][13] + sp[18] * PI1[0][12][13] + sp[18] * PI1[0][13][12] + sp[17] * PI2[0][12][13];
    A[194] = sp[19] * PI0[0][12][14] + sp[18] * PI1[0][12][14] + sp[18] * PI1[0][14][12] + sp[17] * PI2[0][12][14];
    A[195] = sp[19] * PI0[0][13][0] + sp[18] * PI1[0][13][0] + sp[18] * PI1[0][0][13] + sp[17] * PI2[0][13][0];
    A[196] = sp[19] * PI0[0][13][1] + sp[18] * PI1[0][13][1] + sp[18] * PI1[0][1][13] + sp[17] * PI2[0][13][1];
    A[197] = sp[19] * PI0[0][13][2] + sp[18] * PI1[0][13][2] + sp[18] * PI1[0][2][13] + sp[17] * PI2[0][13][2];
    A[198] = sp[19] * PI0[0][13][3] + sp[18] * PI1[0][13][3] + sp[18] * PI1[0][3][13] + sp[17] * PI2[0][13][3];
    A[199] = sp[19] * PI0[0][13][4] + sp[18] * PI1[0][13][4] + sp[18] * PI1[0][4][13] + sp[17] * PI2[0][13][4];
    A[200] = sp[19] * PI0[0][13][5] + sp[18] * PI1[0][13][5] + sp[18] * PI1[0][5][13] + sp[17] * PI2[0][13][5];
    A[201] = sp[19] * PI0[0][13][6] + sp[18] * PI1[0][13][6] + sp[18] * PI1[0][6][13] + sp[17] * PI2[0][13][6];
    A[202] = sp[19] * PI0[0][13][7] + sp[18] * PI1[0][13][7] + sp[18] * PI1[0][7][13] + sp[17] * PI2[0][13][7];
    A[203] = sp[19] * PI0[0][13][8] + sp[18] * PI1[0][13][8] + sp[18] * PI1[0][8][13] + sp[17] * PI2[0][13][8];
    A[204] = sp[19] * PI0[0][13][9] + sp[18] * PI1[0][13][9] + sp[18] * PI1[0][9][13] + sp[17] * PI2[0][13][9];
    A[205] = sp[19] * PI0[0][13][10] + sp[18] * PI1[0][13][10] + sp[18] * PI1[0][10][13] + sp[17] * PI2[0][13][10];
    A[206] = sp[19] * PI0[0][13][11] + sp[18] * PI1[0][13][11] + sp[18] * PI1[0][11][13] + sp[17] * PI2[0][13][11];
    A[207] = sp[19] * PI0[0][13][12] + sp[18] * PI1[0][13][12] + sp[18] * PI1[0][12][13] + sp[17] * PI2[0][13][12];
    A[208] = sp[19] * PI0[0][13][13] + sp[18] * PI1[0][13][13] + sp[18] * PI1[0][13][13] + sp[17] * PI2[0][13][13];
    A[209] = sp[19] * PI0[0][13][14] + sp[18] * PI1[0][13][14] + sp[18] * PI1[0][14][13] + sp[17] * PI2[0][13][14];
    A[210] = sp[19] * PI0[0][14][0] + sp[18] * PI1[0][14][0] + sp[18] * PI1[0][0][14] + sp[17] * PI2[0][14][0];
    A[211] = sp[19] * PI0[0][14][1] + sp[18] * PI1[0][14][1] + sp[18] * PI1[0][1][14] + sp[17] * PI2[0][14][1];
    A[212] = sp[19] * PI0[0][14][2] + sp[18] * PI1[0][14][2] + sp[18] * PI1[0][2][14] + sp[17] * PI2[0][14][2];
    A[213] = sp[19] * PI0[0][14][3] + sp[18] * PI1[0][14][3] + sp[18] * PI1[0][3][14] + sp[17] * PI2[0][14][3];
    A[214] = sp[19] * PI0[0][14][4] + sp[18] * PI1[0][14][4] + sp[18] * PI1[0][4][14] + sp[17] * PI2[0][14][4];
    A[215] = sp[19] * PI0[0][14][5] + sp[18] * PI1[0][14][5] + sp[18] * PI1[0][5][14] + sp[17] * PI2[0][14][5];
    A[216] = sp[19] * PI0[0][14][6] + sp[18] * PI1[0][14][6] + sp[18] * PI1[0][6][14] + sp[17] * PI2[0][14][6];
    A[217] = sp[19] * PI0[0][14][7] + sp[18] * PI1[0][14][7] + sp[18] * PI1[0][7][14] + sp[17] * PI2[0][14][7];
    A[218] = sp[19] * PI0[0][14][8] + sp[18] * PI1[0][14][8] + sp[18] * PI1[0][8][14] + sp[17] * PI2[0][14][8];
    A[219] = sp[19] * PI0[0][14][9] + sp[18] * PI1[0][14][9] + sp[18] * PI1[0][9][14] + sp[17] * PI2[0][14][9];
    A[220] = sp[19] * PI0[0][14][10] + sp[18] * PI1[0][14][10] + sp[18] * PI1[0][10][14] + sp[17] * PI2[0][14][10];
    A[221] = sp[19] * PI0[0][14][11] + sp[18] * PI1[0][14][11] + sp[18] * PI1[0][11][14] + sp[17] * PI2[0][14][11];
    A[222] = sp[19] * PI0[0][14][12] + sp[18] * PI1[0][14][12] + sp[18] * PI1[0][12][14] + sp[17] * PI2[0][14][12];
    A[223] = sp[19] * PI0[0][14][13] + sp[18] * PI1[0][14][13] + sp[18] * PI1[0][13][14] + sp[17] * PI2[0][14][13];
    A[224] = sp[19] * PI0[0][14][14] + sp[18] * PI1[0][14][14] + sp[18] * PI1[0][14][14] + sp[17] * PI2[0][14][14];
  }

};


class forms_form_0: public ufc::form
{
public:

  forms_form_0() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "1c9f2722f2f6220661ca872251535a0591b94c8bf328e636d07baddfb70002626dc60b51378046bd622a1ea5d06be457784b36454f010c37a5c3c72c337bbb9b";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_0_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};


class forms_form_1: public ufc::form
{
public:

  forms_form_1() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "499f292275f354a5c9ba500a5876308055354915a275bd6c468b66ad436ed8f88d82e4d026ada849298959a57aac31fb643a3ed042a61a0d6e7be8c17e801392";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_1_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};

// DOLFIN wrappers

// Standard library includes
#include <string>

// DOLFIN includes
#include <dolfin/common/NoDeleter.h>
#include <dolfin/mesh/Mesh.h>
#include <dolfin/mesh/MultiMesh.h>
#include <dolfin/fem/FiniteElement.h>
#include <dolfin/fem/DofMap.h>
#include <dolfin/fem/Form.h>
#include <dolfin/fem/MultiMeshForm.h>
#include <dolfin/function/FunctionSpace.h>
#include <dolfin/function/MultiMeshFunctionSpace.h>
#include <dolfin/function/GenericFunction.h>
#include <dolfin/function/CoefficientAssigner.h>
#include <dolfin/function/MultiMeshCoefficientAssigner.h>
#include <dolfin/adaptivity/ErrorControl.h>
#include <dolfin/adaptivity/GoalFunctional.h>
#include <dolfin/la/GenericVector.h>

namespace Forms
{

class Form_a_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a: public dolfin::Form
{
public:

  // Constructor
  Form_a(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_0>();
  }

  // Destructor
  ~Form_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_a: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_a(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_a(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class Form_L_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L: public dolfin::Form
{
public:

  // Constructor
  Form_L(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_1>();
  }

  // Destructor
  ~Form_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_L: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_L(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_L(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

// Class typedefs
typedef Form_a::TestSpace FunctionSpace;
typedef Form_a::MultiMeshTestSpace MultiMeshFunctionSpace;

}

#endif
